// WAR_CONTROLEVENT.JS
//
// Author:	Poundboy
// Version:	2.08
//
//
// Modification History:
//
// Who	  Date	    Version	Description
//
// PB	  09/03/03  2.05	Initial version.
//
//
// Description:
//
//	The following file contains all the event function OnControlEvent which
//	handles all the Decal control panel generated events
//

// Handler function for the OnControl event.
function MainHandlers_OnControlEvent(szPanel, szControl, dictSzValue) {
    if (debugEvent||debugCmds) Log.OutD("Main_OnControlEvent: Begin, Panel [" + szPanel + "] Control [" + szControl + "]");

    if (szPanel == szPanelControl) {
   	// Process Control Panel Controls
	switch (szControl) {

	    // C1 tab **********************************************

	    case "btnPause":
		szCurCap = dictSzValue("btnPause");
		if (szCurCap == "Pause") {
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Pause request detected.  Pausing macro...");
		    Chat.Screen("Pausing macro...");
		    MacroPaused = true;
		    skapi.SetControlProperty(szPanelControl, "btnPause", "Text", "Resume");
		} else {
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Resume request detected.  Resuming macro...");
		    Chat.Screen("Resuming macro...");
		    MacroPaused = false;
		    skapi.SetControlProperty(szPanelControl, "btnPause", "Text", "Pause");
		} // endif
 	        break;

	    case "btnAttackMode":
		szCurCap = dictSzValue("btnAttackMode");
		if (szCurCap == "Disable Attack") {
		    Chat.Screen("Defend only mode enabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Defend mode enabled");
		    AttackMode = false;
		    skapi.SetControlProperty(szPanelControl, "btnAttackMode", "Text", "Enable Attack");
		} else {
		    Chat.Screen("Attacking enabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Attacking enabled.");
		    AttackMode = true;
		    skapi.SetControlProperty(szPanelControl, "btnAttackMode", "Text", "Disable Attack");
		} // endif
 	        break;

	    case "btnStealth":
		szCurCap = dictSzValue("btnStealth");
		if (szCurCap == "Disable Stealth") {
		    Chat.Screen("WARNING!!! Stealth mode disabled!", cmcYellow);
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Stealth mode disabled");
		    Stealth = false;
		    skapi.SetControlProperty(szPanelControl, "btnStealth", "Text", "Enable Stealth");
		} else {
		    Chat.Screen("Stealth mode enabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Stealth mode enabled");
		    Stealth = true;
		    skapi.SetControlProperty(szPanelControl, "btnStealth", "Text", "Disable Stealth");
		} // endif
 	        break;

	    case "btnAutoMove":
		szCurCap = dictSzValue("btnAutoMove");
		if (szCurCap == "Disable AutoMove") {
		    Chat.Screen("WARNING!!! AutoMove disabled!");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: AutoMove disabled");
		    AutoMove = false;
		    skapi.SetControlProperty(szPanelControl, "btnAutoMove", "Text", "Enable AutoMove");
		} else {
		    Chat.Screen("AutoMove enabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: AutoMove enabled");
		    AutoMove = true;
		    skapi.SetControlProperty(szPanelControl, "btnAutoMove", "Text", "Disable AutoMove");
		} // endif
 	        break;

 	    case "btnExclusion":
 	    	szCurCap = dictSzValue("btnExclusion");
		if (szCurCap == "Disable ExclMode") {
		    Chat.Screen("Exclusion mode disabled.")
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Exclusion mode disabled");
		    ExclMode = false;
		    skapi.SetControlProperty(szPanelControl, "btnExclusion", "Text", "Enable ExclMode");
		} else {
		    Chat.Screen("Exclusion mode enabled.")
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Exclusion mode enabled");
		    ExclMode = true;
		    skapi.SetControlProperty(szPanelControl, "btnExclusion", "Text", "Disable ExclMode");
		} // endif
 	        break;

	    case "btnSafeMode":
		szCurCap = dictSzValue("btnSafeMode");
		if (szCurCap == "Disable SafeMode") {
		    Chat.Screen("WARNING!!! SafeMode mode disabled!");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: SafeMode mode disabled");
		    SafeMode = false;
		    skapi.SetControlProperty(szPanelControl, "btnSafeMode", "Text", "Enable SafeMode");
		} else {
		    Chat.Screen("SafeMode mode enabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: SafeMode mode enabled");
		    SafeMode = true;
		    skapi.SetControlProperty(szPanelControl, "btnSafeMode", "Text", "Disable SafeMode");
		} // endif
 	        break;

	    case "btnPeaceMode":
		szCurCap = dictSzValue("btnPeaceMode");
		if (szCurCap == "Disable PeaceMode") {
		    Chat.Screen("Peace mode disabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Peace mode disabled");
		    PeaceMode = false;
		    skapi.SetControlProperty(szPanelControl, "btnPeaceMode", "Text", "Enable PeaceMode");
		    if (!flagIgnoreAtt) {
			skapi.AddHandler( evidOnMeleeDamageSelf,	MainH );
			skapi.AddHandler( evidOnMeleeEvadeSelf,		MainH );
			skapi.AddHandler( evidOnMeleeLastAttacker,	MainH );
		    } // endif
		} else {
		    Chat.Screen("WARNING!!! Peace mode enabled!", cmcYellow);
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Peace mode enabled");
		    PeaceMode = true;
		    skapi.SetControlProperty(szPanelControl, "btnPeaceMode", "Text", "Disable PeaceMode");
		    if (!flagIgnoreAtt) {
			skapi.RemoveHandler( evidOnMeleeDamageSelf,	MainH );
			skapi.RemoveHandler( evidOnMeleeEvadeSelf,	MainH );
			skapi.RemoveHandler( evidOnMeleeLastAttacker, 	MainH );
		    } // endif
		} // endif
 	        break;

	    case "btnReqFellow":
		// Request fellow from the nearest character
		ReqFellow();
		break;

	    case "btnJoinGroup":
	        JoinMoveGroup();
	        break;

	    case "btnAddDNAL":
	    	if (!attDNAL) {
		    Chat.Screen("DNAL not being maintained");
		    break;
		} // endif

		var CurSelAco = skapi.acoSelected;
	        if (CurSelAco == null) {
	            Chat.Screen("No creature currently selected");
	        } else {
	            // Something is selected, lets see what it is
	            if (CurSelAco.ocm & ocmMonster) {
	            	// Add monster to DNAL and abort the current kill attempt
	            	if (logDecal||logAttack||debugDecal||debugAttack)
	            	    Log.OutD("Adding creature " + CurSelAco.szName + ", oid [" +
	            	    	     Util.Hex(CurSelAco.oid) + "] to DNAL", ToChat);
	            	SelNoAttackAdd(CurSelAco.oid);
	            	if (State == stateKill) {
	            	    if (logAttack||debugAttack) Log.OutD("Aborting current kill attempt...", ToChat);
	            	    KillDone();
	            	} // endif
	            } else {
	            	Chat.Screen("Object selected is not a creature");
	            } // endif
	        } // endif
 	        break;

	    case "btnBuffMode":
		szCurCap = dictSzValue("btnBuffMode");
		if (szCurCap == "Disable Buffing") {
		    Chat.Screen("WARNING!!! Buffing disabled!", cmcYellow);
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Buffing disabled");
		    BuffMode = false;
		    skapi.SetControlProperty(szPanelControl, "btnBuffMode", "Text", "Enable Buffing");
		} // endif

		if (szCurCap == "Enable Buffing") {
		    Chat.Screen("Buffing enabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: SafeMode mode enabled");
		    BuffMode = true;
		    skapi.SetControlProperty(szPanelControl, "btnBuffMode", "Text", "Disable Buffing");
		} // endif
 	        break;

	    case "btnGotoCurr":
		Chat.Screen("Moving to current kill location...");
		StateChange(stateGotoCurrent);
	        break;

	    case "btnGotoNext":
	        if (AttLocCnt == 1) {
	            Chat.Screen("Only one attack location defined!!!");
	        } else {
		    Chat.Screen("Moving to next attack location...");
		    StateChange(stateGotoNext);
		} // endif
	        break;

	    case "btnCancelNav":
	    	if ((State != stateGotoCurrent) && (State != stateGotoNext) && !NavActive) {
	    	    Chat.Screen("No active navigation!");
	    	} else {
		    Chat.Screen("Cancelling current navigation...");
		    skapi.CancelNav();
		} // endif
		break;


	    // C2 tab ********************************************

	    case "btnPlayers":
	    	var OurLoc = skapi.maplocCur;
		var PlayerAcf = skapi.AcfNew();
    		PlayerAcf.ocm = ocmPlayer;
		var PlayerList = PlayerAcf.CoacoGet();
		var PlayCnt = 0;

		for (var index=0; index<PlayerList.Count; index++) {
		    var PlayerAco = PlayerList.Item(index);
		    // If this Aco is us, then continue with next entry
		    if (PlayerAco.szName == skapi.szName) continue;

		    // Get player distance.  Exclude players too far from us
		    // which most likely means a stale entry in the object table.
		    var Dist = Util.Distance(PlayerAco.maploc,OurLoc);
		    if (Dist > 3.0) continue;

		    // Report player distance and heading
		    PlayCnt++;
		    var OutLine = "Name: " + Util.Width(PlayerAco.szName,2) + "  Dist: " + Util.RoundFill(Dist,2);
		    if (Dist > 0.01)
			OutLine = OutLine + "  Heading: " + Util.Round(OurLoc.HeadToMaploc(PlayerAco.maploc),0) +
					    "  Coords:  " + Util.FormatCoords(PlayerAco.maploc,2);
	    	    Chat.Screen(OutLine);
		} // endfor

		if (PlayCnt == 0) {
		    Chat.Screen("No players near us.");
		    break;
		} // endif

		if (PlayCnt == 1)
		    Chat.Screen ("1 player detected.");
		else
		    Chat.Screen(PlayCnt + " players detected.");
		break;

	    case "btnChat":
	        if (ChatCnt == 0) {
	            Chat.Screen("No tell or allegiance messages in chat log.");
	        } else {
	    	    Chat.Screen("Displaying chat log...");
		    for (var x=0; x<ChatCnt; x++) Chat.Screen(ChatLog[x]);
 		} // endif
	        break;

	    case "btnStats":
	    	LoadStats();
		Chat.Screen("ElapsedTimeMin: " + ElapsedTimeMin);
		Chat.Screen("Stats Reset: " + new Date(StartTime) + "   Kills: " + TotalKilled +
			    "  Kill Exp: " + KillExp + "  Actual Exp: " + StatActExp);
		Chat.Screen("Kills/Hour: " + StatAveKillHour +
			  "  Kill Exp/Hour: " +  StatEstExpHour +
			  "  Actual Exp/Hour: " + StatActExpHour );
	        break;
	        
	    case "btnMoveStats":
		ShowMoveStats();
		break;

	    case "btnShowComps":
	    	ReportComps("");
	        break;

	    case "btnVersion":
	    	Chat.Screen("Running WarBot " + macroVersion);
	        break;

	    case "btnShowSpells":
	  	Chat.Screen("Maximum war spell lvl : "	   + maxWarSpell	);
	  	Chat.Screen("Maximum vuln spell lvl : "    + maxVulnSpell	);
	  	Chat.Screen("Maximum yield spell lvl : "   + maxYieldSpell	);
	  	Chat.Screen("Minimum war spell lvl : "     + minWarSpell	);
		Chat.Screen("Drain health spell lvl : "    + spellDrainHealth	);
		Chat.Screen("Drain stamina spell lvl : "   + spellDrainStamina	);
		Chat.Screen("Drain mana spell lvl : "      + spellDrainMana	);
		Chat.Screen("Stam2Health spell lvl : "     + spellStamHealth	);
		Chat.Screen("Stam2Mana spell lvl : "       + spellStamMana	);
		Chat.Screen("Heal self spell lvl : "       + spellHeal		);
		Chat.Screen("Revitalize self spell lvl : " + spellRevitalize	);
		Chat.Screen("Strength self spell lvl : "   + spellStrength	);
	  	if (AttCtx.Lvl7Override) {
	  	    var CurDate = new Date();
		    var OutLine = "Lvl 7 Override active, started at " + AttCtx.Lvl7OverStart + " for " +
		    		  AttCtx.Lvl7OverInt/60000 + " minutes";
		    var TimeLeft = (AttCtx.Lvl7OverStart.getTime()+AttCtx.Lvl7OverInt) - CurDate.getTime();
		    if (TimeLeft > 0) OutLine = OutLine + "  (" + Util.Round(TimeLeft/60000,1) + " minutes left)";
		    OutLine = OutLine + "."
	  	    Chat.Screen(OutLine);
	  	} else {
	  	    Chat.Screen("Lvl 7 Override inactive.");
	  	} // endif
	        break;

	    case "btnClearChat":
		Chat.Screen("Chat log cleared.");
		if (logDecal||debugDecal) Log.OutD("OnControlEvent: Chat log cleared.");
	    	ChatCnt = 0;
		break;

	    case "btnResetStats":
	    	Chat.Screen("Resetting stat counters...");
	    	if (logDecal||debugDecal) Log.OutD("OnControlEvent: Resetting stat counters...");
	    	ResetStats();
	    	ClearMoveStats();
	        break;

	    case "btnForceAll":
	    	if (logDecal||debugDecal) Log.OutD("OnControlEvent: Setting force flag on all spells.");
		var ForceCount = Buff.ForceAll();
		Chat.Screen("Forced " + ForceCount + " spells.");
		if (logDecal||debugDecal) Log.OutD("Forced " + ForceCount + " spells.");
 	        break;

	    case "btnResetLB":
	    	var LogInt = Util.Round(landblockInt/(1000*60),1);
		Chat.Screen("Logging for " +  LogInt + " minutes to reset landblock...");
		if (logDecal||debugDecal) Log.OutD("OnControlEvent: Logging for " +  LogInt + " minutes to reset LB...");
	        StateChange(stateHide,NoCheck);
	        LandReset = true;
		break;

	    case "btnLogOff":
		Chat.Screen("Logging off until you manually log back in...");
		if (logDecal||debugDecal) Log.OutD("OnControlEvent: Logging off until you manually log back in...");
		StateChange(statePaused,NoCheck);
		break;

	    case "btnForce7":
	    	NewLvl = parseInt(dictSzValue("lvl7Over"));
	    	if ((NewLvl == 0) && AttCtx.Lvl7Override) {
	    	    Chat.Screen("Lvl 7 override cancelled.")
	    	    if (logDecal||debugDecal) Log.OutD("Lvl 7 override cancelled.");
	    	    AttCtx.Lvl7Override = false;
	    	} else {
	    	    Chat.Screen("Level 7 spells will be cast for " + NewLvl + " minutes");
		    if (logDecal||debugDecal) Log.OutD("Lvl 7 override set for " + NewLvl + " minutes");
		    AttCtx.Lvl7Override  = true;
		    AttCtx.Lvl7OverStart = new Date();
		    AttCtx.Lvl7OverInt   = NewLvl * 60000;	// Convert minutes to milliseconds
		} // endif
	        break;


	    // Loot tab **********************************

	    case "btnShowLoot":
	        ShowLoot();
	        break;

	    case "btnShowDetail":
		ShowDetail();
		break;

	    case "btnShowValSal":
		ShowValSalv();
		break;

	    case "btnSellLoot":
	        if (!MacroPaused) {
	            Chat.Screen("Macro must be paused to sell loot.");
	            break;
	        } // endif

	        if (!VendorOpen) {
	            Chat.Screen("No vendor open!");
	            break;
	        } // endif

		// Build list of valuable salvage
		BuildValSalList();
		
		// Make sure we have some type of valuable loot or salvage bags	        
	        if ((Loot.TypeInfo[lootTypeValuable].ItemCount == 0) && (ValBagColl.Count == 0)) {
		    Chat.Screen("No valuable loot to sell.");
		    break;
		} // endif

	        SellLoot();
	        break;

	    case "btnGiveSell":
	        if (!MacroPaused) {
	            Chat.Screen("Macro must be paused to give loot.");
	            break;
	        } // endif

                // Now see if someone is selected
                var SelAco = skapi.acoSelected;
                if (SelAco == null) {
            	    Chat.Screen("No player selected to give loot");
            	    break;
                } // endif
            
                if (!(SelAco.ocm & ocmPlayer)) {
            	    Chat.Screen("Current selected object is not a player");
            	    break;
                } // endif
            
                if (SelAco.oid == skapi.acoChar.oid) {
            	    Chat.Screen("Can't give to ourself!");
            	    break;
                } // endif
            
                var PlayerDist = Util.Distance(skapi.maplocCur, SelAco.maploc);
                if (PlayerDist > giveMaxDist) {
            	    Chat.Screen("Current selected object is too far away, come within " + giveMaxDist + " map units");
            	    break;
                } // endif

		// Build list of valuable salvage
		BuildValSalList();
		
		// Make sure we have some type of valuable loot or salvage bags	        
	        if ((Loot.TypeInfo[lootTypeValuable].ItemCount == 0) && (ValBagColl.Count == 0)) {
		    Chat.Screen("No valuable loot found.");
		    break;
		} // endif

		if (Loot.TypeInfo[lootTypeValuable].ItemCount > 0) {
		    Chat.Screen("Giving high priced loot...");
		    if (!GiveLoot(lootTypeValuable)) {
			Chat.Screen("Aborted!");
			break;
		    } // endif
		} // endif

		// Now try to give any valuable (nontink) salvage bags
		if (ValBagColl.Count > 0) {
		    Chat.Screen("Giving valuable salvage bags...");
		    if (!GiveValSalvage(SelAco)) {
			Chat.Screen("Aborted!");
			break;
		    } // endif
		} // endif
		Chat.Screen("Done.");
	        break;

	    case "btnGiveSalvage":
	        if (!MacroPaused) {
	            Chat.Screen("Macro must be paused to give salvage.");
	            break;
	        } // endif

	        if (Loot.TypeInfo[lootTypeSalvage].Count == 0) {
		    Chat.Screen("No salvage.");
	            break;
	        } // endif

	        Chat.Screen("Giving salvage...");
		if (GiveLoot(lootTypeSalvage))
		    Chat.Screen("Done.");
		else
		    Chat.Screen("Aborted!");
	        break;

	    case "btnGiveBags":
	    	if (!MacroPaused) {
	            Chat.Screen("Macro must be paused to give salvage.");
	            break;
	        } // endif
		GiveBags();
		break;

	    case "btnAssessLoot":
	    	if (!MacroPaused) {
	            Chat.Screen("Macro must be paused to reassess loot.");
	            break;
	        } // endif
	        AssessLoot();

	        // Set flag to check scroll list for unknown spells if we have learn unknown spells option
	        // checked
	        if (Loot.ScrollFilter.LearnUnknown) HaveUnkScrolls = true; 
		break;

	    case "btnUstSalvage":
		UstAco = skapi.AcoFindInInv("Ust");
		if (!UstAco) {
		    Chat.Screen("Unable to UST salvage, no UST tool could be found!");
		    break;
		} // endif

		// Warn if salvage skills not at a minimum level
		var WeaponTinkInfo = skapi.SkinfoFromSkid(skidWeaponTinkering);
		var ArmorTinkInfo  = skapi.SkinfoFromSkid(skidArmorTinkering);
		var ItemTinkInfo   = skapi.SkinfoFromSkid(skidItemTinkering);
		var MagicTinkInfo  = skapi.SkinfoFromSkid(skidMagicItemTinkering);
		if (!((WeaponTinkInfo.lvlCur>=salvageMinSkill) || (ArmorTinkInfo.lvlCur>=salvageMinSkill) ||
		      (ItemTinkInfo.lvlCur>=salvageMinSkill)   || (MagicTinkInfo.lvlCur>=salvageMinSkill))) {
		    // No tinker skill is at the minimum level
		    Chat.Screen("Warning!!! No tinker skill over " + salvageMinSkill +
		    		".  You may lose some units when USTing!", cmcYellow);
		} // endif

	        if ((Loot.TypeInfo[lootTypeSalvage].ItemCount == 0) &&
		    (Loot.TypeInfo[lootTypeValSalv].ItemCount == 0)) {
		    Chat.Screen("No items on salvage list.");
		    break;
		} // endif

	        if (!MacroPaused) {
	            Chat.Screen("Macro must be paused to UST salvage.");
	            break;
	        } // endif

	        var FreePackSlots = skapi.acoChar.citemMax - skapi.acoChar.citemContents;
	        if (FreePackSlots == 0) {
	            Chat.Screen("No slots left in main pack! Can't UST salvage!");
	            break;
	        } // endif

	        Chat.Screen("USTing salvage...");
	    	AbortAction = false;
	    	UstFailCount = 0;
		while (!AbortAction &&
		       ((Loot.TypeInfo[lootTypeSalvage].ItemCount > 0) ||
		        (Loot.TypeInfo[lootTypeValSalv].ItemCount > 0))) {
		    // Clear out event queue
		    skapi.WaitEvent(0);

                    if (Loot.TypeInfo[lootTypeSalvage].ItemCount > 0) {
                	var Success = Salvage_TinkItems();
                    } else {
                    	var Success = Salvage_ValItems();
                    } //endif

		    if (Success) {
			// UST operation was successful
			UstFailCount = 0;
		    } else {
			// Increment Ust fail count and abort USTing if we exceed the fail limit.
			UstFailCount++;
			if (UstFailCount>salvageMaxFails) {
			    // Exceeded consecutive fail limit, abort UST attempt
			    Chat.Screen("Exceeded Ust fail limit, Usting aborted.");
			    break;
			} // endif
		    } // endif
		} // end while

		if (AbortAction) {
		    Chat.Screen("USTing aborted!");
		    break;
		} // endif

		// Move any full bags of salvage to a side pack if option enabled
		if (flagMoveFull && BagToMove) {
		    Chat.Screen("Moving full bags to side pack...");
		    MoveFullBags();
		    BagToMove = false;
		} // endif
		Chat.Screen("USTing complete.");
	        break;

  	    case "btnSortGood":
	        if (!MacroPaused) {
	            Chat.Screen("Macro must be paused to sort objects in pack.");
	            break;
	        } // endif

	        // Set some flags and sort loot
	        LootSortMode = true;
	        AbortAction = false;

	        // SortLoot with false parameter which means only sort good (keeper items)
	        if (SortLoot(false))
		    Chat.Screen("Done.");
		else
		    Chat.Screen("Sort Aborted!");

		LootSortMode = false;
		break;

   	    case "btnSortAll":
	        if (!MacroPaused) {
	            Chat.Screen("Macro must be paused to sort objects in pack.");
	            break;
	        } // endif

	        // Set some flags and sort loot
	        LootSortMode = true;

	        // SortLoot with true paramter which means sort everything
	        if (SortLoot(true))
		    Chat.Screen("Done.");
		else
		    Chat.Screen("Sort Aborted!");

		LootSortMode = false;
		break;

	    case "btnSortFullBag":
	    	if (!MacroPaused) {
	            Chat.Screen("Macro must be paused to sort salvage bags.");
	            break;
	        } // endif
	        SortBags(true);
	        break;

	    case "btnSortPartBag":
	    	if (!MacroPaused) {
	            Chat.Screen("Macro must be paused to sort salvage bags.");
	            break;
	        } // endif
	        SortBags(false);
	        break;

	    case "btnResetLoot":
	    	Chat.Screen("Resetting loot counters...");
	    	for (var x=0; x<lootTypeTotal; x++) {
	    		Loot.TypeInfo[x].ItemCount = 0;
	    		Loot.TypeInfo[x].TotalValue = 0;
	    	} // endfor
	    	CorpseCheckCnt = 0;
	        break;

	    case "btnAbortLoot":
	    	Chat.Screen("Setting abort flag...");
	    	AbortAction = true;
	        break;


	    // Shortcut tab ******************************************************

	    case "btnFillComps":
	        SafeChatSay("@fillcomps");
	        break;

	    case "btnLifeStone":
		SafeChatSay("@lifestone");
	        break;

	    case "btnHouse":
	    	SafeChatSay("@house recall");
		break;

	    case "btnMansion":
		SafeChatSay("@house mansion_recall");
		break;

	    case "btnMarket":
		SafeChatSay("@marketplace");
		break;

	    case "btnStoneRecall":
	        SpellObj_LifestoneRecall = Cast.GetSpellObj("Lifestone Recall");
	        if (!Cast.Know(SpellObj_LifestoneRecall.spellid)) {
	            Chat.Screen("You do not know the recall to lifestone spell!");
	            break;
	        } // endif
	        Chat.Screen("Casting Lifestone Recall spell...");
	        Cast.Cast(SpellObj_LifestoneRecall);
		break;

	    case "btnPortal1Recall":
	        SpellObj_Portal1Recall = Cast.GetSpellObj("Primary Portal Recall");
	        if (!Cast.Know(SpellObj_Portal1Recall.spellid)) {
	            Chat.Screen("You do not know the Primary Portal Recall spell!");
	            break;
	        } // endif
	        Chat.Screen("Casting Primary Portal Recall spell...");
	        Cast.Cast(SpellObj_Portal1Recall);
	        break;

	    case "btnPortal2Recall":
	        SpellObj_Portal2Recall = Cast.GetSpellObj("Secondary Portal Recall");
	        if (!Cast.Know(SpellObj_Portal2Recall.spellid)) {
	            Chat.Screen("You do not know the Secondary Portal Recall spell!");
	            break;
	        } // endif
	        Chat.Screen("Casting Secondary Portal Recall spell...");
	        Cast.Cast(SpellObj_Portal2Recall);
	        break;

	    case "btnPortalRecall":
	        SpellObj_PortalRecall = Cast.GetSpellObj("Portal Recall");
	        if (!Cast.Know(SpellObj_PortalRecall.spellid)) {
	            Chat.Screen("You do not know the Portal Recall spell!");
	            break;
	        } // endif
	        Chat.Screen("Casting Portal Recall spell...");
	        Cast.Cast(SpellObj_PortalRecall);
	        break;

	    case "btnRecallSanct":
	        SpellObj_RecallSanct = Cast.GetSpellObj("Recall the Sanctuary");
	        if (!Cast.Know(SpellObj_RecallSanct.spellid)) {
	            Chat.Screen("You do not know the recall to sanctuary spell!");
	            break;
	        } // endif
	        Chat.Screen("Casting Recall the Sanctuary spell...");
	        Cast.Cast(SpellObj_RecallSanct);
	        break;

	    case "btnUlgrimRecall":
	        SpellObj_UlgrimRecall = Cast.GetSpellObj("Ulgrim's Recall");
	        if (!Cast.Know(SpellObj_UlgrimRecall.spellid)) {
	            Chat.Screen("You do not know the Ulgrim's Recall spell!");
	            break;
	        } // endif
	        Chat.Screen("Casting Ulgrim's Recall spell...");
	        Cast.Cast(SpellObj_UlgrimRecall);
	        break;

	    case "btnCaulRecall":
	        SpellObj_CaulRecall = Cast.GetSpellObj("Recall to the Singularity Caul");
	        if (!Cast.Know(SpellObj_CaulRecall.spellid)) {
	            Chat.Screen("You do not know the Recall to the Singularity Caul spell!");
	            break;
	        } // endif
	        Chat.Screen("Casting Recall to the Singularity Caul spell...");
	        Cast.Cast(SpellObj_CaulRecall);
	        break;

	    case "btnAphusRecall":
	        SpellObj_AphusRecall = Cast.GetSpellObj("Recall Aphus Lassel");
	        if (!Cast.Know(SpellObj_AphusRecall.spellid)) {
	            Chat.Screen("You do not know the Recall Aphus Lassel spell!");
	            break;
	        } // endif
	        Chat.Screen("Casting Recall Aphus Lassel spell...");
	        Cast.Cast(SpellObj_AphusRecall);
	        break;

	    // U(tility) tab  *********************************************


	    case "btnFindScrolls":
		// See if either a vendor or trade window open
		if (!TradeOpen && !VendorOpen) {
		    Chat.Screen("No vendor or trade window open!");
		    break;
		} // endif

		Chat.Screen("Searching for unknown scrolls...");
		ScrollCoaco.Clear();

		for (var x=0; x<ItemCoaco.Count; x++) {
		    // If item is a scroll and not in the players spellbook, then
		    // add scroll to the Scroll coaco.
		    var ItemAco = ItemCoaco.Item(x);
		    if ((ItemAco.mcm & mcmBooksPaper) && (ItemAco.szName.match(/Scroll/)) &&
		    	(!skapi.FSpellidInSpellbook(ItemAco.spellid))) {
			// Found scroll not found in spellbook, add it to scroll list
			ScrollCoaco.AddAco(ItemAco);
		    } // endif
		} // end for

		ScrollCoaco.Sort(skapi.sortbyName);	// Sort scroll list by name
		Chat.Screen("Found " + ScrollCoaco.Count + " scrolls.");

		break;

	    case "btnShowScrolls":
		if (ScrollCoaco.Count == 0) {
		    Chat.Screen("No unknown scrolls found!");
		} // endif

		Chat.Screen(" ");
		for (var x=0; x<ScrollCoaco.Count; x++) {
		    Chat.Screen(ScrollCoaco.Item(x).szName);
		} // end for
		Chat.Screen(" ");

		break;

	    case "btnBuyScrolls":
		skapi.SelectAco(ScrollCoaco.Item(0));
		break;

	    case "btnSaveScrolls":
		break;

	    case "btnLoadScrolls":
		break;

	    case "btnClearScrolls":
		break;


	    // D(ebug) tab  *********************************************

	    case "btnLootList":
	        Chat.Screen("Loot list count [" + LootCount + "]");
		for (var x=0; x<LootCount; x++) {
		  with (LootList[x]) {
		    Chat.Screen(" ");
		    Chat.Screen("Index: " + x + "  Name: " + Aco.szName + "  Oid: " + Util.Hex(Oid) +
		    		"ObjCreate: " + ObjCreate);
		    Chat.Screen("AssessReq: " + AssessReq + "  AssessCount: " + AssessCount );

		    if (AssessTime > 0)
		    	Chat.Screen("AssessTime: " + new Date(AssessTime));
		    else
		    	Chat.Screen("AssessTime: None");

		    Chat.Screen("AssDone: " + AssessDone + "  Checked: " + Checked + "  CreTime: " + new Date(CreTime));
		    if ((Desc != null) && (Desc != "")) Chat.Screen("Desc: " + Desc);
		  } // end with
		} // end for
	        break;

	    case "btnCorpseList":
	    	Log.OutD("Corpse List [" + CorpseCount + "]", true);
		for (var x=0; x<CorpseCount; x++) {
		    with (CorpseList[x]) {
		    	Chat.Screen("Index: " + x + " Name: " + Aco.szName + " AssReq: " + AssessReq);
			if (debugDecal||debugLoot)
			    Log.OutD("Index: " + x + " Name: " + Aco.szName + " AssReq: " + AssessReq);
			Chat.Screen("AssDone: " + AssessDone + " Ours: " + Ours + " CreTime: " + new Date(CreTime));
			if (debugDecal||debugLoot)
			    Log.OutD("AssDone: " + AssessDone + " Ours: " + Ours + " CreTime: " + new Date(CreTime));
		    } // end with
		} // end for
	        break;

	    case "btnCorpseClear":
	    	CorpseCount = 0;
	    	Chat.Screen("Corpse list cleared");
	    	if (logDecal||debugDecal) Log.OutD("Corpse list cleared");
	    	break;

	    case "btnShowDNAL":
	        if (SelDNALCnt == 0) {
	            Chat.Screen("Do not attack list empty");
	            if (debugDecal||debugAttack) Log.OutD("OnControlEvent: Do not attack list empty");
	        } else {
		    Chat.Screen("Dumping DNAL...");
		    if (debugDecal||debugAttack) Log.OutD("OnControlEvent: Dumping DNAL...");
		    for (var x=0; x < SelDNALCnt; x++) {
			// List DNAL entries
			var OutLine = "Index: " + x + "  Id: " + Util.Hex(SelDNAL[x].Id);
			if (SelDNAL[x].Name != null) OutLine = OutLine + "   Name: " + SelDNAL[x].Name;
			Chat.Screen(OutLine);
			if (debugDecal||debugAttack) Log.OutD("OnControlEvent: " + OutLine);
		    } // endfor
		} // endif
	        break;

	    case "btnDNAL":
	    	Log.OutD("Resetting DNAL ...", true);
		SelDNALCnt    = 0;
		AttCtx.PrevId = 0;	 // Also clear out previous monster id selected
		break;

	    case "btnShowOORL":
	        if (SelOutRangeCnt == 0) {
	            Chat.Screen("Out of range list empty");
	            if (debugDecal||debugAttack) Log.OutD("OnControlEvent: Out of range list empty");
	        } else {
		    Chat.Screen("Dumping out of range list...");
		    if (debugDecal||debugAttack) Log.OutD("OnControlEvent: Dumping OORL...");
		    for (var x=0; x < SelOutRangeCnt; x++) {
			// List OORL entries
			var OutLine = "Index: " + x + "  Id: " + Util.Hex(SelOutRangeList[x].Id);
			if (SelOutRangeList[x].Name != null) OutLine = OutLine + "   Name: " + SelOutRangeList[x].Name;
			Chat.Screen(OutLine);
			if (debugDecal||debugAttack) Log.OutD("OnControlEvent: " + OutLine);
		    } // endfor
		} // endif
	        break;

	    case "btnOORL":
	    	Log.OutD("Resetting Out of Range List ...", true);
		SelOutRangeCnt = 0;
		AttCtx.PrevId  = 0;	 // Also clear out previous monster id selected
		break;

	    case "btnShowBuffs":
		Chat.Screen("Displaying buff structures...");
	    	Buff.ShowBuffs();
	    	break;

	    case "btnShowParams":
	        Chat.Screen("");
	    	Chat.Screen("PlayerExclCnt = "  + PlayerExclCnt  );
	    	Chat.Screen("PlayerNearCnt = "  + PlayerNearCnt  );
	    	Chat.Screen("CriticalAmount = " + CriticalAmount );
	    	Chat.Screen("UrgentAmount = "   + UrgentAmount   );
	    	Chat.Screen("RetreatAmount = "  + RetreatAmount  );
	    	break;

	    case "btnAnalSel":
	        var Aco = skapi.acoSelected;
		if ((Aco == undefined) || (Aco == null)) {
		    Chat.Screen("No object selected.");
		    break;
		} // endif

		var wid = 1.5;
	        Chat.Screen("");
	        Chat.Screen(Util.Width("Oid",wid) 		+ ": " + Util.Hex(Aco.oid));
	        Chat.Screen(Util.Width("fExists",wid) 		+ ": " + Aco.fExists);
	        Chat.Screen(Util.Width("szName",wid)		+ ": " + Aco.szName);
	        Chat.Screen(Util.Width("szPlural",wid)		+ ": " + Aco.szPlural);
	        Chat.Screen(Util.Width("oty",wid) 		+ ": " + Util.Hex(Aco.oty));
	        Chat.Screen(Util.Width("ocm",wid) 		+ ": " + Util.Hex(Aco.ocm));
	        Chat.Screen(Util.Width("olc",wid) 		+ ": " + Util.Hex(Aco.olc));
	        Chat.Screen(Util.Width("eqm",wid) 		+ ": " + Util.Hex(Aco.eqm));
	        Chat.Screen(Util.Width("eqmWearer",wid) 	+ ": " + Util.Hex(Aco.eqmWearer));
	        Chat.Screen(Util.Width("mcm",wid) 		+ ": " + Util.Hex(Aco.mcm));
	        Chat.Screen(Util.Width("szMcm",wid) 		+ ": " + Aco.szMcm);
	        Chat.Screen(Util.Width("cpyValue",wid) 		+ ": " + Aco.cpyValue);
	        Chat.Screen(Util.Width("material",wid)		+ ": " + Aco.material);
	        Chat.Screen(Util.Width("workmanship",wid)	+ ": " + Aco.workmanship);
	        Chat.Screen(Util.Width("citemStack",wid) 	+ ": " + Aco.citemStack);
	        Chat.Screen(Util.Width("citemMaxStack",wid) 	+ ": " + Aco.citemMaxStack);
	        Chat.Screen(Util.Width("cuseLeft",wid) 		+ ": " + Aco.cuseLeft);
	        Chat.Screen(Util.Width("cuseMax",wid) 		+ ": " + Aco.cuseMax);
	        Chat.Screen(Util.Width("burden",wid) 		+ ": " + Aco.burden);
	        Chat.Screen(Util.Width("fInInventory",wid) 	+ ": " + Aco.fInInventory);
	        Chat.Screen(Util.Width("iitem",wid) 		+ ": " + Aco.iitem);
	        Chat.Screen(Util.Width("spellid",wid) 		+ ": " + Aco.spellid);
	        Chat.Screen(Util.Width("distApproach",wid) 	+ ": " + Aco.distApproach);
	        Chat.Screen(Util.Width("fContainer",wid) 	+ ": " + Aco.fContainer);
	        Chat.Screen(Util.Width("citemMax",wid) 		+ ": " + Aco.citemMax);
	        Chat.Screen(Util.Width("citemContents",wid) 	+ ": " + Aco.citemContents);
	        Chat.Screen(Util.Width("icon",wid) 		+ ": " + Aco.icon);
	        Chat.Screen(Util.Width("model",wid) 		+ ": " + Aco.model);
	        if ((Aco.maploc != undefined) && (Aco.maploc != null)) {
		    // Map loc seems to exist, print it out and the distance to us and our kill loc
		    Chat.Screen(Util.Width("coords",wid) 	+ ": " + Util.FormatCoords(Aco.maploc,2));
		    Chat.Screen(Util.Width("kill loc dist",wid) + ": " +
		    	Util.RoundFill(Util.Distance(Aco.maploc,AttLoc[AttLocCur].KillLoc),2));
		    Chat.Screen(Util.Width("Cur loc dist",wid)  + ": " +
			Util.RoundFill(Util.Distance(Aco.maploc,skapi.maplocCur),2));
		} // endif
	        break;

	    case "editCmd":
		szCmd = (dictSzValue("editCmd"));
		Chat.Screen("Evaluating command [" + szCmd + "]");
		eval(szCmd);
		break;

 	} // end switch
 	if (debugEvent||debugCmds) Log.OutD("Main_OnControlEvent: End, Control");
    	return;
    } // endif

    // Config panel
    if (szPanel == szPanelConfig) {
   	// Process Control Panel Controls
	switch (szControl) {

	    // G(eneral)1 tab ******************************************

	    case "btnGenLoad":
	       	var FileNum = parseInt(dictSzValue("loadGen"));
	       	Chat.Screen("Loading general configuration info...");
	        var Status = GenLoad(FileNum);	// Load info from file
	        if (Status) {
	            CritSpellsInit();	// Redefine spell objects
	            SpellCheck(true);	// Make sure critical spells known
		    SetGenControls();	// Now update decal panels with new settings
		    Chat.Screen("Loaded general configuration info from file " + GenFileName);
		} else {
		    Chat.Screen("File " + GenFileName + " not found!");
		} // endif
	        break;

	    case "btnGenSave":
	       	var FileNum = parseInt(dictSzValue("saveGen"));
	       	Chat.Screen("Saving general configuration info...");
		GenSave(FileNum);
		Chat.Screen("General configuration info saved to file " + GenFileName);
	        break;

	    case "btnGenReset":
	    	Chat.Screen("Resetting...");
		GenVarInit();		// Load default values
		Creature.ResetRace();	// Reset race database
		Creature.ResetCre();	// Reset creature database
		Comp.Reset();		// Reset components
		CritSpellsInit();	// Redefine spell objects
		SpellCheck(true);	// Make sure critical spells known
		SetGenControls();	// Now update decal panels with new settings
		Chat.Screen("General configuration reset to defaults!");
	        break;

	    case "chkLogItemBuffs":
		flagLogBuffs = !flagLogBuffs;
		skapi.SetControlProperty(szPanelConfig, "chkLogItemBuffs", "checked", flagLogBuffs );
		if (flagLogBuffs) {
		    if (flagVerbose) Chat.Screen("Item buff logging enabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Item buff logging enabled.");
		    Buff.SetBuffLog(true);
		} else {
		    if (flagVerbose) Chat.Screen("Item buff logging disabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Item buff logging disabled.");
		    Buff.SetBuffLog(false);
		} // endif
		break;

	    case "chkReduceBurden":
		flagReduceBurden = !flagReduceBurden;
		skapi.SetControlProperty(szPanelConfig, "chkReduceBurden", "checked", flagReduceBurden );
		if (flagReduceBurden) {
		    if (flagVerbose) Chat.Screen("Burden reduction enabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Burden reduction enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("Burden reduction disabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Burden reduction disabled.");
		} // endif
		break;

	    case "chkDeathLog":
	    	flagDeathLog= !flagDeathLog;
		skapi.SetControlProperty(szPanelConfig, "chkDeathLog", "checked", flagDeathLog );
		if (flagDeathLog) {
		    if (flagVerbose) Chat.Screen("Logoff on death enabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Logoff on death enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("WARNING!!! Logoff on death disabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Logoff on death disabled.");
		} // endif
 	        break;

	    case "chkDeathBuff":
	    	flagDeathRebuff = !flagDeathRebuff;
		skapi.SetControlProperty(szPanelConfig, "chkDeathBuff", "checked", flagDeathRebuff );
		if (flagDeathRebuff) {
		    if (flagVerbose) Chat.Screen("Rebuff after death enabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Rebuff after death enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("WARNING!!! Rebuff after death disabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Rebuff after death disabled.");
		} // endif
 	        break;

	    case "chkAutoExcl":
	    	flagAutoExcl = !flagAutoExcl;
		skapi.SetControlProperty(szPanelConfig, "chkAutoExcl", "checked", flagAutoExcl );
		if (flagAutoExcl) {
		    if (flagVerbose) Chat.Screen("Auto exclusion enabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Auto exclusion enabled");
		} else {
		    if (flagVerbose) Chat.Screen("Auto exclusion disabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Auto exclusion disabled");
		} // endif
		break;

	    case "chkWarAvoid":
		flagWarAvoid = !flagWarAvoid;
		skapi.SetControlProperty(szPanelConfig, "chkWarAvoid", "checked", flagWarAvoid );
		if (flagWarAvoid) {
		    if (flagVerbose) Chat.Screen("War spell evasion enabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: War spell evasion enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("War spell evasion disabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: War spell evasion disabled.");
		} // endif
		break;

	    case "chkFellowStealth":
	    	flagFellowStealth = !flagFellowStealth;
		skapi.SetControlProperty(szPanelConfig, "chkFellowStealth", "checked", flagFellowStealth);
		if (flagFellowStealth) {
		    if (flagVerbose) Chat.Screen("Fellow stealth enabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Fellow stealth enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("Fellow stealth disabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Fellow stealth disabled.");
		} // endif
 	        break;

	    case "chkAllegStealth":
	    	flagAllegStealth = !flagAllegStealth;
		skapi.SetControlProperty(szPanelConfig, "chkAllegStealth", "checked", flagAllegStealth);
		if (flagAllegStealth) {
		    if (flagVerbose) Chat.Screen("Allegiance stealth enabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Allegiance stealth enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("Allegiance stealth disabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Allegiance stealth disabled.");
		} // endif
 	        break;

	    case "chkAutoResp":
	    	flagAutoRespond	= !flagAutoRespond;
		skapi.SetControlProperty(szPanelConfig, "chkAutoResp", "checked", flagAutoRespond );
		if (flagAutoRespond) {
		    if (flagVerbose) Chat.Screen("Auto response enabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Auto response enabled");
		} else {
		    if (flagVerbose) Chat.Screen("Auto response disabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Auto response disabled");
		} // endif
		break;

	    case "chkDisband":
	    	flagAllowDisband = !flagAllowDisband;
		skapi.SetControlProperty(szPanelConfig, "chkDisband", "checked", flagAllowDisband);
		if (flagAllowDisband) {
		    if (flagVerbose) Chat.Screen("Remote disband enabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Remote disband enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("Remote disband disabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Remote disband disabled.");
		} // endif
 	        break;

	    case "chkAutoResume":
	    	flagAutoResume = !flagAutoResume;
		skapi.SetControlProperty(szPanelConfig, "chkAutoResume", "checked", flagAutoResume);
		if (flagAutoResume) {
		    if (flagVerbose) Chat.Screen("Macro will automatically resume from Paused state after " +
		    		 Util.Round(autoResumeInt/1000,0) + "seconds.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: AutoResume enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("Auto resume disabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: AutoResume disabled.");
		} // endif
 	        break;

	    case "chkAcceptFellow":
	    	flagAcceptFellow = !flagAcceptFellow;
		skapi.SetControlProperty(szPanelConfig, "chkAcceptFellow", "checked", flagAcceptFellow);
		if (flagAcceptFellow) {
		    if (flagVerbose) Chat.Screen("Macro will accept fellow requests");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Macro will accept fellow requests");
		} else {
		    if (flagVerbose) Chat.Screen("Macro will NOT accept fellow requests");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Macro will NOT accept fellow requests");
		} // endif
 	        break;

	    case "chkGem":
		flagGem = !flagGem;
		skapi.SetControlProperty(szPanelConfig, "chkGem", "checked", flagGem );
		if (flagGem) {
		    if (flagVerbose) Chat.Screen("Gem of stillness use enabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Gem of stillness use enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("Gem of stillness use disabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Gem of stillness use disabled.");
		} // endif
		break;

	    case "chkSlideCast":
		flagSlideCast = !flagSlideCast;
		skapi.SetControlProperty(szPanelConfig, "chkSlideCast", "checked", flagSlideCast );
		if (flagSlideCast) {
		    if (flagVerbose) Chat.Screen("Slide casting enabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Slide casting enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("Slide casting disabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Slide casting disabled.");
		} // endif
		break;

	    case "fellowOptions":
		szNewOpt = dictSzValue("fellowOptions");
		if (szNewOpt == "Authorized") {
		    if (!anybodyFellow && !passwordFellow) break;	// Same as previous, no sense processing
		    anybodyFellow = false;
		    passwordFellow = false;
		    Chat.Screen("Only authorized characters can request fellow.");
		    if (logDecal||debugDecal)
		    	Log.OutD("OnControlEvent: Only authorized characters can request fellow.");
		} // endif

		if (szNewOpt == "Password") {
		    if (!anybodyFellow && passwordFellow) break;	// Same as previous, no sense processing
		    anybodyFellow = false;
		    passwordFellow = true;
		    Chat.Screen("Password '" + fellowPassword + "' required with fellow requests.");
		    if (logDecal||debugDecal)
		        Log.OutD("OnControlEvent: Password '" + fellowPassword + "' required with fellow requests.");
		} // endif

		if (szNewOpt == "Anybody") {
		    if (anybodyFellow && !passwordFellow) break;	// Same as previous, no sense processing
		    anybodyFellow = true;
		    passwordFellow = false;
		    Chat.Screen("Anybody can request fellow.")
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Anybody can request fellow.")
		} // endif
		break;


	    // G(eneral)2 tab ******************************************

	    case "chkSelCheckZ":
		flagSelCheckZ = !flagSelCheckZ;
		skapi.SetControlProperty(szPanelConfig, "chkSelCheckZ", "checked", flagSelCheckZ );
		if (flagSelCheckZ) {
		    if (flagVerbose) Chat.Screen("Restrictive altitude selection enabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Restrictive altitude selection enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("Restrictive altitude selection disabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Restrictive altitude selection disabled.");
		} // endif
		break;

	    case "chkAssessKnown":
		flagAssessKnown = !flagAssessKnown;
		skapi.SetControlProperty(szPanelConfig, "chkAssessKnown", "checked", flagAssessKnown );
		if (flagAssessKnown) {
		    if (flagVerbose) Chat.Screen("Known creature assessing enabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Known creature assessing enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("Known creature assessing disabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Known creature assessing disabled.");
		} // endif
		break;

	    case "chkAssessUnknown":
		flagAssessUnknown = !flagAssessUnknown;
		skapi.SetControlProperty(szPanelConfig, "chkAssessUnknown", "checked", flagAssessUnknown );
		if (flagAssessUnknown) {
		    if (flagVerbose) Chat.Screen("Unknown creature assessing enabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Unknown creature assessing enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("Unknown creature assessing disabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Unknown creature assessing disabled.");
		} // endif
		break;

	    case "chkIgnoreAtt":
		flagIgnoreAtt = !flagIgnoreAtt;
		skapi.SetControlProperty(szPanelConfig, "chkIgnoreAtt", "checked", flagIgnoreAtt );
		if (flagIgnoreAtt) {
		    if (flagVerbose) Chat.Screen("Attack ignore enabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Attack ignore enabled.");
		    if (!PeaceMode) {
			skapi.RemoveHandler( evidOnMeleeDamageSelf,	MainH );
			skapi.RemoveHandler( evidOnMeleeEvadeSelf,	MainH );
			skapi.RemoveHandler( evidOnMeleeLastAttacker, 	MainH );
		    } // endif
		} else {
		    if (flagVerbose) Chat.Screen("Attack ignore disabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Attack ignore disabled.");
		    if (!PeaceMode) {
			skapi.AddHandler( evidOnMeleeDamageSelf,	MainH );
			skapi.AddHandler( evidOnMeleeEvadeSelf,		MainH );
			skapi.AddHandler( evidOnMeleeLastAttacker,	MainH );
		    } // endif
		} // endif
		break;

	    // Movement options

	    case "chkAutoHome":
		flagAutoHome = !flagAutoHome;
		skapi.SetControlProperty(szPanelConfig, "chkAutoHome", "checked", flagAutoHome);
		if (flagAutoHome) {
		    if (flagVerbose) Chat.Screen("Auto home enabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Auto home enabled");
		} else {
		    if (flagVerbose) Chat.Screen("Auto home disabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Auto home disabled");
		} // endif
		break;

	    case "chkMoveDelay":
		flagMoveDelay = !flagMoveDelay;
		skapi.SetControlProperty(szPanelConfig, "chkMoveDelay", "checked", flagMoveDelay);
		if (flagMoveDelay) {
		    if (flagVerbose) Chat.Screen("Move delay enabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Move delay enabled");
		} else {
		    if (flagVerbose) Chat.Screen("Move delay disabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Move delay disabled");
		} // endif
		break;

	    case "chkRetreat":
		flagRetreatCrit = !flagRetreatCrit;
		skapi.SetControlProperty(szPanelConfig, "chkRetreat", "checked", flagRetreatCrit);
		if (flagRetreatCrit) {
		    if (flagVerbose) Chat.Screen("Retreating enabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Retreating enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("Retreating disabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Retreating disabled.");
		} // endif
		break;

	    case "chkMultRetreat":
		flagMultRetreat = !flagMultRetreat;
		skapi.SetControlProperty(szPanelConfig, "chkMultRetreat", "checked", flagMultRetreat);
		if (flagMultRetreat) {
		    if (flagVerbose) Chat.Screen("Multichar retreating enabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Multichar retreating enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("Multichar retreating disabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Multichar retreating disabled.");
		} // endif
		break;

	    case "chkHealthRetreat":
		flagHealthRetreat = !flagHealthRetreat;
		skapi.SetControlProperty(szPanelConfig, "chkHealthRetreat", "checked", flagHealthRetreat);
		if (flagHealthRetreat) {
		    if (flagVerbose) Chat.Screen("Low health retreating enabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Low health retreating enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("Low health retreating disabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Low health retreating disabled.");
		} // endif
		break;

	    case "chkRecordLoc":
		flagRecordLoc = !flagRecordLoc;
		skapi.SetControlProperty(szPanelConfig, "chkRecordLoc", "checked", flagRecordLoc);
		if (flagRecordLoc) {
		    if (flagVerbose) Chat.Screen("Location recording enabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Location recording enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("Location recording disabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Location recording disabled.");
		} // endif
		break;

	    case "retreatCnt1":
	    	var NewInt = parseInt(dictSzValue("retreatCnt1"));
	    	if (retreatAmtOne == NewInt) break;		// Same value so just break
	    	retreatAmtOne = NewInt;
		if (flagVerbose) Chat.Screen("One player retreat count set to " + retreatAmtOne + "." );
		if (logDecal||debugDecal) Log.OutD("OnControlEvent: 1 retreat cnt set to " + retreatAmtOne + ".");
		break;

	    case "retreatCnt2":
		var NewInt = parseInt(dictSzValue("retreatCnt2"));
		if (retreatAmtTwo == NewInt) break;		// Same value so just break
		retreatAmtTwo = NewInt;
		if (flagVerbose) Chat.Screen("Two player retreat count set to " + retreatAmtTwo + "." );
		if (logDecal||debugDecal) Log.OutD("OnControlEvent: 2 retreat cnt set to " + retreatAmtTwo + ".");
		break;

	    case "retreatCnt3":
		var NewInt = parseInt(dictSzValue("retreatCnt3"));
		if (retreatAmtThreePlus == NewInt) break;	// Same value so just break
		retreatAmtThreePlus = NewInt;
		if (flagVerbose) Chat.Screen("Three+ player retreat count set to " + retreatAmtThreePlus + "." );
		if (logDecal||debugDecal) Log.OutD("OnControlEvent: 3+ retreat cnt set to " + retreatAmtThreePlus + "." );
		break;

	    case "retreatDam":
	    	var NewInt = parseInt(dictSzValue("retreatDam"));
	    	if (retreatDamThresh == NewInt) break;		// Same value as before so just break
	    	retreatDamThresh = NewInt;
		if (flagVerbose) Chat.Screen("Damage retreat threshold set to " + retreatDamThresh + "." );
		if (logDecal||debugDecal) Log.OutD("OnControlEvent: 3+ retreat cnt set to " + retreatDamThresh + "." );
		break;

	    case "moveGroup":
	    	var MoveGroupText = dictSzValue("moveGroup");
	    	if (MoveGroupText == "None") {
		    var NewInt = 0;
		} else {
		    var NewInt = parseInt(MoveGroupText);
		} // endif
		if (MoveGroup == NewInt) break;	// Same value as before so just break

		if (NewInt == 0) {
		    MoveGroup = 0;
		    if (flagVerbose) Chat.Screen("MoveGroup cleared.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: MoveGroup cleared.");
		} else {
		    MoveGroup = NewInt;
		    if (flagVerbose) Chat.Screen("Joining MoveGroup " + MoveGroup + "." );
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Joining MoveGroup " + MoveGroup + "." );
		} // endif
		break;


	    // I(nfo) ******************************************

	    case "chkRepPlayer":
		flagReportPlayer = !flagReportPlayer;
		skapi.SetControlProperty(szPanelConfig, "chkRepPlayer", "checked", flagReportPlayer );
		if (flagReportPlayer) {
		    if (flagVerbose) Chat.Screen("Player reporting enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("Player reporting disabled.");
		} // endif
		break;

	    case "chkRepLoot":
		flagReportLoot = !flagReportLoot;
		skapi.SetControlProperty(szPanelConfig, "chkRepLoot", "checked", flagReportLoot);
		if (flagReportLoot) {
		    if (flagVerbose) Chat.Screen("Loot reporting enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("Loot reporting disabled.");
		} // endif
		break;

	    case "chkRepAbort":
		flagReportAbort = !flagReportAbort;
		skapi.SetControlProperty(szPanelConfig, "chkRepAbort", "checked", flagReportAbort);
		if (flagReportAbort) {
		    if (flagVerbose) Chat.Screen("Kill abort reporting enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("Kill abort reporting disabled.");
		} // endif
		break;

	    case "chkDispUnspent":
		flagDispExp = !flagDispExp;
		skapi.SetControlProperty(szPanelConfig, "chkDispUnspent", "checked", flagDispExp);
		if (flagDispExp) {
		    if (flagVerbose) Chat.Screen("Unspent experience change reporting enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("Unspent experience change reporting disabled.");
		} // endif
		break;

	    case "chkDispSkill":
		flagDispSkillExp = !flagDispSkillExp;
		skapi.SetControlProperty(szPanelConfig, "chkDispSkill", "checked", flagDispSkillExp);
		if (flagDispSkillExp) {
		    if (flagVerbose) Chat.Screen("Skill experience change reporting enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("Skill experience change reporting disabled.");
		} // endif
		break;

	    case "chkItemFellow":
		flagItemSpam = !flagItemSpam;
		skapi.SetControlProperty(szPanelConfig, "chkItemFellow", "checked", flagItemSpam);
		if (flagItemSpam) {
		    if (flagVerbose) Chat.Screen("Spamming good items to fellow enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("Spamming good items to fellow disabled.");
		} // endif
		break;

	    case "chkFellowSupport":
		flagFellowSup = !flagFellowSup;
		skapi.SetControlProperty(szPanelConfig, "chkFellowSuport", "checked", flagFellowSup);
		if (flagFellowSup) {
		    if (flagVerbose) Chat.Screen("Spamming important macro events to fellow enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("Spamming important macro events to fellow disabled.");
		} // endif
		break;

	    case "chkFriendSupport":
		flagFriendSup = !flagFriendSup;
		skapi.SetControlProperty(szPanelConfig, "chkFriendSupport", "checked", flagFriendSup);
		if (flagFriendSup) {
		    Chat.Screen("Spamming important macro events to friends enabled.");
		    if (supportChars.length == 0) {
		    	Chat.Screen("WARNING! No characters listed in 'supportChars' variable to receive @tells");
		    } else {
			Chat.Screen("The following chars will receive @tells: " + supportChars.join());
		    } // endif
		} else {
		    if (flagVerbose) Chat.Screen("Spamming important macro events to friends disabled.");
		} // endif
		break;

	    case "chkVerbose":
		flagVerbose = !flagVerbose;
		skapi.SetControlProperty(szPanelConfig, "chkVerbose", "checked", flagVerbose);
		if (flagVerbose) {
		    Chat.Screen("Verbose mode enabled.");
		} else {
		    Chat.Screen("Verbose mode disabled.");
		} // endif
		break;


	    // L(oot), S(tartup) tab ***********************************

	    case "chkLooting":
		flagLootCheck = !flagLootCheck;
		skapi.SetControlProperty(szPanelLoot, "chkLooting", "checked", flagLootCheck);
		if (flagLootCheck) {
		    if (flagVerbose) Chat.Screen("Looting enabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Looting enabled");
		} else {
		    if (flagVerbose) Chat.Screen("Looting disabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Looting disabled");
		} // endif
		break;

	    case "chkLootAll":
		flagLootAll = !flagLootAll;
		skapi.SetControlProperty(szPanelLoot, "chkLootAll", "checked", flagLootAll);
		if (flagLootAll) {
		    if (flagVerbose) Chat.Screen("Looting all corpses enabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Looting other player's corpses enabled");
		} else {
		    if (flagVerbose) Chat.Screen("Looting all corpses disabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Looting other player's corpses disabled");
		} // endif
		break;

	    case "chkAutoUst":
		flagAutoUst = !flagAutoUst;
		if (flagAutoUst) {
		    // Make sure an UST tool is in inventory before enabling auto-USTing
		    UstAco = skapi.AcoFindInInv("Ust");
		    if (!UstAco) {
			flagAutoUst = false;
			Log.OutD("ItemInit: Error, no UST tool found, disabling auto-USTing...");
			Chat.Screen("Unable to enable USTing, no UST tool could be found!");
			skapi.SetControlProperty(szPanelConfig, "chkAutoUst", "checked", flagAutoUst );
			break;
		    } // endif

		    // Warn if salvage skills not at a minimum level
		    var WeaponTinkInfo = skapi.SkinfoFromSkid(skidWeaponTinkering);
		    var ArmorTinkInfo  = skapi.SkinfoFromSkid(skidArmorTinkering);
		    var ItemTinkInfo   = skapi.SkinfoFromSkid(skidItemTinkering);
		    var MagicTinkInfo  = skapi.SkinfoFromSkid(skidMagicItemTinkering);
		    if (!((WeaponTinkInfo.lvlCur>=salvageMinSkill) || (ArmorTinkInfo.lvlCur>=salvageMinSkill) ||
		    	  (ItemTinkInfo.lvlCur>=salvageMinSkill)   || (MagicTinkInfo.lvlCur>=salvageMinSkill))) {
			// No tinker skill is at the minimum level, give a warning
			Log.OutD("ItemInit: Warning! No tink skill >= recommended lvl [" + salvageMinSkill + "]");
		        Chat.Screen("Warning!!! No tinker skill over " + salvageMinSkill +
		    		    ".  You may lose some units when USTing!", cmcYellow);
		    } // endif
		} // endif

		skapi.SetControlProperty(szPanelConfig, "chkAutoUst", "checked", flagAutoUst);

		if (flagAutoUst) {
		    if (flagVerbose) Chat.Screen("Automatic USTing of salvage enabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Automatic USTing of salvage enabled");
		} else {
		    if (flagVerbose) Chat.Screen("Automatic USTing of salvage disabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Automatic USTing of salvage disabled");
		} // endif
		break;

	    case "chkMoveFull":
		flagMoveFull = !flagMoveFull
		skapi.SetControlProperty(szPanelLoot, "chkMoveFull", "checked", flagMoveFull );
		if (flagMoveFull) {
		    if (flagVerbose) Chat.Screen("Moving full bags of salvage to side packs enabled.");
		    if (logDecal||debugDecal)
			Log.OutD("OnControlEvent: Moving full bags of salvage to side packs enabled");
		} else {
		    if (flagVerbose) Chat.Screen("Moving full bags of salvage to side packs disabled.");
		    if (logDecal||debugDecal)
			Log.OutD("OnControlEvent: Moving full bags of salvage to side packs disabled");
		} // endif
		break;

	    // Startup options

	    case "chkStartBuff":
		startBuffMode = !startBuffMode;
		skapi.SetControlProperty(szPanelConfig, "chkStartBuff", "checked", startBuffMode);
		if (startBuffMode) {
		    if (flagVerbose) Chat.Screen("Buffing will be enabled at macro start.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Buffing enabled at macro start");
		} else {
		    Chat.Screen("WARNING!!! Buffing will be disabled at macro start.", cmcYellow);
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Buffing disabled at macro start");
		} // endif
		break;

	    case "chkStartAttack":
		startAttackMode = !startAttackMode;
		skapi.SetControlProperty(szPanelConfig, "chkStartAttack", "checked", startAttackMode);
		if (startAttackMode) {
		    if (flagVerbose) Chat.Screen("Attack mode will be enabled at macro start.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Attack mode will be enabled at macro start.");
		} else {
		    if (flagVerbose) Chat.Screen("Attack mode will be disabled at macro start.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Attack mode will be disabled at macro start.");
		} // endif
		break;

	    case "chkStartStealth":
		startStealth = !startStealth;
		skapi.SetControlProperty(szPanelConfig, "chkStartStealth", "checked", startStealth);
		if (startStealth) {
		    if (flagVerbose) Chat.Screen("Stealth mode will be enabled at macro start.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Stealth mode will be enabled at macro start.");
		} else {
		    if (flagVerbose) Chat.Screen("Stealth mode will be disabled at macro start.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Stealth mode will be disabled at macro start.");
		} // endif
		break;

	    case "chkStartAutoMove":
		startAutoMove = !startAutoMove;
		skapi.SetControlProperty(szPanelConfig, "chkStartAutoMove", "checked", startAutoMove);
		if (startAutoMove) {
		    if (flagVerbose) Chat.Screen("Automove will be enabled at macro start.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Automove will be enabled at macro start.");
		} else {
		    if (flagVerbose) Chat.Screen("Automove will be disabled at macro start.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Automove will be disabled at macro start.");
		} // endif
		break;

	    case "chkStartExclMode":
		startExclMode = !startExclMode;
		skapi.SetControlProperty(szPanelConfig, "chkStartExclMode", "checked", startExclMode);
		if (startExclMode) {
		    if (flagVerbose) Chat.Screen("Exclusion mode will be enabled at macro start.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Excl mode will be enabled at macro start.");
		} else {
		    if (flagVerbose) Chat.Screen("Exclusion mode will be disabled at macro start.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Excl mode will be disabled at macro start.");
		} // endif
		break;

	    case "chkStartSafeMode":
		startSafeMode = !startSafeMode;
		skapi.SetControlProperty(szPanelConfig, "chkStartSafeMode", "checked", startSafeMode);
		if (startSafeMode) {
		    if (flagVerbose) Chat.Screen("Safe mode will be enabled at macro start.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Safe mode will be enabled at macro start.");
		} else {
		    if (flagVerbose) Chat.Screen("Safe mode will be disabled at macro start.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Safe mode will be disabled at macro start.");
		} // endif
		break;

	    case "chkStartPeaceMode":
		startPeaceMode = !startPeaceMode;
		skapi.SetControlProperty(szPanelConfig, "chkStartPeaceMode", "checked", startPeaceMode);
		if (startPeaceMode) {
		    if (flagVerbose) Chat.Screen("Peace mode will be enabled at macro start.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Peace mode will be enabled at macro start.");
		} else {
		    if (flagVerbose) Chat.Screen("Peace mode will be disabled at macro start.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Peace mode will be disabled at macro start.");
		} // endif
		break;

	    case "chkStartFellow":
		creFellow = !creFellow;
		skapi.SetControlProperty(szPanelConfig, "chkStartFellow", "checked", creFellow);
		if (creFellow) {
		    if (flagVerbose) Chat.Screen("Fellow '" + fellowName + "' will be created at macro start.");
		    if (logDecal||debugDecal)
			Log.OutD("OnControlEvent: Fellow '" + fellowName + "' will be created at macro start.");
		} else {
		    if (flagVerbose) Chat.Screen("Fellow will not be created at macro start.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Fellow will not be created at macro start.");
		} // endif
		break;


	    // S(pell)1 Tab **********************************

	    case "chkYieldDisable":
	    	flagYieldDisable = !flagYieldDisable;
		skapi.SetControlProperty(szPanelConfig, "chkYieldDisable", "checked", flagYieldDisable);
		if (flagYieldDisable) {
		    Chat.Screen("WARNING!!! Yielding disabled.", cmcYellow);
		    if (logDecal||debugDecal) Log.OutD("Yielding disabled.");
		} else {
		    if (flagVerbose) Chat.Screen("Yielding enabled.");
		    if (logDecal||debugDecal) Log.OutD("Yielding enabled.");
		} // endif
		break;

	    case "chkYieldMagicD":
	    	flagYieldNoMagD = !flagYieldNoMagD;
		skapi.SetControlProperty(szPanelConfig, "chkYieldMagicD", "checked", flagYieldNoMagD);
		if (flagYieldNoMagD) {
		    if (flagVerbose) Chat.Screen("Yielding of creatures with an unknown magicd enabled.");
		    if (logDecal||debugDecal) Log.OutD("Yielding of creatures with an unknown magicd enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("Yielding of creatures with an unknown magicd disabled.");
		    if (logDecal||debugDecal) Log.OutD("Yielding of creatures with an unknown magicd disabled.");
		} // endif
		break;

	    case "chkVulnDown":
	    	attVulnStepdown = !attVulnStepdown;
		skapi.SetControlProperty(szPanelConfig, "chkVulnDown", "checked", attVulnStepdown);
		if (attVulnStepdown) {
		    if (flagVerbose) Chat.Screen("Vuln step down enabled.");
		    if (logDecal||debugDecal) Log.OutD("Vuln step down enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("Vuln step down disabled.");
		    if (logDecal||debugDecal) Log.OutD("Vuln step down disabled.");
		} // endif
		break;

	    case "chkWarDown":
	    	attWarStepdown = !attWarStepdown;
		skapi.SetControlProperty(szPanelConfig, "chkWarDown", "checked", attWarStepdown);
		if (attWarStepdown) {
		    if (flagVerbose) Chat.Screen("War step down enabled.");
		    if (logDecal||debugDecal) Log.OutD("War step down enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("War step down disabled.");
		    if (logDecal||debugDecal) Log.OutD("War step down disabled.");
		} // endif
		break;

	    case "chkWarUp":
	    	attWarStepup = !attWarStepup;
		skapi.SetControlProperty(szPanelConfig, "chkWarUp", "checked", attWarStepup);
		if (attWarStepup) {
		    if (flagVerbose) Chat.Screen("War step up enabled.");
		    if (logDecal||debugDecal) Log.OutD("War step up enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("War step up disabled.");
		    if (logDecal||debugDecal) Log.OutD("War step up disabled.");
		} // endif
		break;

	    case "healStepUp":
	    	var NewInt = parseInt(dictSzValue("healStepUp"));
	    	if (NewInt == healStepUpThresh) break;
	    	healStepUpThresh = NewInt;
	    	if (flagVerbose) Chat.Screen("Level 7 heal setup threshold set to " + healStepUpThresh + ".");
	  	if (logDecal||debugDecal) Log.OutD("Level 7 heal setup threshold set to " + healStepUpThresh);
	        break;

	    case "chkWandImbue":
	    	attUseWandImbue = !attUseWandImbue;
		skapi.SetControlProperty(szPanelConfig, "chkWandImbue", "checked", attUseWandImbue);
		if (attUseWandImbue) {
		    if (flagVerbose) Chat.Screen("Wand resistance imbue vuln suppress enabled.");
		    if (logDecal||debugDecal) Log.OutD("Wand resistance imbue vuln skip enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("Wand resistance imbue vuln suppress disabled.");
		    if (logDecal||debugDecal) Log.OutD("Wand resistance imbue vuln skip disabled.");
		} // endif
		break;

	    case "chkMatchVuln2":
	    	attMatchVuln2 = !attMatchVuln2;
		skapi.SetControlProperty(szPanelConfig, "chkMatchVuln2", "checked", attMatchVuln2);
		if (attMatchVuln2) {
		    if (flagVerbose) Chat.Screen("Wand imbue check against secondary vuln enabled.");
		    if (logDecal||debugDecal) Log.OutD("Wand imbue check against secondary vuln enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("Wand imbue check against secondary vuln disabled.");
		    if (logDecal||debugDecal) Log.OutD("Wand imbue check against secondary vuln disabled.");
		} // endif
		break;

	    case "chkMatchVuln3":
	    	attMatchVuln3 = !attMatchVuln3;
		skapi.SetControlProperty(szPanelConfig, "chkMatchVuln3", "checked", attMatchVuln3);
		if (attMatchVuln3) {
		    if (flagVerbose) Chat.Screen("Wand imbue check against tertiary vuln enabled.");
		    if (logDecal||debugDecal) Log.OutD("Wand imbue check against tertiary vuln enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("Wand imbue check against tertiary vuln disabled.");
		    if (logDecal||debugDecal) Log.OutD("Wand imbue check against tertiary vuln disabled.");
		} // endif
		break;

	    case "warChoice":
	    	var NewInt = parseInt(dictSzValue("warChoice"));
	    	if (NewInt == attSpell) break;
	    	attSpell = NewInt;
	    	if (flagVerbose) Chat.Screen("War spell type set to  " + attSpellText[attSpell] + ".");
	  	if (logDecal||debugDecal) Log.OutD("War spell type set to " + attSpellText[attSpell] + ".");
	        break;

	    case "chkAlwaysImperl":
	    	attAlwaysImperl = !attAlwaysImperl;
		skapi.SetControlProperty(szPanelConfig, "chkAlwaysImperl", "checked", attAlwaysImperl);
		if (attAlwaysImperl) {
		    if (flagVerbose) Chat.Screen("Imperling enabled.");
		    if (logDecal||debugDecal) Log.OutD("Imperling enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("Imperling disabled.");
		    if (logDecal||debugDecal) Log.OutD("Imperling disabled.");
		} // endif
		break;

	    case "chkUseRingSpl":
	    	attUseRingSpells = !attUseRingSpells;
		skapi.SetControlProperty(szPanelConfig, "chkUseRingSpl", "checked", attUseRingSpells);
		if (attUseRingSpells) {
		    if (flagVerbose) Chat.Screen("Ring spells enabled.");
		    if (logDecal||debugDecal) Log.OutD("Ring spells enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("Ring spells disabled.");
		    if (logDecal||debugDecal) Log.OutD("Ring spells disabled.");
		} // endif
		break;

	    // Spell 2 Tab **********************************8

	    case "maxWar":
	    	var NewLvl = parseInt(dictSzValue("maxWar"));
	    	if (NewLvl == maxWarSpell) break;
	    	if (NewLvl < minWarSpell) {
		    Chat.Screen("Can't set maximum war spell below minimum war spell you idiot!");
		    skapi.SetControlProperty(szPanelConfig, "maxWar", "selected", 7-maxWarSpell );
		    break;
		} // endif
	    	maxWarSpell = NewLvl;
	    	if (flagVerbose) Chat.Screen("Maximum war spell level set to " + maxWarSpell + ".");
	  	if (logDecal||debugDecal) Log.OutD("Maximum war spell level set to " + maxWarSpell);
	        break;
	        
	    case "minWar":
	    	var NewLvl = parseInt(dictSzValue("minWar"));
	    	if (NewLvl == minWarSpell) break;
	    	if (NewLvl > maxWarSpell) {
		    Chat.Screen("Can't set minimum war spell above maximum war spell you moron!");
		    skapi.SetControlProperty(szPanelConfig, "minWar", "selected", 7-minWarSpell );
		    break;
		} // endif
		minWarSpell = NewLvl;
	    	if (flagVerbose) Chat.Screen("Minimum war spell level set to " + minWarSpell + ".");
	  	if (logDecal||debugDecal) Log.OutD("Minimum war spell level set to " + minWarSpell);
	        break;

	    case "maxYield":
	    	var NewInt = parseInt(dictSzValue("maxYield"));
	    	if (NewInt == maxYieldSpell) break;
	    	maxYieldSpell = NewInt;
	    	if (flagVerbose) Chat.Screen("Maximum yield spell level set to " + maxYieldSpell + ".");
	  	if (logDecal||debugDecal) Log.OutD("Maximum yield spell level set to " + maxYieldSpell);
	        break;

	    case "maxImperl":
	    	var NewInt = parseInt(dictSzValue("maxImperl"));
	    	if (NewInt == maxImperlSpell) break;
	    	maxImperlSpell = NewInt;
	    	if (flagVerbose) Chat.Screen("Maximum imperl spell level set to " + maxImperlSpell + ".");
	  	if (logDecal||debugDecal) Log.OutD("Maximum imperl spell level set to " + maxImperlSpell);
	        break;

	    case "maxVuln":
	    	var NewInt = parseInt(dictSzValue("maxVuln"));
	    	if (NewInt == maxVulnSpell) break;
	    	maxVulnSpell = NewInt;
	    	if (flagVerbose) Chat.Screen("Maximum vuln spell level set to " + maxVulnSpell + ".");
	  	if (logDecal||debugDecal) Log.OutD("Maximum vuln spell level set to " + maxVulnSpell);
	        break;

	    case "healSelf":
	    	var NewLvl = parseInt(dictSzValue("healSelf"));
	    	if (NewLvl == spellHeal) break;
	    	if (!Cast.Know(spellListHeal[NewLvl])) {
		    Chat.Screen("You do not know Heal Self " + NewLvl + "!");
		    skapi.SetControlProperty(szPanelConfig, "healSelf", "selected", 7-spellHeal);
		    break;
		} // endif
		spellHeal = NewLvl;
		SpellObj_Heal = skapi.SpellInfoFromSpellid(spellListHeal[spellHeal]);
	    	if (flagVerbose) Chat.Screen("Heal Self spell level set to " + spellHeal + ".");
	  	if (logDecal||debugDecal) Log.OutD("Heal Self spell level set to " + spellHeal);

	  	// If we are in Restricted mode due to not knowing spells at macro start, then see if
	  	// we now know all spells needed for proper macro operation
	  	if (Restricted) {
		    if (SpellCheck(false)) {
		    	Chat.Screen("All spells necessary for macro operation are now known, Restricted flag cleared.");
		    	Restricted = false;
		    } else {
		    	Chat.Screen("One or more spells still not known, macro still in Restricted mode.");
		    } // endif
		} // endif
	        break;

	    case "stam2health":
	    	var NewLvl = parseInt(dictSzValue("stam2health"));
	    	if (NewLvl == spellStamHealth) break;
	    	if (!Cast.Know(spellListStamHealth[NewLvl])) {
		    Chat.Screen("You do not know Stamina to Health " + NewLvl + "!");
		    skapi.SetControlProperty(szPanelConfig, "stam2health", "selected", 7-spellStamHealth);
		    break;
		} // endif
		spellStamHealth = NewLvl;
		SpellObj_StamHealth = skapi.SpellInfoFromSpellid(spellListStamHealth[spellStamHealth]);
	    	if (flagVerbose) Chat.Screen("Stamina to Health spell level set to " + spellStamHealth + ".");
	  	if (logDecal||debugDecal) Log.OutD("Stamina to Health spell level set to " + spellStamHealth);

	  	// If we are in Restricted mode due to not knowing spells at macro start, then see if
	  	// we now know all spells needed for proper macro operation
	  	if (Restricted) {
		    if (SpellCheck(false)) {
		    	Chat.Screen("All spells necessary for macro operation are now known, Restricted flag cleared.");
		    	Restricted = false;
		    } else {
		    	Chat.Screen("One or more spells still not known, macro still in Restricted mode.");
		    } // endif
		} // endif
	        break;

	    case "stam2mana":
	    	var NewLvl = parseInt(dictSzValue("stam2mana"));
	    	if (NewLvl == spellStamMana) break;
	    	if (!Cast.Know(spellListStamMana[NewLvl])) {
		    Chat.Screen("You do not know Stamina to Mana " + NewLvl + "!");
		    skapi.SetControlProperty(szPanelConfig, "stam2mana", "selected", 7-spellStamMana);
		    break;
		} // endif
		spellStamMana = NewLvl;
		SpellObj_StamMana = skapi.SpellInfoFromSpellid(spellListStamMana[spellStamMana]);
	    	if (flagVerbose) Chat.Screen("Stamina to Mana spell level set to " + spellStamMana + ".");
	  	if (logDecal||debugDecal) Log.OutD("Stamina to Mana spell level set to " + spellStamMana);

	  	// If we are in Restricted mode due to not knowing spells at macro start, then see if
	  	// we now know all spells needed for proper macro operation
	  	if (Restricted) {
		    if (SpellCheck(false)) {
		    	Chat.Screen("All spells necessary for macro operation are now known, Restricted flag cleared.");
		    	Restricted = false;
		    } else {
		    	Chat.Screen("One or more spells still not known, macro still in Restricted mode.");
		    } // endif
		} // endif
	        break;

	    case "revitSelf":
	    	var NewLvl = parseInt(dictSzValue("revitSelf"));
	    	if (NewLvl == spellRevitalize) break;
	    	if (!Cast.Know(spellListRevitalize[NewLvl])) {
		    Chat.Screen("You do not know Revitalize Self " + NewLvl + "!");
		    skapi.SetControlProperty(szPanelConfig, "revitSelf", "selected", 7-spellRevitalize);
		    break;
		} // endif
		spellRevitalize = NewLvl;
		SpellObj_Revitalize = skapi.SpellInfoFromSpellid(spellListRevitalize[spellRevitalize]);
	    	if (flagVerbose) Chat.Screen("Revitalize Self spell level set to " + spellRevitalize + ".");
	  	if (logDecal||debugDecal) Log.OutD("Revitalize Self spell level set to " + spellRevitalize);

	  	// If we are in Restricted mode due to not knowing spells at macro start, then see if
	  	// we now know all spells needed for proper macro operation
	  	if (Restricted) {
		    if (SpellCheck(false)) {
		    	Chat.Screen("All spells necessary for macro operation are now known, Restricted flag cleared.");
		    	Restricted = false;
		    } else {
		    	Chat.Screen("One or more spells still not known, macro still in Restricted mode.");
		    } // endif
		} // endif
	        break;

	    case "strengthSelf":
	    	var NewLvl = parseInt(dictSzValue("strengthSelf"));
	    	if (NewLvl == spellStrength) break;
	    	if (!Cast.Know(spellListStrength[NewLvl])) {
		    Chat.Screen("You do not know Strength Self " + NewLvl + "!");
		    skapi.SetControlProperty(szPanelConfig, "strengthSelf", "selected", 7-spellStrength);
		    break;
		} // endif
		spellStrength = NewLvl;
		SpellObj_Strength = skapi.SpellInfoFromSpellid(spellListStrength[spellStrength]);
	    	if (flagVerbose) Chat.Screen("Strength Self spell level set to " + spellStrength + ".");
	  	if (logDecal||debugDecal) Log.OutD("Strength Self spell level set to " + spellStrength);

	  	// If we are in Restricted mode due to not knowing spells at macro start, then see if
	  	// we now know all spells needed for proper macro operation
	  	if (Restricted) {
		    if (SpellCheck(false)) {
		    	Chat.Screen("All spells necessary for macro operation are now known, Restricted flag cleared.");
		    	Restricted = false;
		    } else {
		    	Chat.Screen("One or more spells still not known, macro still in Restricted mode.");
		    } // endif
		} // endif
	        break;

	    case "drainHealth":
	    	var NewLvl = parseInt(dictSzValue("drainHealth"));
	    	if (NewLvl == spellDrainHealth) break;
	    	if (!Cast.Know(spellListDrainHealth[NewLvl])) {
		    Chat.Screen("You do not know Drain Health " + NewLvl + "!");
		    skapi.SetControlProperty(szPanelConfig, "drainHealth", "selected", 7-spellDrainHealth);
		    break;
		} // endif
		spellDrainHealth = NewLvl;
		SpellObj_DrainHealth = skapi.SpellInfoFromSpellid(spellListDrainHealth[spellDrainHealth]);
	    	if (flagVerbose) Chat.Screen("Drain Health spell level set to " + spellDrainHealth + ".");
	  	if (logDecal||debugDecal) Log.OutD("Drain Health spell level set to " + spellDrainHealth);

	  	// If we are in Restricted mode due to not knowing spells at macro start, then see if
	  	// we now know all spells needed for proper macro operation
	  	if (Restricted) {
		    if (SpellCheck(false)) {
		    	Chat.Screen("All spells necessary for macro operation are now known, Restricted flag cleared.");
		    	Restricted = false;
		    } else {
		    	Chat.Screen("One or more spells still not known, macro still in Restricted mode.");
		    } // endif
		} // endif
	        break;

	    case "drainStamina":
	    	var NewLvl = parseInt(dictSzValue("drainStamina"));
	    	if (NewLvl == spellDrainStamina) break;
	    	if (!Cast.Know(spellListDrainStamina[NewLvl])) {
		    Chat.Screen("You do not know Drain Stamina " + NewLvl + "!");
		    skapi.SetControlProperty(szPanelConfig, "drainStamina", "selected", 7-spellDrainStamina);
		    break;
		} // endif
		spellDrainStamina = NewLvl;
		SpellObj_DrainStamina = skapi.SpellInfoFromSpellid(spellListDrainStamina[spellDrainStamina]);
	    	if (flagVerbose) Chat.Screen("Drain Stamina spell level set to " + spellDrainStamina + ".");
	  	if (logDecal||debugDecal) Log.OutD("Drain Stamina spell level set to " + spellDrainStamina);

	  	// If we are in Restricted mode due to not knowing spells at macro start, then see if
	  	// we now know all spells needed for proper macro operation
	  	if (Restricted) {
		    if (SpellCheck(false)) {
		    	Chat.Screen("All spells necessary for macro operation are now known, Restricted flag cleared.");
		    	Restricted = false;
		    } else {
		    	Chat.Screen("One or more spells still not known, macro still in Restricted mode.");
		    } // endif
		} // endif
	        break;

	    case "drainMana":
	    	var NewLvl = parseInt(dictSzValue("drainMana"));
	    	if (NewLvl == spellDrainMana) break;
	    	if (!Cast.Know(spellListDrainMana[NewLvl])) {
		    Chat.Screen("You do not know Drain Mana " + NewLvl + "!");
		    skapi.SetControlProperty(szPanelConfig, "drainMana", "selected", 7-spellDrainMana);
		    break;
		} // endif
		spellDrainMana = NewLvl;
		SpellObj_DrainMana = skapi.SpellInfoFromSpellid(spellListDrainMana[spellDrainMana]);
	    	if (flagVerbose) Chat.Screen("Drain Mana spell level set to " + spellDrainMana + ".");
	  	if (logDecal||debugDecal) Log.OutD("Drain Mana spell level set to " + spellDrainMana);

	  	// If we are in Restricted mode due to not knowing spells at macro start, then see if
	  	// we now know all spells needed for proper macro operation
	  	if (Restricted) {
		    if (SpellCheck(false)) {
		    	Chat.Screen("All spells necessary for macro operation are now known, Restricted flag cleared.");
		    	Restricted = false;
		    } else {
		    	Chat.Screen("One or more spells still not known, macro still in Restricted mode.");
		    } // endif
		} // endif
	        break;


	    // C(omponent) tab **************************************************

	    case "chkComps":
	    	flagCompCheck = !flagCompCheck
		skapi.SetControlProperty(szPanelConfig, "chkComps", "checked", flagCompCheck );
		if (flagCompCheck) {
		    if (flagVerbose) Chat.Screen("Component checking enabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Component checking enabled");
		} else {
		    if (flagVerbose) Chat.Screen("WARNING!!! Component checking disabled.", cmcYellow);
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Component checking disabled");
		} // endif
		break;

 	    case "chkCompLog":
 	    	flagCompLogOff = !flagCompLogOff;
		skapi.SetControlProperty(szPanelConfig, "chkCompLog", "checked", flagCompLogOff );
		if (flagCompLogOff) {
		    if (flagVerbose) Chat.Screen("Logoff when comps low enabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Logoff when comps low enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("Logoff when comps low disabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Logoff when comps low disabled.");
		} // endif
 	        break;

	    case "chkCompAssist":
 	    	flagCompAssist = !flagCompAssist;
		skapi.SetControlProperty(szPanelConfig, "chkCompAssist", "checked", flagCompAssist);
		if (flagCompAssist) {
		    if (flagVerbose) Chat.Screen("Request for comps when low enabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Request for comps when low enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("Request for comps when low disabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Request for comps when low disabled.");
		} // endif
 	        break;

	    case "chkCompRetreat":
 	    	flagCompRetreat = !flagCompRetreat;
		skapi.SetControlProperty(szPanelConfig, "chkCompRetreat", "checked", flagCompRetreat);
		if (flagCompRetreat) {
		    if (flagVerbose) Chat.Screen("Retreat when comps low enabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: RRetreat when comps low enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("Retreat when comps low disabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Retreat when comps low disabled.");
		} // endif
 	        break;

	    case "chkSplitPeas":
 	    	flagSplitPeas = !flagSplitPeas;
		skapi.SetControlProperty(szPanelConfig, "chkSplitPeas", "checked", flagSplitPeas);
		if (flagSplitPeas) {
		    if (flagVerbose) Chat.Screen("Pea splitting enabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Pea splitting enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("Pea splitting disabled.");
		    if (logDecal||debugDecal) Log.OutD("OnControlEvent: Pea splitting disabled.");
		} // endif
 	        break;

	    case "compChoice":
		// Update text for new comp selected
		var CompIndex = parseInt(dictSzValue("compChoice"));
		DisplayComp(CompIndex);
		break;

	    case "chkCompEnabled":
		var CompIndex = parseInt(dictSzValue("compChoice"));
		with (Comp.Info[CompIndex]) {
		    Enabled = !Enabled;
		    skapi.SetControlProperty(szPanelConfig, "chkCompEnabled", "checked", Enabled);
		} // end with
		break;

	    case "editComp1":
		szExp = dictSzValue("editComp1");
		if (isNaN(szExp) || (szExp == undefined) || (szExp == "")) {
		    Chat.Screen("Invalid number entered");
		    break;
		} // endif
		var CompIndex = parseInt(dictSzValue("compChoice"));
		intExp = parseInt(szExp);
		with (Comp.Info[CompIndex]) {
		    WarnLvl = intExp;
		    skapi.SetControlProperty(szPanelConfig, "textComp1v", "text", WarnLvl);
		} // end with
		break;

	    case "editComp2":
		szExp = dictSzValue("editComp2");
		if (isNaN(szExp) || (szExp == undefined) || (szExp == "")) {
		    Chat.Screen("Invalid number entered");
		    break;
		} // endif
		var CompIndex = parseInt(dictSzValue("compChoice"));
		intExp = parseInt(szExp);
		with (Comp.Info[CompIndex]) {
		    SplitLvl = intExp;
		    skapi.SetControlProperty(szPanelConfig, "textComp2v", "text", SplitLvl);
		} // end with
		break;

	    case "editComp3":
		szExp = dictSzValue("editComp3");
		if (isNaN(szExp) || (szExp == undefined) || (szExp == "")) {
		    Chat.Screen("Invalid number entered");
		    break;
		} // endif
		var CompIndex = parseInt(dictSzValue("compChoice"));
		intExp = parseInt(szExp);
		with (Comp.Info[CompIndex]) {
		    CritLvl = intExp;
		    skapi.SetControlProperty(szPanelConfig, "textComp3v", "text", CritLvl);
		} // end with
		break;

	    case "editComp4":
		szExp = dictSzValue("editComp4");
		if (isNaN(szExp) || (szExp == undefined) || (szExp == "")) {
		    Chat.Screen("Invalid number entered");
		    break;
		} // endif
		var CompIndex = parseInt(dictSzValue("compChoice"));
		intExp = parseInt(szExp);
		with (Comp.Info[CompIndex]) {
		    BuyLvl = intExp;
		    skapi.SetControlProperty(szPanelConfig, "textComp4v", "text", BuyLvl);
		} // end with
		break;

	    case "btnCompNext":
		var CompIndex = parseInt(dictSzValue("compChoice"));
		CompIndex++;
		if (CompIndex == Comp.Count) CompIndex = 0;
		skapi.SetControlProperty(szPanelConfig, "compChoice", "selected", CompIndex);
		break;

	    case "btnCompPrev":
		var CompIndex = parseInt(dictSzValue("compChoice"));
		if (CompIndex == 0) CompIndex = Comp.Count -1; else CompIndex--;
		skapi.SetControlProperty(szPanelConfig, "compChoice", "selected", CompIndex);
		break;

	    case "btnCompSetAs":
		var CompIndex = parseInt(dictSzValue("compChoice"));
		var PrevIndex = CompIndex;
		if (PrevIndex == 0) var PrevIndex = Comp.Count -1; else PrevIndex--;
		Comp.Info[CompIndex].Enabled  = Comp.Info[PrevIndex].Enabled;
		Comp.Info[CompIndex].WarnLvl  = Comp.Info[PrevIndex].WarnLvl;
		Comp.Info[CompIndex].SplitLvl = Comp.Info[PrevIndex].SplitLvl;
		Comp.Info[CompIndex].CritLvl  = Comp.Info[PrevIndex].CritLvl;
		DisplayComp(CompIndex);
		break;

	    case "btnCompReset":
		var CompIndex = parseInt(dictSzValue("compChoice"));
		Chat.Screen("Resetting comps...");
		Comp.Reset();
		DisplayComp(CompIndex);
		Chat.Screen("Component info reset.");
		break;

	    case "btnCompShow":
	        Header = false;
	        for (var x=0; x<Comp.Count; x++) {
		    if (Comp.Info[x].Enabled) {
		    	if (!Header) {
		    	    Header = true;
		    	    Chat.Screen(Util.Width("Comp",2.0)  + Util.Width("Warn Lvl",1.0) +
		    	    		Util.Width("Split Lvl",1.0) + Util.Width("Crit Lvl",1.0) + "Buy Lvl");
		    	} // endif
		        with (Comp.Info[x]) {
			    // Print info
			    Chat.Screen(Util.Width(Name,2.0)  + Util.Width(WarnLvl + " ",1.0) +
		    	    		Util.Width(SplitLvl + " ",1.0) + Util.Width(CritLvl + " ",1.0) + BuyLvl );
			} // end with
		    } // endif
		} // end for
		if (!Header) Chat.Screen("No comps being checked!");
		break;


	    // A(lert) tab **************************************************

	    case "chkTellAlert":
	    	alertTell = !alertTell;
		skapi.SetControlProperty(szPanelConfig, "chkTellAlert", "checked", alertTell);
		if (alertTell) {
		    if (flagVerbose) Chat.Screen("@Tell alert enabled.");
		    if (logDecal||debugDecal) Log.OutD("@Tell alert enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("@Tell alert disabled.");
		    if (logDecal||debugDecal) Log.OutD("@Tell alert disabled.");
		} // endif
		break;

	    case "chkAllegAlert":
	    	alertAlleg = !alertAlleg;
		skapi.SetControlProperty(szPanelConfig, "chkAllegAlert", "checked", alertAlleg);
		if (alertAlleg) {
		    if (flagVerbose) Chat.Screen("@Alleg alert enabled.");
		    if (logDecal||debugDecal) Log.OutD("@Alleg alert enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("@Alleg alert disabled.");
		    if (logDecal||debugDecal) Log.OutD("@Alleg alert disabled.");
		} // endif
		break;

	    case "chkDeathAlert":
	    	alertDeath = !alertDeath;
		skapi.SetControlProperty(szPanelConfig, "chkDeathAlert", "checked", alertDeath);
		if (alertDeath) {
		   if (flagVerbose)  Chat.Screen("Death alert enabled.");
		    if (logDecal||debugDecal) Log.OutD("Death alert enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("Death alert disabled.");
		    if (logDecal||debugDecal) Log.OutD("Death alert disabled.");
		} // endif
		break;

	    case "chkPlayerAlert":
	    	alertPlayer = !alertPlayer;
		skapi.SetControlProperty(szPanelConfig, "chkPlayerAlert", "checked", alertPlayer);
		if (alertPlayer) {
		    if (flagVerbose) Chat.Screen("Player alert enabled.");
		    if (logDecal||debugDecal) Log.OutD("Player alert enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("Player alert disabled.");
		    if (logDecal||debugDecal) Log.OutD("Player alert disabled.");
		} // endif
		break;

	    case "chkStealthAlert":
	    	alertStealth = !alertStealth;
		skapi.SetControlProperty(szPanelConfig, "chkStealthAlert", "checked", alertStealth);
		if (alertStealth) {
		    if (flagVerbose) Chat.Screen("Stealth alert enabled.");
		    if (logDecal||debugDecal) Log.OutD("Stealth alert enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("Stealth alert disabled.");
		    if (logDecal||debugDecal) Log.OutD("Stealth alert disabled.");
		} // endif
		break;

	    case "chkCompAlert":
	    	alertComps = !alertComps;
		skapi.SetControlProperty(szPanelConfig, "chkCompAlert", "checked", alertComps);
		if (alertComps) {
		    if (flagVerbose) Chat.Screen("Low component alert enabled.");
		    if (logDecal||debugDecal) Log.OutD("Low component alert enabled");
		} else {
		    if (flagVerbose) Chat.Screen("Low component alert disabled.");
		    if (logDecal||debugDecal) Log.OutD("Low component alert disabled.");
		} // endif
		break;

	    case "chkItemAlert":
	    	alertItem = !alertItem;
		skapi.SetControlProperty(szPanelConfig, "chkItemAlert", "checked", alertItem);
		if (alertItem) {
		    if (flagVerbose) Chat.Screen("Item alert enabled.");
		    if (logDecal||debugDecal) Log.OutD("Item alert enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("Item alert disabled.");
		    if (logDecal||debugDecal) Log.OutD("Item alert disabled.");
		} // endif
		break;

	    case "chkAbortAlert":
	    	alertAbort = !alertAbort;
		skapi.SetControlProperty(szPanelConfig, "chkAbortAlert", "checked", alertAbort);
		if (alertAbort) {
		    if (flagVerbose) Chat.Screen("Abort alert enabled.");
		    if (logDecal||debugDecal) Log.OutD("Abort alert enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("Abort alert disabled.");
		    if (logDecal||debugDecal) Log.OutD("Abort alert disabled.");
		} // endif
		break;

	    case "chkAdminAlert":
	    	alertAdmin = !alertAdmin;
		skapi.SetControlProperty(szPanelConfig, "chkAdminAlert", "checked", alertAdmin);
		if (alertAdmin) {
		    if (flagVerbose) Chat.Screen("Admin alert enabled.");
		    if (logDecal||debugDecal) Log.OutD("Admin alert enabled.");
		} else {
		    if (flagVerbose) Chat.Screen("Admin alert disabled.");
		    if (logDecal||debugDecal) Log.OutD("Admin alert disabled.");
		} // endif
		break;

    	    case "btnTestAdmin":
	    	alertAdminWav.Play();
	        break;


	    // D(ebug) config tab *************************

	    case "chkDebug":
		debug = !debug;
		skapi.SetControlProperty(szPanelControl, "chkDebug", "checked", debug);
		if (debug) {
		    if (flagVerbose) Chat.Screen("General debug info logging turned on.");
		    Log.OutD("General debug info logging turned on.");
		} else {
		    if (flagVerbose) Chat.Screen("General debug info logging turned off.");
		    Log.OutD("General debug info logging turned off.");
		} // endif
		break;

	    case "chkEvents":
	    	debugEvent = !debugEvent;
		skapi.SetControlProperty(szPanelControl, "chkEvents", "checked", debugEvent);
		if (debugEvent) {
		    if (flagVerbose) Chat.Screen("Event debug info logging turned on.");
		    Log.OutD("Event debug info logging turned on.");
		} else {
		    if (flagVerbose) Chat.Screen("Event debug info logging turned off.");
		    Log.OutD("Event debug info logging turned off.");
		} // endif
		break;

	    case "chkStateDebug":
		debugState = !debugState;
		skapi.SetControlProperty(szPanelControl, "chkStateDebug", "checked", debugState);
		if (debugState) {
		    if (flagVerbose) Chat.Screen("State debug info logging turned on.");
		    Log.OutD("State debug info logging turned on.");
		} else {
		    if (flagVerbose) Chat.Screen("State debug info logging turned off.");
		    Log.OutD("State debug info logging turned off.");
		} // endif
		break;

	    case "chkSelDebug":
		debugSelect = !debugSelect;
		skapi.SetControlProperty(szPanelControl, "chkSelDebug", "checked", debugSelect);
		if (debugSelect) {
		    if (flagVerbose) Chat.Screen("Select debug info logging turned on.");
		    Log.OutD("Select debug info logging turned on.");
		} else {
		    if (flagVerbose) Chat.Screen("Select debug info logging turned off.");
		    Log.OutD("Select debug info logging turned off.");
		} // endif
		break;

	    case "chkTarDebug":
		debugTarget = !debugTarget;
		skapi.SetControlProperty(szPanelControl, "chkTarDebug", "checked", debugTarget);
		if (debugTarget) {
		    if (flagVerbose) Chat.Screen("Targeting debug info logging turned on.");
		    Log.OutD("Targeting debug info logging turned on.");
		} else {
		    if (flagVerbose) Chat.Screen("Targeting debug info logging turned off.");
		    Log.OutD("Targeting debug info logging turned off.");
		} // endif
		break;

	    case "chkKillDebug":
		debugAttack = !debugAttack;
		skapi.SetControlProperty(szPanelControl, "chkKillDebug", "checked", debugAttack);
		if (debugAttack) {
		    if (flagVerbose) Chat.Screen("Kill debug info logging turned on.");
		    Log.OutD("Kill debug info logging turned on.");
		} else {
		    if (flagVerbose) Chat.Screen("Kill debug info logging turned off.");
		    Log.OutD("Kill debug info logging turned off.");
		} // endif
		break;

	    case "chkMoveDebug":
		debugMove = !debugMove;
		skapi.SetControlProperty(szPanelControl, "chkMoveDebug", "checked", debugMove);
		if (debugMove) {
		    if (flagVerbose) Chat.Screen("Move debug info logging turned on.");
		    Log.OutD("Move debug info logging turned on.");
		} else {
		    if (flagVerbose) Chat.Screen("Move debug info logging turned off.");
		    Log.OutD("Move debug info logging turned off.");
		} // endif
		break;

	    case "chkLootDebug":
		debugLoot = !debugLoot;
		skapi.SetControlProperty(szPanelControl, "chkLootDebug", "checked", debugLoot);
		if (debugLoot) {
		    if (flagVerbose) Chat.Screen("Loot debug info logging turned on.");
		    Log.OutD("Loot debug info logging turned on.");
		} else {
		    if (flagVerbose) Chat.Screen("Loot debug info logging turned off.");
		    Log.OutD("Loot debug info logging turned off.");
		} // endif
		break;

	    case "chkSalvageDebug":
		debugSalvage = !debugSalvage;
		skapi.SetControlProperty(szPanelControl, "chkSalvageDebug", "checked", debugSalvage);
		if (debugSalvage) {
		    if (flagVerbose) Chat.Screen("Salvage debug info logging turned on.");
		    Log.OutD("Salvage debug info logging turned on.");
		} else {
		    if (flagVerbose) Chat.Screen("Salvage debug info logging turned off.");
		    Log.OutD("Salvage debug info logging turned off.");
		} // endif
		break;

	    case "chkIdleDebug":
		debugIdle = !debugIdle;
		skapi.SetControlProperty(szPanelControl, "chkIdleDebug", "checked", debugIdle);
		if (debugIdle) {
		    if (flagVerbose) Chat.Screen("Idle debug info logging turned on.");
		    Log.OutD("Idle debug info logging turned on.");
		} else {
		    if (flagVerbose) Chat.Screen("Idle debug info logging turned off.");
		    Log.OutD("Idle debug info logging turned off.");
		} // endif
		break;

	    case "chkBuffDebug":
		debugBuffs = !debugBuffs;
		skapi.SetControlProperty(szPanelControl, "chkBuffDebug", "checked", debugBuffs);
		if (debugBuffs) {
		    Buff.SetDebug(true);
		    if (flagVerbose) Chat.Screen("Buff debug info logging turned on.");
		    Log.OutD("Buff debug info logging turned on.");
		} else {
		    Buff.SetDebug(false);
		    if (flagVerbose) Chat.Screen("Buff debug info logging turned off.");
		    Log.OutD("Buff debug info logging turned off.");
		} // endif
		break;

	    case "chkCastDebug":
		debugCast = !debugCast;
		skapi.SetControlProperty(szPanelControl, "chkCastDebug", "checked", debugCast);
		if (debugCast) {
		    Cast.SetDebug(true);
		    if (flagVerbose) Chat.Screen("Cast debug info logging turned on.");
		    Log.OutD("Cast debug info logging turned on.");
		} else {
		    Cast.SetDebug(false);
		    if (flagVerbose) Chat.Screen("Cast debug info logging turned off.");
		    Log.OutD("Cast debug info logging turned off.");
		} // endif
		break;

	} // end switch
	if (debugEvent||debugCmds) Log.OutD("Main_OnControlEvent: End, Config");
    	return;
    } // endif

    if (szPanel == szPanelMovement) {
    	// Process Movement Panel Controls

    	// Read value of 'curAttLoc' list since so many buttons below use this value
    	AttLocIndex = parseInt(dictSzValue("curAttLoc"));

	switch (szControl) {

	    // M(ovement)1 tab ************************************************

	    case "btnEval":
	    	Chat.Screen("Evaluating this location...");
		EvalLoc();
	        break;

	    case "btnCheckLoc":
		if (Player.MemberFellow()) {
		    Chat.Fellow("CHECKLOC [" + Util.FormatCoords(skapi.maplocCur,3) + "]");
	        } else {
	            Chat.Screen("You are not in a fellowship, nobody to check with!");
	        } // endif
	        break;

	    case "btnCreSum":
	    	Chat.Screen("Listing summary of all creatures nearby...");
		FindCreSummary();
	        break;

	    case "btnCreDetail":
	    	Chat.Screen("Detailed list of all creatures nearby...");
		FindCreDetail();
	        break;

	    case "curAttLoc":
	        // Display properties of attack loc selected.  Only one right now.
	        DisplayAttLoc(AttLocIndex);
	        break;

	    case "ShowAttLoc":
		ShowAttLoc(AttLocIndex);
		break;

	    case "btnKillSet":
	        if ((AttLocIndex>1) && (AttLoc[AttLocIndex-1].KillLoc == null)) {
		    Chat.Screen("Previous KillLoc not defined, can't set this one");
		    break;
		} // endif

		Chat.Screen("Kill location #" + AttLocIndex + " set to current coords.");
		AttLoc[AttLocIndex].KillLoc = skapi.maplocCur;
		HomeLoc = AttLoc[AttLocIndex].KillLoc;
		AttLocCur = AttLocIndex;
		if (AttLocIndex > AttLocCnt) AttLocCnt = AttLocIndex;
		break;

	    case "btnKillClear":
	        // Make sure at least one attack location always defined
	        if (AttLocCnt == 1) {
	            Chat.Screen("You must have at least one attack location defined! Delete aborted.");
	            break;
	        } // endif

	        // See if this attack location defined
	        if (AttLocIndex > AttLocCnt) {
	            Chat.Screen("Attack location #" + AttLocIndex + " not defined!");
	            break;
	        } // endif

	        // Clear out current attack location
		AttLoc[AttLocIndex] = new AttLocRec();

		// If the attack location deleted was last one defined then...
		if (AttLocIndex == AttLocCnt) {
		    if (AttLocCur == AttLocIndex) {
		    	AttLocCur = 1;
		    	HomeLoc = AttLoc[AttLocCur].KillLoc;
		    	Chat.Screen("Current attack location set to AttLoc #1");
		    } // endif
		    AttLocCnt--;
		    Chat.Screen("Attack location #" + AttLocIndex + " deleted!");
		    break;
		} // endif

		// This attack location was not at end so shift all AttLoc records down by 1
		Chat.Screen("Attack location #" + AttLocIndex + " deleted! Higher attlocs shifted down");
		for (var x=AttLocIndex; x<AttLocCnt; x++) AttLoc[x] = AttLoc[x+1];
		AttLocCnt--;

		// Now fix up the current attack location pointer.
		if (AttLocCur > AttLocIndex) {
		    // Pointed to one of the shifted records so just reduce it by 1
		    AttLocCur--;
		} else {
		    // Pointed to the current location so we need to pick a new one.  We use the next one
		    // in the list which because of the shift is now at the same index as record deleted
		    if (AttLocCur == AttLocIndex) {
			Chat.Screen("Current location deleted, active location set to next attloc.");
			HomeLoc = AttLoc[AttLocCur].KillLoc;
		    } // endif
		} // endif
		break;

	    case "btnRetreatSet":
	        if ((AttLocIndex>1) && (AttLoc[AttLocIndex-1].KillLoc == null)) {
		    Chat.Screen("Previous KillLoc not defined!");
		    break;
		} // endif
		AttLoc[AttLocIndex].RetreatLoc = skapi.maplocCur;
		Chat.Screen("Attloc # " + AttLocIndex + " retreat location set to current coords.");
		break;

	    case "btnRetreatClear":
	        if ((AttLocIndex>1) && (AttLoc[AttLocIndex-1].KillLoc == null)) {
		    Chat.Screen("Previous KillLoc not defined!");
		    break;
		} // endif
		AttLoc[AttLocIndex].RetreatLoc = null;
		Chat.Screen("Attloc # " + AttLocIndex + " retreat location cleared.");
		break;

	    case "btnWaySet":
	        if ((AttLocIndex>1) && (AttLoc[AttLocIndex-1].KillLoc == null)) {
		    Chat.Screen("Previous KillLoc not defined!");
		    break;
		} // endif
		AttLoc[AttLocIndex].WayLoc = skapi.maplocCur;
		Chat.Screen("Attloc # " + AttLocIndex + " waypoint set to current coords.");
		break;

	    case "btnWayClear":
	        if ((AttLocIndex>1) && (AttLoc[AttLocIndex-1].KillLoc == null)) {
		    Chat.Screen("Previous KillLoc not defined!");
		    break;
		} // endif
		AttLoc[AttLocIndex].WayLoc = null;
		Chat.Screen("Attloc #" + AttLocIndex + " waypoint cleared.");
		break;

	    case "chkSpawnAdvance":
	        if ((AttLocIndex>1) && (AttLoc[AttLocIndex-1].KillLoc == null)) {
		    Chat.Screen("Previous KillLoc not defined!");
		    break;
		} // endif

		with (AttLoc[AttLocIndex]) {
		    // If spawn advance flag set, then clear it, else set it
		    if (LocFlags & navFlagSpawnAdv) {
			LocFlags &= ~navFlagSpawnAdv;
			skapi.SetControlProperty(szPanelMovement, "chkSpawnAdvance", "checked", false);
		    } else {
			LocFlags |= navFlagSpawnAdv;
			skapi.SetControlProperty(szPanelMovement, "chkSpawnAdvance", "checked", true);
		    } // end if
		} // end with
		break;

	    case "btnMasterSet":
		MasterWayLoc = skapi.maplocCur;
		Chat.Screen("Master Waypoint set to current coords.");
		break;

	    case "btnMasterClear":
		MasterWayLoc = null;
		Chat.Screen("Master Waypoint cleared.");
		break;

	    case "btnGotoCurr":
		Chat.Screen("Moving to current kill location...");
		StateChange(stateGotoCurrent);
	        break;

	    case "btnGotoNext":
	        if (AttLocCnt == 1) {
	            Chat.Screen("Only one attack location defined!!!");
	        } else {
		    Chat.Screen("Moving to next attack location...");
		    StateChange(stateGotoNext);
		} // endif
	        break;

	    case "btnCancelNav":
	    	if ((State != stateGotoCurrent) && (State != stateGotoNext) && !NavActive) {
	    	    Chat.Screen("No active navigation!");
	    	} else {
		    Chat.Screen("Cancelling current navigation...");
		    skapi.CancelNav();
		} // endif
		break;

	    case "btnNavShow":
	    	NavShow();
	        break;

	    case "btnNavReset":
	        NavReset();
	        DisplayAttLoc(1);
	        break;

	    case "btnNavLoad":
	       	var FileNum = parseInt(dictSzValue("loadFile"));
	        NavLoad(FileNum);
	        break;

	    case "btnNavSave":
	       	var FileNum = parseInt(dictSzValue("saveFile"));
		NavSave(FileNum);
	        break;

	} // end switch
	if (debugEvent||debugCmds) Log.OutD("Main_OnControlEvent: End, Movement");
    	return;
    } // endif


    // BUFF PANEL **************************************************************************************************

    if (szPanel == szPanelBuffs) {
	// Process Buff Panel Controls
	switch (szControl) {
	    // Gen(eral) Buff Section *****************************

	    case "btnBuffLoad":
	       	var FileNum = parseInt(dictSzValue("loadBuff"));
	       	Chat.Screen("Loading buff configuration info...");
	        var Count = Buff.Load(FileNum);
	        if (Count < 0) {
	            Chat.Screen("File " + Buff.FileName + " not found!");
	            break;
	        } // endif
		DisplayBuffHerm();
		DisplayBuffDef();
		BuffIndex = parseInt(dictSzValue("creChoice"));
		DisplayBuffCre(BuffIndex);
		BuffIndex = parseInt(dictSzValue("lifeChoice"));
		DisplayBuffLife(BuffIndex);
		BuffIndex = parseInt(dictSzValue("armorChoice"));
		DisplayBuffArmor(BuffIndex);
	        Chat.Screen(Count + " active buffs read from file " + Buff.FileName);
	        break;

	    case "btnBuffSave":
	       	var FileNum = parseInt(dictSzValue("saveBuff"));
	       	Chat.Screen("Saving buff configuration info...");
		var SavedCount = Buff.Save(FileNum);
		Chat.Screen("Buff information saved.  " + SavedCount + " active buffs written to file " + Buff.FileName);
	        break;

	    case "btnBuffReset":
	        // Reset buffs to factory defaults
	        Chat.Screen("Resetting...");
	        Buff.Reset();
		DisplayBuffHerm();
		DisplayBuffDef();
		BuffIndex = parseInt(dictSzValue("creChoice"));
		DisplayBuffCre(BuffIndex);
		BuffIndex = parseInt(dictSzValue("lifeChoice"));
		DisplayBuffLife(BuffIndex);
		BuffIndex = parseInt(dictSzValue("armorChoice"));
		DisplayBuffArmor(BuffIndex);
		Chat.Screen("All buffs reset to default settings!");
	        break;

	    case "btnBuffShow":
	        if (!Buff.Show()) Chat.Screen("No buffs enabled!");
	        break;


	    // Cre(ature) Buff Section ****************************************************

    	    case "creChoice":
		// Update text for new buff selected
		BuffCrePrev = BuffCreIndex;
		BuffCreIndex = parseInt(dictSzValue("creChoice"));
		DisplayBuffCre(BuffCreIndex);
		break;

	    case "chkBuffCreEnab":
		var BuffIndex = parseInt(dictSzValue("creChoice"));
		var Level = Buff.Info[BuffIndex].Level;
		if (!Buff.Info[BuffIndex].Enabled && !Cast.Know(Buff.Info[BuffIndex].Self[Level])) {
		    Chat.Screen("You do not know " + Buff.Info[BuffIndex].Name + " Self " +
		    		Buff.Info[BuffIndex].Level + ", buff not enabled.");
		    skapi.SetControlProperty(szPanelBuffs, "chkBuffCreEnab", "checked", Buff.Info[BuffIndex].Enabled);
		    break;
		} // endif
		Buff.Info[BuffIndex].Enabled = !Buff.Info[BuffIndex].Enabled;
		skapi.SetControlProperty(szPanelBuffs, "chkBuffCreEnab", "checked", Buff.Info[BuffIndex].Enabled);
		BuffCreLast = BuffIndex;
		break;

	    case "chkBuffCreRandom":
		var BuffIndex = parseInt(dictSzValue("creChoice"));
		Buff.Info[BuffIndex].Randomize = !Buff.Info[BuffIndex].Randomize;
		skapi.SetControlProperty(szPanelBuffs, "chkBuffCreRandom", "checked", Buff.Info[BuffIndex].Randomize);
		BuffCreLast = BuffIndex;
		break;

	    case "choiceBuff2b":
		var BuffIndex = parseInt(dictSzValue("creChoice"));
		var BuffLevel = parseInt(dictSzValue("choiceBuff2b"));
		if (BuffLevel == Buff.Info[BuffIndex].Level) break;
	    	if (!Cast.Know(Buff.Info[BuffIndex].Self[BuffLevel])) {
		    Chat.Screen("WARNING!!! You do not know " + Buff.Info[BuffIndex].Name + " Self " + BuffLevel + ".");
		    if (Buff.Info[BuffIndex].Enabled) {
			Chat.Screen("WARNING!!! Buff disabled");
			Buff.Info[BuffIndex].Enabled = false;
			skapi.SetControlProperty(szPanelBuffs, "chkBuffCreEnab", "checked", false);
		    } // endif
		} // endif
		Buff.Info[BuffIndex].SpellObj = skapi.SpellInfoFromSpellid(Buff.Info[BuffIndex].Self[BuffLevel]);
		Buff.Info[BuffIndex].Level = BuffLevel;
		BuffCreLast = BuffIndex;
		break;

	    case "editBuff2c":
		szExp = dictSzValue("editBuff2c");
		if (isNaN(szExp) || (szExp == undefined) || (szExp == "")) {
		    Chat.Screen("Invalid number entered");
		    break;
		} // endif
		var BuffIndex = parseInt(dictSzValue("creChoice"));
		intExp = parseInt(szExp);
		Buff.Info[BuffIndex].Safety = intExp*1000;
		skapi.SetControlProperty(szPanelBuffs, "text2cv", "text", intExp);
		BuffCreLast = BuffIndex;
		break;

	    case "editBuff2d":
		szExp = dictSzValue("editBuff2d");
		if (isNaN(szExp) || (szExp == undefined) || (szExp == "")) {
		    Chat.Screen("Invalid number entered");
		    break;
		} // endif
		var BuffIndex = parseInt(dictSzValue("creChoice"));
		intExp = parseInt(szExp);
		Buff.Info[BuffIndex].Priority = intExp;
		skapi.SetControlProperty(szPanelBuffs, "text2dv", "text", intExp);
		BuffCreLast = BuffIndex;
		break;

	    case "btnBuffCreNext":
		var BuffIndex = parseInt(dictSzValue("creChoice"));
		BuffIndex++;
		if (BuffIndex > Buff.Range[buffTypeCre].End) BuffIndex = Buff.Range[buffTypeCre].Begin;
		skapi.SetControlProperty(szPanelBuffs, "creChoice", "selected", BuffIndex-Buff.Range[buffTypeCre].Begin);
		break;

	    case "btnBuffCrePrev":
		var BuffIndex = parseInt(dictSzValue("creChoice"));
		if (BuffIndex == Buff.Range[buffTypeCre].Begin)
		    BuffIndex = Buff.Range[buffTypeCre].End;
		else
		    BuffIndex--;
		skapi.SetControlProperty(szPanelBuffs, "creChoice", "selected", BuffIndex-Buff.Range[buffTypeCre].Begin);
		break;

	    case "btnBuffCreSetPrev":
		var BuffIndex = parseInt(dictSzValue("creChoice"));
		if (BuffIndex == BuffCrePrev) {
		    Chat.Screen("Previous examined creature buff is same as current, aborted.");
		    break;
		} // endif
		Buff.Info[BuffIndex].Enabled	= Buff.Info[BuffCrePrev].Enabled;
		Buff.Info[BuffIndex].Level	= Buff.Info[BuffCrePrev].Level;
		Buff.Info[BuffIndex].Randomize	= Buff.Info[BuffCrePrev].Randomize;
		Buff.Info[BuffIndex].Safety	= Buff.Info[BuffCrePrev].Safety;
		Buff.Info[BuffIndex].SpellObj	=
		    skapi.SpellInfoFromSpellid(Buff.Info[BuffIndex].Self[Buff.Info[BuffIndex].Level]);

	    	if ((Buff.Info[BuffIndex].Enabled) &&
		    (!Cast.Know(Buff.Info[BuffIndex].Self[Buff.Info[BuffIndex].Level]))) {
		    Chat.Screen("You do not know " + Buff.Info[BuffIndex].Name + " Self " +
		    		Buff.Info[BuffIndex].Level + ", buff disabled.");
		    Buff.Info[BuffIndex].Enabled = false;
		} // endif
		DisplayBuffCre(BuffIndex);
		BuffCreLast = BuffIndex;
		if (flagVerbose) Chat.Screen("Current buff set same as previous creature buff examined.");
		break;

	    case "btnBuffCreSetLast":
	        if (BuffCreLast < 0)  {
		    Chat.Screen("No creature buffs modified since macro start, can't set as last modified!");
		    break;
		} // endif
		var BuffIndex = parseInt(dictSzValue("creChoice"));
		if (BuffIndex == BuffCreLast) {
		    Chat.Screen("Last modified creature buff is same as current, aborted.");
		    break;
		} // endif

		Buff.Info[BuffIndex].Enabled	= Buff.Info[BuffCreLast].Enabled;
		Buff.Info[BuffIndex].Level	= Buff.Info[BuffCreLast].Level;
		Buff.Info[BuffIndex].Randomize	= Buff.Info[BuffCreLast].Randomize;
		Buff.Info[BuffIndex].Safety	= Buff.Info[BuffCreLast].Safety;
		Buff.Info[BuffIndex].SpellObj	=
		    skapi.SpellInfoFromSpellid(Buff.Info[BuffIndex].Self[Buff.Info[BuffIndex].Level]);

	    	if ((Buff.Info[BuffIndex].Enabled) &&
		    (!Cast.Know(Buff.Info[BuffIndex].Self[Buff.Info[BuffIndex].Level]))) {
		    Chat.Screen("You do not know " + Buff.Info[BuffIndex].Name + " Self " +
		    		Buff.Info[BuffIndex].Level + ", buff disabled.");
		    Buff.Info[BuffIndex].Enabled = false;
		} // endif
		DisplayBuffCre(BuffIndex);
		BuffCreLast = BuffIndex;
		if (flagVerbose) Chat.Screen("Current buff set same as last modified creature buff.");
		break;

	    case "btnBuffCreAll":
		var BuffIndex = parseInt(dictSzValue("creChoice"));
		for (var x=Buff.Range[buffTypeCre].Begin; x<=Buff.Range[buffTypeCre].End; x++) {
		    if (x == BuffIndex) continue;
		    Buff.Info[x].Enabled    = Buff.Info[BuffIndex].Enabled;
		    Buff.Info[x].Level	    = Buff.Info[BuffIndex].Level;
		    Buff.Info[x].Randomize  = Buff.Info[BuffIndex].Randomize;
		    Buff.Info[x].Safety	    = Buff.Info[BuffIndex].Safety;
		    Buff.Info[x].SpellObj   = skapi.SpellInfoFromSpellid(Buff.Info[x].Self[Buff.Info[x].Level]);

		    if ((Buff.Info[x].Enabled) &&
			(!Cast.Know(Buff.Info[x].Self[Buff.Info[x].Level]))) {
			Chat.Screen("You do not know " + Buff.Info[x].Name + " Self " +
		    		Buff.Info[x].Level + ", buff disabled.");
			Buff.Info[x].Enabled = false;
		    } // endif
		} // endfor
		if (flagVerbose) Chat.Screen("All creature buffs set like this one.");
		break;

	    case "btnBuffCreShow":
		if (!Buff.Show(buffTypeCre)) Chat.Screen("No creature buffs enabled!");
		break;

	    // Life Buff Section ****************************************************

    	    case "lifeChoice":
		// Update text for new buff selected
		BuffLifePrev = BuffLifeIndex;
		BuffLifeIndex = parseInt(dictSzValue("lifeChoice"));
		DisplayBuffLife(BuffLifeIndex);
		break;

	    case "chkBuffLifeEnab":
		var BuffIndex = parseInt(dictSzValue("lifeChoice"));
		var Level = Buff.Info[BuffIndex].Level;
		if (!Buff.Info[BuffIndex].Enabled && !Cast.Know(Buff.Info[BuffIndex].Self[Level])) {
		    Chat.Screen("You do not know " + Buff.Info[BuffIndex].Name + " Self " +
		    		Buff.Info[BuffIndex].Level + ", buff not enabled.");
		    skapi.SetControlProperty(szPanelBuffs, "chkBuffLifeEnab", "checked", Buff.Info[BuffIndex].Enabled);
		    break;
		} // endif
		Buff.Info[BuffIndex].Enabled = !Buff.Info[BuffIndex].Enabled;
		skapi.SetControlProperty(szPanelBuffs, "chkBuffLifeEnab", "checked", Buff.Info[BuffIndex].Enabled);
		BuffLifeLast = BuffIndex;
		break;

	    case "chkBuffLifeRandom":
		var BuffIndex = parseInt(dictSzValue("lifeChoice"));
		Buff.Info[BuffIndex].Randomize = !Buff.Info[BuffIndex].Randomize;
		skapi.SetControlProperty(szPanelBuffs, "chkBuffLifeRandom", "checked", Buff.Info[BuffIndex].Randomize);
		BuffLifeLast = BuffIndex;
		break;

	    case "choiceBuff3b":
		var BuffIndex = parseInt(dictSzValue("lifeChoice"));
		var BuffLevel = parseInt(dictSzValue("choiceBuff3b"));
		if (BuffLevel == Buff.Info[BuffIndex].Level) break;
	    	if (!Cast.Know(Buff.Info[BuffIndex].Self[BuffLevel])) {
		    Chat.Screen("WARNING!!! You do not know " + Buff.Info[BuffIndex].Name + " Self " + BuffLevel + ".");
		    if (Buff.Info[BuffIndex].Enabled) {
			Chat.Screen("WARNING!!! Buff disabled!");
			Buff.Info[BuffIndex].Enabled = false;
			skapi.SetControlProperty(szPanelBuffs, "chkBuffLifeEnab", "checked", false);
		    } // endif
		} // endif
		Buff.Info[BuffIndex].SpellObj = skapi.SpellInfoFromSpellid(Buff.Info[BuffIndex].Self[BuffLevel]);
		Buff.Info[BuffIndex].Level = BuffLevel;
		BuffLifeLast = BuffIndex;
		break;

	    case "editBuff3c":
		szExp = dictSzValue("editBuff3c");
		if (isNaN(szExp) || (szExp == undefined) || (szExp == "")) {
		    Chat.Screen("Invalid number entered");
		    break;
		} // endif
		var BuffIndex = parseInt(dictSzValue("lifeChoice"));
		intExp = parseInt(szExp);
		Buff.Info[BuffIndex].Safety = intExp*1000;
		skapi.SetControlProperty(szPanelBuffs, "text3cv", "text", intExp);
		BuffLifeLast = BuffIndex;
		break;

	    case "editBuff3d":
		szExp = dictSzValue("editBuff3d");
		if (isNaN(szExp) || (szExp == undefined) || (szExp == "")) {
		    Chat.Screen("Invalid number entered");
		    break;
		} // endif
		var BuffIndex = parseInt(dictSzValue("lifeChoice"));
		intExp = parseInt(szExp);
		Buff.Info[BuffIndex].Priority = intExp;
		skapi.SetControlProperty(szPanelBuffs, "text3dv", "text", intExp);
		BuffLifeLast = BuffIndex;
		break;

	    case "btnBuffLifeNext":
		var BuffIndex = parseInt(dictSzValue("lifeChoice"));
		BuffIndex++;
		if (BuffIndex > Buff.Range[buffTypeLife].End) BuffIndex = Buff.Range[buffTypeLife].Begin;
		skapi.SetControlProperty(szPanelBuffs, "lifeChoice", "selected", BuffIndex-Buff.Range[buffTypeLife].Begin);
		break;

	    case "btnBuffLifePrev":
		var BuffIndex = parseInt(dictSzValue("lifeChoice"));
		if (BuffIndex == Buff.Range[buffTypeLife].Begin)
		    BuffIndex = Buff.Range[buffTypeLife].End;
		else
		    BuffIndex--;
		skapi.SetControlProperty(szPanelBuffs, "lifeChoice", "selected", BuffIndex-Buff.Range[buffTypeLife].Begin);
		break;

	    case "btnBuffLifeSetPrev":
		var BuffIndex = parseInt(dictSzValue("lifeChoice"));
		if (BuffIndex == BuffLifePrev) {
		    Chat.Screen("Previous examined buff is same as current, aborted.");
		    break;
		} // endif
		Buff.Info[BuffIndex].Enabled	= Buff.Info[BuffLifePrev].Enabled;
		Buff.Info[BuffIndex].Level	= Buff.Info[BuffLifePrev].Level;
		Buff.Info[BuffIndex].Randomize	= Buff.Info[BuffLifePrev].Randomize;
		Buff.Info[BuffIndex].Safety	= Buff.Info[BuffLifePrev].Safety;
		Buff.Info[BuffIndex].SpellObj	=
		    skapi.SpellInfoFromSpellid(Buff.Info[BuffIndex].Self[Buff.Info[BuffIndex].Level]);

	    	if ((Buff.Info[BuffIndex].Enabled) &&
		    (!Cast.Know(Buff.Info[BuffIndex].Self[Buff.Info[BuffIndex].Level]))) {
		    Chat.Screen("You do not know " + Buff.Info[BuffIndex].Name + " Self " +
		    		Buff.Info[BuffIndex].Level + ", buff disabled.");
		    Buff.Info[BuffIndex].Enabled = false;
		} // endif
		DisplayBuffLife(BuffIndex);
		BuffLifeLast = BuffIndex;
		if (flagVerbose) Chat.Screen("Current buff set same as previous life buff examined.");
		break;

	    case "btnBuffLifeSetLast":
	        if (BuffLifeLast < 0)  {
		    Chat.Screen("No life buffs modified since macro start, can't set as last modified!");
		    break;
		} // endif

		var BuffIndex = parseInt(dictSzValue("lifeChoice"));
		if (BuffIndex == BuffLifeLast) {
		    Chat.Screen("Last modified life buff is same as current, aborted.");
		    break;
		} // endif

		Buff.Info[BuffIndex].Enabled	= Buff.Info[BuffLifeLast].Enabled;
		Buff.Info[BuffIndex].Level	= Buff.Info[BuffLifeLast].Level;
		Buff.Info[BuffIndex].Randomize	= Buff.Info[BuffLifeLast].Randomize;
		Buff.Info[BuffIndex].Safety	= Buff.Info[BuffLifeLast].Safety;
		Buff.Info[BuffIndex].SpellObj	=
		    skapi.SpellInfoFromSpellid(Buff.Info[BuffIndex].Self[Buff.Info[BuffIndex].Level]);

	    	if ((Buff.Info[BuffIndex].Enabled) &&
		    (!Cast.Know(Buff.Info[BuffIndex].Self[Buff.Info[BuffIndex].Level]))) {
		    Chat.Screen("You do not know " + Buff.Info[BuffIndex].Name + " Self " +
		    		Buff.Info[BuffIndex].Level + ", buff disabled.");
		    Buff.Info[BuffIndex].Enabled = false;
		} // endif
		DisplayBuffLife(BuffIndex);
		BuffLifeLast = BuffIndex;
		if (flagVerbose) Chat.Screen("Current buff set same as last life buff modified.");
		break;

	    case "btnBuffLifeAll":
		var BuffIndex = parseInt(dictSzValue("lifeChoice"));
		for (var x=Buff.Range[buffTypeLife].Begin; x<=Buff.Range[buffTypeLife].End; x++) {
		    if (x == BuffIndex) continue;
		    Buff.Info[x].Enabled    = Buff.Info[BuffIndex].Enabled;
		    Buff.Info[x].Level	    = Buff.Info[BuffIndex].Level;
		    Buff.Info[x].Randomize  = Buff.Info[BuffIndex].Randomize;
		    Buff.Info[x].Safety	    = Buff.Info[BuffIndex].Safety;
		    Buff.Info[x].SpellObj   = skapi.SpellInfoFromSpellid(Buff.Info[x].Self[Buff.Info[x].Level]);

		    if ((Buff.Info[x].Enabled) &&
			(!Cast.Know(Buff.Info[x].Self[Buff.Info[x].Level]))) {
			Chat.Screen("You do not know " + Buff.Info[x].Name + " Self " +
		    		Buff.Info[x].Level + ", buff disabled.");
			Buff.Info[x].Enabled = false;
		    } // endif
		} // endfor
		if (flagVerbose) Chat.Screen("All life buffs set like this one.");
		break;

	    case "btnBuffLifeShow":
		if (!Buff.Show(buffTypeLife)) Chat.Screen("No life buffs enabled!");
		break;

	    // Armor Buff Section ****************************************************

    	    case "armorChoice":
		// Update text for new buff selected
		BuffArmorPrev = BuffArmorIndex;
		BuffArmorIndex = parseInt(dictSzValue("armorChoice"));
		DisplayBuffArmor(BuffArmorIndex);
		break;

	    case "chkBuffArmorEnab":
		var BuffIndex = parseInt(dictSzValue("armorChoice"));
		var Level = Buff.Info[BuffIndex].Level;
		if (!Buff.Info[BuffIndex].Enabled && !Cast.Know(Buff.Info[BuffIndex].Self[Level])) {
		    Chat.Screen("You do not know " + Buff.Info[BuffIndex].Name + " Self " +
		    		Buff.Info[BuffIndex].Level + ", buff not enabled.");
		    skapi.SetControlProperty(szPanelBuffs, "chkBuffArmorEnab", "checked", Buff.Info[BuffIndex].Enabled);
		    break;
		} // endif
		Buff.Info[BuffIndex].Enabled = !Buff.Info[BuffIndex].Enabled;
		skapi.SetControlProperty(szPanelBuffs, "chkBuffArmorEnab", "checked", Buff.Info[BuffIndex].Enabled);
		BuffArmorLast = BuffIndex;
		break;

	    case "chkBuffArmorRandom":
		var BuffIndex = parseInt(dictSzValue("armorChoice"));
		Buff.Info[BuffIndex].Randomize = !Buff.Info[BuffIndex].Randomize;
		skapi.SetControlProperty(szPanelBuffs, "chkBuffArmorRandom", "checked", Buff.Info[BuffIndex].Randomize);
		BuffArmorLast = BuffIndex;
		break;

	    case "choiceBuff4b":
		var BuffIndex = parseInt(dictSzValue("armorChoice"));
		var BuffLevel = parseInt(dictSzValue("choiceBuff4b"));
		if (BuffLevel == Buff.Info[BuffIndex].Level) break;
	    	if (!Cast.Know(Buff.Info[BuffIndex].Self[BuffLevel])) {
		    Chat.Screen("WARNING!!! You do not know " + Buff.Info[BuffIndex].Name + " Self " + BuffLevel + ".");
		    if (Buff.Info[BuffIndex].Enabled) {
			Chat.Screen("WARNING!!! Buff disabled!");
			Buff.Info[BuffIndex].Enabled = false;
			skapi.SetControlProperty(szPanelBuffs, "chkBuffArmorEnab", "checked", false);
		    } // endif
		} // endif
		Buff.Info[BuffIndex].SpellObj = skapi.SpellInfoFromSpellid(Buff.Info[BuffIndex].Self[BuffLevel]);
		Buff.Info[BuffIndex].Level = BuffLevel;
		BuffArmorLast = BuffIndex;
		break;

	    case "editBuff4c":
		szExp = dictSzValue("editBuff4c");
		if (isNaN(szExp) || (szExp == undefined) || (szExp == "")) {
		    Chat.Screen("Invalid number entered");
		    break;
		} // endif
		var BuffIndex = parseInt(dictSzValue("armorChoice"));
		intExp = parseInt(szExp);
		Buff.Info[BuffIndex].Safety = intExp*1000;
		skapi.SetControlProperty(szPanelBuffs, "text4cv", "text", Buff.Info[BuffIndex].Safety/1000);
		BuffArmorLast = BuffIndex;
		break;

	    case "editBuff4d":
		szExp = dictSzValue("editBuff4d");
		if (isNaN(szExp) || (szExp == undefined) || (szExp == "")) {
		    Chat.Screen("Invalid number entered");
		    break;
		} // endif
		var BuffIndex = parseInt(dictSzValue("armorChoice"));
		intExp = parseInt(szExp);
		Buff.Info[BuffIndex].Priority = intExp;
		skapi.SetControlProperty(szPanelBuffs, "text4dv", "text", Buff.Info[BuffIndex].Priority);
		BuffArmorLast = BuffIndex;
		break;

	    case "chkPaperDoll":
		var BuffIndex = parseInt(dictSzValue("armorChoice"));
		if (Buff.Info[BuffIndex].Eqm & eqmPaperDoll) {
		    Buff.Info[BuffIndex].Eqm &= ~eqmPaperDoll;
		} else {
		    Buff.Info[BuffIndex].Eqm |= eqmPaperDoll;
		} // endif
		skapi.SetControlProperty(szPanelBuffs, "chkPaperDoll", "checked", 
					 (Buff.Info[BuffIndex].Eqm & eqmPaperDoll));
		BuffArmorLast = BuffIndex;
		break;

	    case "chkBuffHead":
		var BuffIndex = parseInt(dictSzValue("armorChoice"));
		if (Buff.Info[BuffIndex].Eqm & eqmHead) {
		    Buff.Info[BuffIndex].Eqm &= ~eqmHead;
		} else {
		    Buff.Info[BuffIndex].Eqm |= eqmHead;
		} // endif
		skapi.SetControlProperty(szPanelBuffs, "chkBuffHead", "checked", (Buff.Info[BuffIndex].Eqm & eqmHead));
		BuffArmorLast = BuffIndex;
		break;

	    case "chkBuffHands":
		var BuffIndex = parseInt(dictSzValue("armorChoice"));
		if (Buff.Info[BuffIndex].Eqm & eqmHands) {
		    Buff.Info[BuffIndex].Eqm &= ~eqmHands;
		} else {
		    Buff.Info[BuffIndex].Eqm |= eqmHands;
		} // endif
		skapi.SetControlProperty(szPanelBuffs, "chkBuffHands", "checked", (Buff.Info[BuffIndex].Eqm & eqmHands));
		BuffArmorLast = BuffIndex;
		break;

	    case "chkBuffFeet":
		var BuffIndex = parseInt(dictSzValue("armorChoice"));
		if (Buff.Info[BuffIndex].Eqm & eqmFeet) {
		    Buff.Info[BuffIndex].Eqm &= ~eqmFeet;
		} else {
		    Buff.Info[BuffIndex].Eqm |= eqmFeet;
		} // endif
		skapi.SetControlProperty(szPanelBuffs, "chkBuffFeet", "checked", (Buff.Info[BuffIndex].Eqm & eqmFeet));
		BuffArmorLast = BuffIndex;
		break;

	    case "chkBuffChest":
		var BuffIndex = parseInt(dictSzValue("armorChoice"));
		if (Buff.Info[BuffIndex].Eqm & eqmChestOuter) {
		    Buff.Info[BuffIndex].Eqm &= ~eqmChestOuter;
		} else {
		    Buff.Info[BuffIndex].Eqm |= eqmChestOuter;
		} // endif
		skapi.SetControlProperty(szPanelBuffs, "chkBuffChest", "checked",
		    	(Buff.Info[BuffIndex].Eqm & eqmChestOuter));
		BuffArmorLast = BuffIndex;
		break;

	    case "chkBuffUpArms":
		var BuffIndex = parseInt(dictSzValue("armorChoice"));
		if (Buff.Info[BuffIndex].Eqm & eqmUpperArmsOuter) {
		    Buff.Info[BuffIndex].Eqm &= ~eqmUpperArmsOuter;
		} else {
		    Buff.Info[BuffIndex].Eqm |= eqmUpperArmsOuter;
		} // endif
		skapi.SetControlProperty(szPanelBuffs, "chkBuffUpArms", "checked",
		    (Buff.Info[BuffIndex].Eqm & eqmUpperArmsOuter));
		BuffArmorLast = BuffIndex;
		break;

	    case "chkBuffLowArms":
		var BuffIndex = parseInt(dictSzValue("armorChoice"));
		if (Buff.Info[BuffIndex].Eqm & eqmLowerArmsOuter) {
		    Buff.Info[BuffIndex].Eqm &= ~eqmLowerArmsOuter;
		} else {
		    Buff.Info[BuffIndex].Eqm |= eqmLowerArmsOuter;
		} // endif
		skapi.SetControlProperty(szPanelBuffs, "chkBuffLowArms", "checked",
		    (Buff.Info[BuffIndex].Eqm & eqmLowerArmsOuter));
		BuffArmorLast = BuffIndex;
		break;

	    case "chkBuffAbdomen":
		var BuffIndex = parseInt(dictSzValue("armorChoice"));
		if (Buff.Info[BuffIndex].Eqm & eqmAbdomenOuter) {
		    Buff.Info[BuffIndex].Eqm &= ~eqmAbdomenOuter;
		} else {
		    Buff.Info[BuffIndex].Eqm |= eqmAbdomenOuter;
		} // endif
		skapi.SetControlProperty(szPanelBuffs, "chkBuffAbdomen", "checked",
		    (Buff.Info[BuffIndex].Eqm & eqmAbdomenOuter));
		BuffArmorLast = BuffIndex;
		break;

	    case "chkBuffUpLegs":
		var BuffIndex = parseInt(dictSzValue("armorChoice"));
		if (Buff.Info[BuffIndex].Eqm & eqmUpperLegsOuter) {
		    Buff.Info[BuffIndex].Eqm &= ~eqmUpperLegsOuter;
		} else {
		    Buff.Info[BuffIndex].Eqm |= eqmUpperLegsOuter;
		} // endif
		skapi.SetControlProperty(szPanelBuffs, "chkBuffUpLegs", "checked",
		    (Buff.Info[BuffIndex].Eqm & eqmUpperLegsOuter));
		BuffArmorLast = BuffIndex;
		break;

	    case "chkBuffLowLegs":
		var BuffIndex = parseInt(dictSzValue("armorChoice"));
		if (Buff.Info[BuffIndex].Eqm & eqmLowerLegsOuter) {
		    Buff.Info[BuffIndex].Eqm &= ~eqmLowerLegsOuter;
		} else {
		    Buff.Info[BuffIndex].Eqm |= eqmLowerLegsOuter;
		} // endif
		skapi.SetControlProperty(szPanelBuffs, "chkBuffLowLegs", "checked",
		    (Buff.Info[BuffIndex].Eqm & eqmLowerLegsOuter));
		BuffArmorLast = BuffIndex;
		break;

	    case "chkBuffShirt":
		var BuffIndex = parseInt(dictSzValue("armorChoice"));
		if (Buff.Info[BuffIndex].Eqm & eqmChestUnder) {
		    Buff.Info[BuffIndex].Eqm &= ~eqmChestUnder;
		} else {
		    Buff.Info[BuffIndex].Eqm |= eqmChestUnder;
		} // endif
		skapi.SetControlProperty(szPanelBuffs, "chkBuffShirt", "checked",
		    (Buff.Info[BuffIndex].Eqm & eqmChestUnder));
		BuffArmorLast = BuffIndex;
		break;

	    case "chkBuffPants":
		var BuffIndex = parseInt(dictSzValue("armorChoice"));
		if (Buff.Info[BuffIndex].Eqm & eqmUpperLegsUnder) {
		    Buff.Info[BuffIndex].Eqm &= ~eqmUpperLegsUnder;
		} else {
		    Buff.Info[BuffIndex].Eqm |= eqmUpperLegsUnder;
		} // endif
		skapi.SetControlProperty(szPanelBuffs, "chkBuffPants", "checked",
		    (Buff.Info[BuffIndex].Eqm & eqmUpperLegsUnder));
		BuffArmorLast = BuffIndex;
		break;

	    case "btnBuffArmorNext":
		var BuffIndex = parseInt(dictSzValue("armorChoice"));
		BuffIndex++;
		if (BuffIndex > Buff.ClassRange[equipClassArmor].End) BuffIndex = Buff.ClassRange[equipClassArmor].Begin;
		skapi.SetControlProperty(szPanelBuffs, "armorChoice", "selected",
		    BuffIndex-Buff.Range[buffTypeItem].Begin);
		break;

	    case "btnBuffArmorPrev":
		var BuffIndex = parseInt(dictSzValue("armorChoice"));
		BuffIndex--;
		if (BuffIndex < Buff.ClassRange[equipClassArmor].Begin) BuffIndex = Buff.ClassRange[equipClassArmor].End;  
		skapi.SetControlProperty(szPanelBuffs, "armorChoice", "selected",
		    BuffIndex-Buff.Range[buffTypeItem].Begin);
		break;

	    case "btnBuffArmorSetPrev":
		var BuffIndex = parseInt(dictSzValue("armorChoice"));
		if (BuffIndex == BuffArmorPrev) {
		    Chat.Screen("Previous examined armor buff is same as current, aborted.");
		    break;
		} // endif
		Buff.Info[BuffIndex].Enabled	= Buff.Info[BuffArmorPrev].Enabled;
		Buff.Info[BuffIndex].Level	= Buff.Info[BuffArmorPrev].Level;
		Buff.Info[BuffIndex].Randomize	= Buff.Info[BuffArmorPrev].Randomize;
		Buff.Info[BuffIndex].Safety	= Buff.Info[BuffArmorPrev].Safety;
		Buff.Info[BuffIndex].Eqm	= Buff.Info[BuffArmorPrev].Eqm;
		Buff.Info[BuffIndex].SpellObj	=
		    skapi.SpellInfoFromSpellid(Buff.Info[BuffIndex].Self[Buff.Info[BuffIndex].Level]);

	    	if ((Buff.Info[BuffIndex].Enabled) &&
		    (!Cast.Know(Buff.Info[BuffIndex].Self[Buff.Info[BuffIndex].Level]))) {
		    Chat.Screen("You do not know " + Buff.Info[BuffIndex].Name + " Self " +
		    		Buff.Info[BuffIndex].Level + ", buff disabled.");
		    Buff.Info[BuffIndex].Enabled = false;
		} // endif
		DisplayBuffArmor(BuffIndex);
		if (flagVerbose) Chat.Screen("Current buff set same as previous item armor buff examined.");
		break;

	    case "btnBuffArmorSetLast":
	        if (BuffArmorLast < 0)  {
		    Chat.Screen("No item armor buffs modified since macro start, can't set as last modified!");
		    break;
		} // endif

		var BuffIndex = parseInt(dictSzValue("armorChoice"));
		if (BuffIndex == BuffArmorLast) {
		    Chat.Screen("Last modified item armor buff is same as current, aborted.");
		    break;
		} // endif

		Buff.Info[BuffIndex].Enabled	= Buff.Info[BuffArmorLast].Enabled;
		Buff.Info[BuffIndex].Level	= Buff.Info[BuffArmorLast].Level;
		Buff.Info[BuffIndex].Randomize	= Buff.Info[BuffArmorLast].Randomize;
		Buff.Info[BuffIndex].Safety	= Buff.Info[BuffArmorLast].Safety;
		Buff.Info[BuffIndex].Eqm	= Buff.Info[BuffArmorLast].Eqm;
		Buff.Info[BuffIndex].SpellObj	=
		    skapi.SpellInfoFromSpellid(Buff.Info[BuffIndex].Self[Buff.Info[BuffIndex].Level]);

	    	if ((Buff.Info[BuffIndex].Enabled) &&
		    (!Cast.Know(Buff.Info[BuffIndex].Self[Buff.Info[BuffIndex].Level]))) {
		    Chat.Screen("You do not know " + Buff.Info[BuffIndex].Name + " Self " +
		    		Buff.Info[BuffIndex].Level + ", buff disabled.");
		    Buff.Info[BuffIndex].Enabled = false;
		} // endif
		DisplayBuffArmor(BuffIndex);
		if (flagVerbose) Chat.Screen("Current buff set same as last item armor buff modified.");
		break;

	    case "btnBuffArmorAll":
		var BuffIndex = parseInt(dictSzValue("armorChoice"));
		for (var x=Buff.ClassRange[equipClassArmor].Begin; x<=Buff.ClassRange[equipClassArmor].End; x++) {
		    if (x == BuffIndex) continue;
		    Buff.Info[x].Enabled    = Buff.Info[BuffIndex].Enabled;
		    Buff.Info[x].Level	    = Buff.Info[BuffIndex].Level;
		    Buff.Info[x].Randomize  = Buff.Info[BuffIndex].Randomize;
		    Buff.Info[x].Safety	    = Buff.Info[BuffIndex].Safety;
		    Buff.Info[x].Eqm	    = Buff.Info[BuffIndex].Eqm;
		    Buff.Info[x].SpellObj   = skapi.SpellInfoFromSpellid(Buff.Info[x].Self[Buff.Info[x].Level]);

		    if ((Buff.Info[x].Enabled) &&
			(!Cast.Know(Buff.Info[x].Self[Buff.Info[x].Level]))) {
			Chat.Screen("You do not know " + Buff.Info[x].Name + " Self " +
		    		Buff.Info[x].Level + ", buff disabled.");
			Buff.Info[x].Enabled = false;
		    } // endif
		} // endfor
		if (flagVerbose) Chat.Screen("All item armor buffs set like this one.");
		break;

	    case "btnBuffArmorShow":
		if (!Buff.Show(buffTypeItem,equipClassArmor)) Chat.Screen("No item buffs enabled!");
		break;

	    // Wand Buff Section ****************************************************

	    case "chkBuffHermEnab":
		var Level = Buff.Info[BuffHermIndex].Level;
		if (!Buff.Info[BuffHermIndex].Enabled && !Cast.Know(Buff.Info[BuffHermIndex].Self[Level])) {
		    Chat.Screen("You do not know " + Buff.Info[BuffHermIndex].Name + " Self " +
		    		 Level + ", buff not enabled.");
		    skapi.SetControlProperty(szPanelBuffs, "chkBuffHermEnab", "checked",
		    			     Buff.Info[BuffHermIndex].Enabled);
		    break;
		} // endif
		Buff.Info[BuffHermIndex].Enabled = !Buff.Info[BuffHermIndex].Enabled;
		skapi.SetControlProperty(szPanelBuffs, "chkBuffHermEnab", "checked", Buff.Info[BuffHermIndex].Enabled);
		break;

	    case "chkBuffHermRandom":
		Buff.Info[BuffHermIndex].Randomize = !Buff.Info[BuffHermIndex].Randomize;
		skapi.SetControlProperty(szPanelBuffs, "chkBuffHermRandom", "checked",
					 Buff.Info[BuffHermIndex].Randomize);
		break;

	    case "choiceBuff1b":
		var BuffLevel = parseInt(dictSzValue("choiceBuff1b"));
		if (BuffLevel == Buff.Info[BuffHermIndex].Level) break;
	    	if (!Cast.Know(Buff.Info[BuffHermIndex].Self[BuffLevel])) {
		    Chat.Screen("WARNING!!! You don't know " + Buff.Info[BuffHermIndex].Name + " Self " + BuffLevel + ".");
		    if (Buff.Info[BuffHermIndex].Enabled) {
			Chat.Screen("WARNING!!! Buff disabled!");
			Buff.Info[BuffHermIndex].Enabled = false;
			skapi.SetControlProperty(szPanelBuffs, "chkBuffHermEnab", "checked", false);
			break;
		    } // endif
		} // endif
		Buff.Info[BuffHermIndex].SpellObj = skapi.SpellInfoFromSpellid(Buff.Info[BuffHermIndex].Self[BuffLevel]);
		Buff.Info[BuffHermIndex].Level = BuffLevel;
		break;

	    case "editBuff1c":
		szExp = dictSzValue("editBuff1c");
		if (isNaN(szExp) || (szExp == undefined) || (szExp == "")) {
		    Chat.Screen("Invalid number entered");
		    break;
		} // endif
		intExp = parseInt(szExp);
		Buff.Info[BuffHermIndex].Safety = intExp*1000;
		skapi.SetControlProperty(szPanelBuffs, "text1cv", "text", Buff.Info[BuffHermIndex].Safety/1000);
		break;

	    case "editBuff1d":
		szExp = dictSzValue("editBuff1d");
		if (isNaN(szExp) || (szExp == undefined) || (szExp == "")) {
		    Chat.Screen("Invalid number entered");
		    break;
		} // endif
		intExp = parseInt(szExp);
		Buff.Info[BuffHermIndex].Priority = intExp;
		skapi.SetControlProperty(szPanelBuffs, "text1dv", "text", Buff.Info[BuffHermIndex].Priority);
		break;

	    // Defender on wand

	    case "chkBuffDefEnab":
		var Level = Buff.Info[BuffDefIndex].Level;
		if (!Buff.Info[BuffDefIndex].Enabled && !Cast.Know(Buff.Info[BuffDefIndex].Self[Level])) {
		    Chat.Screen("You do not know " + Buff.Info[BuffDefIndex].Name + " Self " +
		    		 Level + ", buff not enabled.");
		    skapi.SetControlProperty(szPanelBuffs, "chkBuffDefEnab", "checked",
		    			     Buff.Info[BuffDefIndex].Enabled);
		    break;
		} // endif
		Buff.Info[BuffDefIndex].Enabled = !Buff.Info[BuffDefIndex].Enabled;
		skapi.SetControlProperty(szPanelBuffs, "chkBuffDefEnab", "checked", Buff.Info[BuffDefIndex].Enabled);
		break;

	    case "chkBuffDefRandom":
		Buff.Info[BuffDefIndex].Randomize = !Buff.Info[BuffDefIndex].Randomize;
		skapi.SetControlProperty(szPanelBuffs, "chkBuffDefRandom", "checked",
					 Buff.Info[BuffDefIndex].Randomize);
		break;

	    case "choiceBuff5b":
		var BuffLevel = parseInt(dictSzValue("choiceBuff5b"));
		if (BuffLevel == Buff.Info[BuffDefIndex].Level) break;
	    	if (!Cast.Know(Buff.Info[BuffDefIndex].Self[BuffLevel])) {
		    Chat.Screen("WARNING!!! You don't know " + Buff.Info[BuffDefIndex].Name + " Self " + BuffLevel + ".");
		    if (Buff.Info[BuffDefIndex].Enabled) {
			Chat.Screen("WARNING!!! Buff disabled!");
			Buff.Info[BuffDefIndex].Enabled = false;
			skapi.SetControlProperty(szPanelBuffs, "chkBuffDefEnab", "checked", false);
			break;
		    } // endif
		} // endif
		Buff.Info[BuffDefIndex].SpellObj = skapi.SpellInfoFromSpellid(Buff.Info[BuffDefIndex].Self[BuffLevel]);
		Buff.Info[BuffDefIndex].Level = BuffLevel;
		break;

	    case "editBuff5c":
		szExp = dictSzValue("editBuff5c");
		if (isNaN(szExp) || (szExp == undefined) || (szExp == "")) {
		    Chat.Screen("Invalid number entered");
		    break;
		} // endif
		intExp = parseInt(szExp);
		Buff.Info[BuffDefIndex].Safety = intExp*1000;
		skapi.SetControlProperty(szPanelBuffs, "text5cv", "text", Buff.Info[BuffDefIndex].Safety/1000);
		break;

	    case "editBuff5d":
		szExp = dictSzValue("editBuff5d");
		if (isNaN(szExp) || (szExp == undefined) || (szExp == "")) {
		    Chat.Screen("Invalid number entered");
		    break;
		} // endif
		intExp = parseInt(szExp);
		Buff.Info[BuffDefIndex].Priority = intExp;
		skapi.SetControlProperty(szPanelBuffs, "text5dv", "text", Buff.Info[BuffDefIndex].Priority);
		break;



	} // end switch
	if (debugEvent||debugCmds) Log.OutD("Main_OnControlEvent: End, Buff");
    	return;
    } // endif

    if (szPanel == szPanelLoot) {
	// Process Loot Panel Controls
	switch (szControl) {

	    case "btnLootLoad":
	       	var FileNum = parseInt(dictSzValue("loadLoot"));
		Chat.Screen("Loading loot configuration info...");
	        if (!Loot.Load(FileNum)) {
		    Chat.Screen("Loot configuration file " + Loot.FileName + " not found!");
		    break;
		} // endif

		LootIndex = parseInt(dictSzValue("typeChoice"));
		DisplayLootType(LootIndex);
		LootIndex = parseInt(dictSzValue("majorChoice"));
		DisplayLootMajor(LootIndex);
		LootIndex = parseInt(dictSzValue("minorChoice"));
		DisplayLootMinor(LootIndex);
		LootIndex = parseInt(dictSzValue("equipChoice"));
		DisplayLootArmor(LootIndex);
		LootIndex = parseInt(dictSzValue("weaponChoice"));
		DisplayLootWeapon(LootIndex);
		LootIndex = parseInt(dictSzValue("wandChoice"));
		DisplayLootWand(LootIndex);
		LootIndex = parseInt(dictSzValue("salvageChoice"));
		DisplayLootSalvage(LootIndex);
		LootIndex = parseInt(dictSzValue("itemChoice"));
		DisplayLootItem(LootIndex);
		DisplayLootJewelry();
		DisplayLootClothing();
		DisplayLootValSalv();
		DisplayLootScroll();
		DisplayLootValuable();
		Chat.Screen("Loot information loaded from " + Loot.FileName);
	        break;

	    case "btnLootSave":
		Chat.Screen("Saving loot configuration info...");
	       	var FileNum = parseInt(dictSzValue("saveLoot"));
		Loot.Save(FileNum);
		Chat.Screen("Loot configuration info saved to file " + Loot.FileName);
	        break;

	    case "btnLootReset":
	    	Chat.Screen("Resetting...");
		Loot.LoadDefaults();
		LootIndex = parseInt(dictSzValue("typeChoice"));
		DisplayLootType(LootIndex);
		LootIndex = parseInt(dictSzValue("majorChoice"));
		DisplayLootMajor(LootIndex);
		LootIndex = parseInt(dictSzValue("minorChoice"));
		DisplayLootMinor(LootIndex);
		LootIndex = parseInt(dictSzValue("equipChoice"));
		DisplayLootArmor(LootIndex);
		LootIndex = parseInt(dictSzValue("weaponChoice"));
		DisplayLootWeapon(LootIndex);
		LootIndex = parseInt(dictSzValue("wandChoice"));
		DisplayLootWand(LootIndex);
		LootIndex = parseInt(dictSzValue("salvageChoice"));
		DisplayLootSalvage(LootIndex);
		LootIndex = parseInt(dictSzValue("itemChoice"));
		DisplayLootItem(LootIndex);
		DisplayLootJewelry();
		DisplayLootClothing();
		DisplayLootValSalv();
		DisplayLootScroll();
		DisplayLootValuable();
		Chat.Screen("Loot configurations reset to default!");
		break;

   	    case "typeChoice":
		// Update text for new loot type
		LootTypePrev = LootTypeIndex;
		LootTypeIndex = parseInt(dictSzValue("typeChoice"));
		DisplayLootType(LootTypeIndex);
		break;

	    case "chkTypeEnab":
		var TypeIndex = parseInt(dictSzValue("typeChoice"));
		Loot.TypeInfo[TypeIndex].Enabled = !Loot.TypeInfo[TypeIndex].Enabled;
		skapi.SetControlProperty(szPanelLoot, "chkLootTypeEnab", "checked", Loot.TypeInfo[TypeIndex].Enabled);
		LootTypeLast = TypeIndex;
		break;

	    case "lootMaxPick":
		var TypeIndex = parseInt(dictSzValue("typeChoice"));
		var MaxCount  = parseInt(dictSzValue("lootMaxPick"));
		if (MaxCount == Loot.TypeInfo[TypeIndex].MaxCount) break;
		Loot.TypeInfo[TypeIndex].MaxCount = MaxCount;
		LootTypeLast = TypeIndex;
		break;

	    case "lootMinSlot":
		var TypeIndex = parseInt(dictSzValue("typeChoice"));
		var MinSlots = parseInt(dictSzValue("lootMinSlot"));
		if (MinSlots == Loot.TypeInfo[TypeIndex].MinSlots) break;
		Loot.TypeInfo[TypeIndex].MinSlots = MinSlots;
		LootTypeLast = TypeIndex;
		break;

	    case "btnTypeNext":
		var TypeIndex = parseInt(dictSzValue("typeChoice"));
		TypeIndex++;
		if (TypeIndex > lootTypeEnd) TypeIndex = lootTypeBegin;
		skapi.SetControlProperty(szPanelLoot, "typeChoice", "selected", TypeIndex-lootTypeBegin);
		break;

	    case "btnTypePrev":
		var TypeIndex = parseInt(dictSzValue("typeChoice"));
		TypeIndex--;
		if (TypeIndex < lootTypeBegin) TypeIndex = lootTypeEnd;
		skapi.SetControlProperty(szPanelLoot, "typeChoice", "selected", TypeIndex-lootTypeBegin);
		break;

	    case "btnTypeSetPrev":
		var TypeIndex = parseInt(dictSzValue("typeChoice"));
		if (TypeIndex == LootTypePrev) {
		    Chat.Screen("Previous examined loot type is same as current, aborted.");
		    break;
		} // endif
		Loot.TypeInfo[TypeIndex].Enabled   = Loot.TypeInfo[LootTypePrev].Enabled;
		Loot.TypeInfo[TypeIndex].MaxCount  = Loot.TypeInfo[LootTypePrev].MaxCount;
		Loot.TypeInfo[TypeIndex].MinSlots  = Loot.TypeInfo[LootTypePrev].MinSlots;
		DisplayLootType(TypeIndex);
		LootTypeLast = TypeIndex;
		if (flagVerbose) Chat.Screen("Current loot type set same as previous loot type examined.");
		break;

	    case "btnTypeSetLast":
	        if (LootTypeLast < 0)  {
		    Chat.Screen("No loot types modified since macro start, can't set as last modified!");
		    break;
		} // endif
		var TypeIndex = parseInt(dictSzValue("typeChoice"));
		if (TypeIndex == LootTypeLast) {
		    Chat.Screen("Last modified loot type is same as current, can't set as last modified!");
		    break;
		} // endif
		Loot.TypeInfo[TypeIndex].Enabled   = Loot.TypeInfo[LootTypeLast].Enabled;
		Loot.TypeInfo[TypeIndex].MaxCount  = Loot.TypeInfo[LootTypeLast].MaxCount;
		Loot.TypeInfo[TypeIndex].MinSlots  = Loot.TypeInfo[LootTypeLast].MinSlots;
		DisplayLootType(TypeIndex);
		LootTypeLast = TypeIndex;
		if (flagVerbose) Chat.Screen("Current loot type set same as last modified loot type.");
		break;

	    case "btnTypeReset":
	        var TypeIndex = parseInt(dictSzValue("typeChoice"));
		Loot.ResetType();
		DisplayLootType(TypeIndex);
		Chat.Screen("All types reset to default settings!");
		break;

	    case "btnTypeAll":
		var TypeIndex = parseInt(dictSzValue("typeChoice"));
		for (var x=lootTypeBegin; x<=lootTypeEnd; x++) {
		    if (x == TypeIndex) continue;
		    Loot.TypeInfo[x].Enabled   = Loot.TypeInfo[TypeIndex].Enabled;
		    Loot.TypeInfo[x].MaxCount  = Loot.TypeInfo[TypeIndex].MaxCount;
		    Loot.TypeInfo[x].MinSlots  = Loot.TypeInfo[TypeIndex].MinSlots;
		} // endfor
		if (flagVerbose) Chat.Screen("All loot types set like this one!");
		break;

	    case "btnTypeShow":
		Loot.ShowType();
		break;

	    // Major settings ************************************************************

  	    case "majorChoice":
		// Update text for new major
		LootIndex = parseInt(dictSzValue("majorChoice"));
		DisplayLootMajor(LootIndex);
		break;

	    case "chkMajorEnab":
		var LootIndex = parseInt(dictSzValue("majorChoice"));
		Loot.MajorFilter[LootIndex].Enabled = !Loot.MajorFilter[LootIndex].Enabled;
		skapi.SetControlProperty(szPanelLoot, "chkLootMajorEnab", "checked", Loot.MajorFilter[LootIndex].Enabled);
		break;

	    case "btnMajorNext":
		var LootIndex = parseInt(dictSzValue("majorChoice"));
		LootIndex++;
		if (LootIndex == Loot.MajorFilter.length) LootIndex = 0;
		skapi.SetControlProperty(szPanelLoot, "majorChoice", "selected", LootIndex);
		break;

	    case "btnMajorPrev":
		var LootIndex = parseInt(dictSzValue("majorChoice"));
		LootIndex--;
		if (LootIndex < 0) LootIndex = Loot.MajorFilter.length-1;
		skapi.SetControlProperty(szPanelLoot, "majorChoice", "selected", LootIndex);
		break;

	    case "btnMajorShow":
		Loot.ShowMajor();
		break;

	    case "btnMajorReset":
	        var LootIndex = parseInt(dictSzValue("majorChoice"));
		Loot.ResetMajor();
		DisplayLootMajor(LootIndex);
		Chat.Screen("All majors reset to default settings!");
		break;

	    // Minor settings **********************************

 	    case "minorChoice":
		// Update text for new minor
		LootMinorPrev = LootMinorIndex;
		LootMinorIndex = parseInt(dictSzValue("minorChoice"));
		DisplayLootMinor(LootMinorIndex);
		break;

	    case "chkMinorEnab":
		var LootIndex = parseInt(dictSzValue("minorChoice"));
		Loot.MinorFilter[LootIndex].Enabled = !Loot.MinorFilter[LootIndex].Enabled;
		skapi.SetControlProperty(szPanelLoot, "chkLootMinorEnab", "checked", Loot.MinorFilter[LootIndex].Enabled);
		LootMinorLast = LootIndex;
		break;

	    case "chkMinorHead":
		var LootIndex = parseInt(dictSzValue("minorChoice"));
		with (Loot.MinorFilter[LootIndex]) {
		    if (Eqm & eqmHead) {
			Eqm &= ~eqmHead;
		    } else {
			Eqm |= eqmHead;
		    } // endif
		    skapi.SetControlProperty(szPanelLoot, "chkMinorHead", "checked", (Eqm & eqmHead));
		} // end with
		LootMinorLast = LootIndex;
		break;

	    case "chkMinorHands":
		var LootIndex = parseInt(dictSzValue("minorChoice"));
		with (Loot.MinorFilter[LootIndex]) {
		    if (Eqm & eqmHands) {
			Eqm &= ~eqmHands;
		    } else {
			Eqm |= eqmHands;
		    } // endif
		    skapi.SetControlProperty(szPanelLoot, "chkMinorHands", "checked", (Eqm & eqmHands));
		} // end with
		LootMinorLast = LootIndex;
		break;

	    case "chkMinorFeet":
		var LootIndex = parseInt(dictSzValue("minorChoice"));
		with (Loot.MinorFilter[LootIndex]) {
		    if (Eqm & eqmFeet) {
			Eqm &= ~eqmFeet;
		    } else {
			Eqm |= eqmFeet;
		   } // endif
		   skapi.SetControlProperty(szPanelLoot, "chkMinorFeet", "checked", (Eqm & eqmFeet));
		} // end with
		LootMinorLast = LootIndex;
		break;

	    case "chkMinorChest":
		var LootIndex = parseInt(dictSzValue("minorChoice"));
		with (Loot.MinorFilter[LootIndex]) {
		    if (Eqm & eqmChestOuter) {
			Eqm &= ~eqmChestOuter;
		    } else {
			Eqm |= eqmChestOuter;
		    } // endif
		    skapi.SetControlProperty(szPanelLoot, "chkMinorChest", "checked", (Eqm & eqmChestOuter));
		} // end with
		LootMinorLast = LootIndex;
		break;

	    case "chkMinorUpArms":
		var LootIndex = parseInt(dictSzValue("minorChoice"));
		with (Loot.MinorFilter[LootIndex]) {
		    if (Eqm & eqmUpperArmsOuter) {
			Eqm &= ~eqmUpperArmsOuter;
		    } else {
			Eqm |= eqmUpperArmsOuter;
		    } // endif
		    skapi.SetControlProperty(szPanelLoot, "chkMinorUpArms", "checked", (Eqm & eqmUpperArmsOuter));
		} // end with
		LootMinorLast = LootIndex;
		break;

	    case "chkMinorLowArms":
		var LootIndex = parseInt(dictSzValue("minorChoice"));
		with (Loot.MinorFilter[LootIndex]) {
		    if (Eqm & eqmLowerArmsOuter) {
			Eqm &= ~eqmLowerArmsOuter;
		    } else {
			Eqm |= eqmLowerArmsOuter;
		    } // endif
		   skapi.SetControlProperty(szPanelLoot, "chkMinorLowArms", "checked", (Eqm & eqmLowerArmsOuter));
		} // end with
		LootMinorLast = LootIndex;
		break;

	    case "chkMinorAbdomen":
		var LootIndex = parseInt(dictSzValue("minorChoice"));
		with (Loot.MinorFilter[LootIndex]) {
		    if (Eqm & eqmAbdomenOuter) {
			Eqm &= ~eqmAbdomenOuter;
		    } else {
			Eqm |= eqmAbdomenOuter;
		    } // endif
		    skapi.SetControlProperty(szPanelLoot, "chkMinorAbdomen", "checked", (Eqm & eqmAbdomenOuter));
		} // end with
		LootMinorLast = LootIndex;
		break;

	    case "chkMinorUpLegs":
		var LootIndex = parseInt(dictSzValue("minorChoice"));
		with (Loot.MinorFilter[LootIndex]) {
		    if (Eqm & eqmUpperLegsOuter) {
			Eqm &= ~eqmUpperLegsOuter;
		    } else {
			Eqm |= eqmUpperLegsOuter;
		    } // endif
		    skapi.SetControlProperty(szPanelLoot, "chkMinorUpLegs", "checked", (Eqm & eqmUpperLegsOuter));
		} // end with
		LootMinorLast = LootIndex;
		break;

	    case "chkMinorLowLegs":
		var LootIndex = parseInt(dictSzValue("minorChoice"));
		with (Loot.MinorFilter[LootIndex]) {
		    if (Eqm & eqmLowerLegsOuter) {
			Eqm &= ~eqmLowerLegsOuter;
		    } else {
			Eqm |= eqmLowerLegsOuter;
		    } // endif
		    skapi.SetControlProperty(szPanelLoot, "chkMinorLowLegs", "checked", (Eqm & eqmLowerLegsOuter));
		} // end with
		LootMinorLast = LootIndex;
		break;

	    case "chkMinorShirt":
		var LootIndex = parseInt(dictSzValue("minorChoice"));
		with (Loot.MinorFilter[LootIndex]) {
		    if (Eqm & eqmChestUnder) {
			Eqm &= ~eqmChestUnder;
		    } else {
			Eqm |= eqmChestUnder;
		    } // endif
		    skapi.SetControlProperty(szPanelLoot, "chkMinorShirt", "checked", (Eqm & eqmChestUnder));
		} // end with
		LootMinorLast = LootIndex;
		break;

	    case "chkMinorPants":
		var LootIndex = parseInt(dictSzValue("minorChoice"));
		with (Loot.MinorFilter[LootIndex]) {
		    if (Eqm & eqmUpperLegsUnder) {
			Eqm &= ~eqmUpperLegsUnder;
		    } else {
			Eqm |= eqmUpperLegsUnder;
		    } // endif
		    skapi.SetControlProperty(szPanelLoot, "chkMinorPants", "checked", (Eqm & eqmUpperLegsUnder));
		} // end with
		LootMinorLast = LootIndex;
		break;

	    case "btnMinorNext":
		var LootIndex = parseInt(dictSzValue("minorChoice"));
		LootIndex++;
		if (LootIndex == Loot.MinorFilter.length) LootIndex = 0;
		skapi.SetControlProperty(szPanelLoot, "minorChoice", "selected", LootIndex);
		break;

	    case "btnMinorPrev":
		var LootIndex = parseInt(dictSzValue("minorChoice"));
		LootIndex--;
		if (LootIndex < 0) LootIndex = Loot.MinorFilter.length-1;
		skapi.SetControlProperty(szPanelLoot, "minorChoice", "selected", LootIndex);
		break;

	    case "btnMinorSetPrev":
		var LootIndex = parseInt(dictSzValue("minorChoice"));
		if (LootIndex == LootMinorPrev) {
		    Chat.Screen("Previous examined minor is same as current, aborted.");
		    break;
		} // endif
		Loot.MinorFilter[LootIndex].Enabled = Loot.MinorFilter[LootMinorPrev].Enabled;
		Loot.MinorFilter[LootIndex].Eqm     = Loot.MinorFilter[LootMinorPrev].Eqm;

		DisplayLootMinor(LootIndex);
		if (flagVerbose) Chat.Screen("Current minor set same as previous minor examined.");
		LootMinorLast = LootIndex;
		break;

	    case "btnMinorSetLast":
	        if (LootMinorLast < 0)  {
		    Chat.Screen("No minors modified since macro start, can't set as last modified!");
		    break;
		} // endif

		var LootIndex = parseInt(dictSzValue("minorChoice"));
		if (LootIndex == LootMinorLast ) {
		    Chat.Screen("Last modified minor is same as current, aborted.");
		    break;
		} // endif

		Loot.MinorFilter[LootIndex].Enabled = Loot.MinorFilter[LootMinorLast].Enabled;
		Loot.MinorFilter[LootIndex].Eqm     = Loot.MinorFilter[LootMinorLast].Eqm;

		DisplayLootMinor(LootIndex);
		LootMinorLast = LootIndex;
		if (flagVerbose) Chat.Screen("Current minor set same as last modified minor.");
		break;

	    case "btnMinorShow":
		Loot.ShowMinor();
		break;

	    case "btnMinorReset":
	        var LootIndex = parseInt(dictSzValue("minorChoice"));
		Loot.ResetMinor();
		DisplayLootMinor(LootIndex);
		Chat.Screen("All minors reset to default settings!");
		break;

	    case "btnMinorAll":
		var LootIndex = parseInt(dictSzValue("minorChoice"));
		for (var x=0; x<Loot.MinorFilter.length; x++) {
		    if (x == LootIndex) continue;
		    Loot.MinorFilter[x].Enabled  = Loot.MinorFilter[LootIndex].Enabled;
		    Loot.MinorFilter[x].Eqm	 = Loot.MinorFilter[LootIndex].Eqm;
		} // endfor
		if (flagVerbose) Chat.Screen("All minors set like this one!");
		break;

	    // Armor loot *************************************************

	    case "equipChoice":
		LootArmorPrev = LootArmorIndex;
		LootArmorIndex = parseInt(dictSzValue("equipChoice"));
		DisplayLootArmor(LootArmorIndex);
		break;

	    case "chkArmorEnab":
		var LootIndex = parseInt(dictSzValue("equipChoice"));
		with (Loot.ArmorFilter[LootIndex]) {
		    Enabled = !Enabled;
		    skapi.SetControlProperty(szPanelLoot, "chkArmorEnab", "checked", Enabled);
		} // end with
		LootArmorLast = LootIndex;
		break;

	    case "editLoot3a":
		szExp = dictSzValue("editLoot3a");
		if (isNaN(szExp) || (szExp == undefined) || (szExp == "")) {
		    Chat.Screen("Invalid number entered");
		    break;
		} // endif
		var LootIndex = parseInt(dictSzValue("equipChoice"));
		intExp = parseInt(szExp);
		with (Loot.ArmorFilter[LootIndex]) {
		    MinAL = intExp;
		    skapi.SetControlProperty(szPanelLoot, "text3av", "text", MinAL);
		} // endif
		LootArmorLast = LootIndex;
		break;

	    case "editLoot3b":
		szExp = dictSzValue("editLoot3b");
		if (isNaN(szExp) || (szExp == undefined) || (szExp == "")) {
		    Chat.Screen("Invalid number entered");
		    break;
		} // endif
		var LootIndex = parseInt(dictSzValue("equipChoice"));
		intExp = parseInt(szExp);
		with (Loot.ArmorFilter[LootIndex]) {
		    MaxBU = intExp;
		    skapi.SetControlProperty(szPanelLoot, "text3bv", "text", MaxBU);
		} // endif
		LootArmorLast = LootIndex;
		break;

	    case "editLoot3c":
		szExp = dictSzValue("editLoot3c");
		if (isNaN(szExp) || (szExp == undefined) || (szExp == "")) {
		    Chat.Screen("Invalid number entered");
		    break;
		} // endif
		var LootIndex = parseInt(dictSzValue("equipChoice"));
		intExp = parseInt(szExp);
		with (Loot.ArmorFilter[LootIndex]) {
		    MaxValue = intExp;
		    skapi.SetControlProperty(szPanelLoot, "text3cv", "text", MaxValue);
		} // endif
		LootArmorLast = LootIndex;
		break;

	    case "choiceLoot3d":
		var LootIndex = parseInt(dictSzValue("equipChoice"));
		var MaxWork = parseInt(dictSzValue("choiceLoot3d"));
		if (MaxWork == Loot.ArmorFilter[LootIndex].MaxWork) break;
		Loot.ArmorFilter[LootIndex].MaxWork = MaxWork;
		LootArmorLast = LootIndex;
		break;

	    case "choiceLoot3e":
		var LootIndex = parseInt(dictSzValue("equipChoice"));
		var MinSpells = parseInt(dictSzValue("choiceLoot3e"));
		if (MinSpells == Loot.ArmorFilter[LootIndex].MinSpells) break;
		Loot.ArmorFilter[LootIndex].MinSpells = MinSpells;
		LootArmorLast = LootIndex;
		break;

	    case "choiceLoot3f":
		var LootIndex = parseInt(dictSzValue("equipChoice"));
		var MinSplLvl = parseInt(dictSzValue("choiceLoot3f"));
		if (MinSplLvl == Loot.ArmorFilter[LootIndex].MinSplLvl) break;
		Loot.ArmorFilter[LootIndex].MinSplLvl = MinSplLvl;
		LootArmorLast = LootIndex;
		break;

	    case "btnArmorNext":
		var LootIndex = parseInt(dictSzValue("equipChoice"));
		LootIndex++;
		if (LootIndex == Loot.ArmorFilter.length) LootIndex = 0;
		skapi.SetControlProperty(szPanelLoot, "equipChoice", "selected", LootIndex);
		break;

	    case "btnArmorPrev":
		var LootIndex = parseInt(dictSzValue("equipChoice"));
		LootIndex--;
		if (LootIndex < 0) LootIndex = Loot.ArmorFilter.length-1;
		skapi.SetControlProperty(szPanelLoot, "equipChoice", "selected", LootIndex);
		break;

	    case "btnArmorSetPrev":
		var LootIndex = parseInt(dictSzValue("equipChoice"));
		if (LootIndex == LootArmorPrev) {
		    Chat.Screen("Previous examined armor item is same as current, aborted.");
		    break;
		} // endif

		Loot.ArmorFilter[LootIndex].Enabled 	= Loot.ArmorFilter[LootArmorPrev].Enabled;
		Loot.ArmorFilter[LootIndex].MinAL	= Loot.ArmorFilter[LootArmorPrev].MinAL;
		Loot.ArmorFilter[LootIndex].MaxBU	= Loot.ArmorFilter[LootArmorPrev].MaxBU;
		Loot.ArmorFilter[LootIndex].MaxValue	= Loot.ArmorFilter[LootArmorPrev].MaxValue;
		Loot.ArmorFilter[LootIndex].MaxWork	= Loot.ArmorFilter[LootArmorPrev].MaxWork;
		Loot.ArmorFilter[LootIndex].MinSpells	= Loot.ArmorFilter[LootArmorPrev].MinSpells;
 		Loot.ArmorFilter[LootIndex].MinSplLvl	= Loot.ArmorFilter[LootArmorPrev].MinSplLvl;

		DisplayLootArmor(LootIndex);
		if (flagVerbose) Chat.Screen("Current armor item set same as previous examined.");
		LootArmorLast = LootIndex;
		break;

	    case "btnArmorSetLast":
	        if (LootArmorLast < 0)  {
		    Chat.Screen("No armor items modified since macro start, can't set as last modified!");
		    break;
		} // endif

		var LootIndex = parseInt(dictSzValue("equipChoice"));
		if (LootIndex == LootArmorLast ) {
		    Chat.Screen("Last modified armor item is same as current, aborted.");
		    break;
		} // endif

		Loot.ArmorFilter[LootIndex].Enabled	= Loot.ArmorFilter[LootArmorLast].Enabled;
		Loot.ArmorFilter[LootIndex].MinAL	= Loot.ArmorFilter[LootArmorLast].MinAL;
		Loot.ArmorFilter[LootIndex].MaxBU	= Loot.ArmorFilter[LootArmorLast].MaxBU;
		Loot.ArmorFilter[LootIndex].MaxValue	= Loot.ArmorFilter[LootArmorLast].MaxValue;
		Loot.ArmorFilter[LootIndex].MaxWork	= Loot.ArmorFilter[LootArmorLast].MaxWork;
		Loot.ArmorFilter[LootIndex].MinSpells	= Loot.ArmorFilter[LootArmorLast].MinSpells;
 		Loot.ArmorFilter[LootIndex].MinSplLvl	= Loot.ArmorFilter[LootArmorLast].MinSplLvl;

		DisplayLootArmor(LootIndex);
		LootArmorLast = LootIndex;
		if (flagVerbose) Chat.Screen("Current Armor set same as last modified Armor.");
		break;

	    case "btnArmorShow":
		Loot.ShowArmor();
		break;

	    case "btnArmorReset":
	        var LootIndex = parseInt(dictSzValue("equipChoice"));
		Loot.ResetArmor();
		DisplayLootArmor(LootIndex);
		Chat.Screen("All armor reset to default settings!");
		break;

	    case "btnArmorAll":
		var LootIndex = parseInt(dictSzValue("equipChoice"));
		for (var x=0; x<Loot.ArmorFilter.length; x++) {
		    if ((x == LootIndex) || (Loot.ArmorFilter[x].CovFlag != Loot.ArmorFilter[LootIndex].CovFlag)) continue;
		    Loot.ArmorFilter[x].Enabled   = Loot.ArmorFilter[LootIndex].Enabled;
		    Loot.ArmorFilter[x].MinAL	  = Loot.ArmorFilter[LootIndex].MinAL;
		    Loot.ArmorFilter[x].MaxBU	  = Loot.ArmorFilter[LootIndex].MaxBU;
		    Loot.ArmorFilter[x].MaxValue  = Loot.ArmorFilter[LootIndex].MaxValue;
		    Loot.ArmorFilter[x].MaxWork	  = Loot.ArmorFilter[LootIndex].MaxWork;
		    Loot.ArmorFilter[x].MinSpells = Loot.ArmorFilter[LootIndex].MinSpells;
 		    Loot.ArmorFilter[x].MinSplLvl = Loot.ArmorFilter[LootIndex].MinSplLvl;
		} // endfor
		if (flagVerbose) Chat.Screen("All armor items set like this one!");
		break;

	    // Weapon options ******************************************

	    case "weaponChoice":
		LootWeaponPrev = LootWeaponIndex;
		LootWeaponIndex = parseInt(dictSzValue("weaponChoice"));
		DisplayLootWeapon(LootWeaponIndex);
		break;

	    case "chkWeaponEnab":
		var LootIndex = parseInt(dictSzValue("weaponChoice"));
		with (Loot.WeaponFilter[LootIndex]) {
		    Enabled = !Enabled;
		    skapi.SetControlProperty(szPanelLoot, "chkWeaponEnab", "checked", Enabled);
		} // end with
		LootWeaponLast = LootIndex;
		break;

	    case "editLoot4a":
		szExp = dictSzValue("editLoot4a");
		if (isNaN(szExp) || (szExp == undefined) || (szExp == "")) {
		    Chat.Screen("Invalid number entered");
		    break;
		} // endif
		var LootIndex = parseInt(dictSzValue("weaponChoice"));
		intExp = parseInt(szExp);
		with (Loot.WeaponFilter[LootIndex]) {
		    MinDam = intExp;
		    skapi.SetControlProperty(szPanelLoot, "text4av", "text", MinDam);
		} // endif
		LootWeaponLast = LootIndex;
		break;


	    case "editLoot4b":
		szExp = dictSzValue("editLoot4b");
		if (isNaN(szExp) || (szExp == undefined) || (szExp == "")) {
		    Chat.Screen("Invalid number entered");
		    break;
		} // endif
		var LootIndex = parseInt(dictSzValue("weaponChoice"));
		intExp = parseInt(szExp);
		with (Loot.WeaponFilter[LootIndex]) {
		    MaxBU = intExp;
		    skapi.SetControlProperty(szPanelLoot, "text4bv", "text", MaxBU);
		} // endif
		LootWeaponLast = LootIndex;
		break;

	    case "editLoot4c":
		szExp = dictSzValue("editLoot4c");
		if (isNaN(szExp) || (szExp == undefined) || (szExp == "")) {
		    Chat.Screen("Invalid number entered");
		    break;
		} // endif
		var LootIndex = parseInt(dictSzValue("weaponChoice"));
		intExp = parseInt(szExp);
		with (Loot.WeaponFilter[LootIndex]) {
		    MaxValue = intExp;
		    skapi.SetControlProperty(szPanelLoot, "text4cv", "text", MaxValue);
		} // endif
		LootWeaponLast = LootIndex;
		break;

	    case "choiceLoot4d":
		var LootIndex = parseInt(dictSzValue("weaponChoice"));
		var MinAtt = parseInt(dictSzValue("choiceLoot4d"));
		if (MinAtt == Loot.WeaponFilter[LootIndex].MinAtt) break;
		Loot.WeaponFilter[LootIndex].MinAtt = MinAtt;
		LootWeaponLast = LootIndex;
		break;

	    case "choiceLoot4e":
		var LootIndex = parseInt(dictSzValue("weaponChoice"));
		var MinDef = parseInt(dictSzValue("choiceLoot4e"));
		if (MinDef == Loot.WeaponFilter[LootIndex].MinDef) break;
		Loot.WeaponFilter[LootIndex].MinDef = MinDef;
		LootWeaponLast = LootIndex;
		break;

	    case "choiceLoot4f":
		var LootIndex = parseInt(dictSzValue("weaponChoice"));
		var MaxWork = parseInt(dictSzValue("choiceLoot4f"));
		if (MaxWork == Loot.WeaponFilter[LootIndex].MaxWork) break;
		Loot.WeaponFilter[LootIndex].MaxWork = MaxWork;
		LootWeaponLast = LootIndex;
		break;

	    case "choiceLoot4g":
		var LootIndex = parseInt(dictSzValue("weaponChoice"));
		var MinSpells = parseInt(dictSzValue("choiceLoot4g"));
		if (MinSpells == Loot.WeaponFilter[LootIndex].MinSpells) break;
		Loot.WeaponFilter[LootIndex].MinSpells = MinSpells;
		LootWeaponLast = LootIndex;
		break;

	    case "choiceLoot4h":
		var LootIndex = parseInt(dictSzValue("weaponChoice"));
		var MinSplLvl = parseInt(dictSzValue("choiceLoot4h"));
		if (MinSplLvl == Loot.WeaponFilter[LootIndex].MinSplLvl) break;
		Loot.WeaponFilter[LootIndex].MinSplLvl = MinSplLvl;
		LootWeaponLast = LootIndex;
		break;

	    case "btnWeaponNext":
		var LootIndex = parseInt(dictSzValue("weaponChoice"));
		LootIndex++;
		if (LootIndex == Loot.WeaponFilter.length) LootIndex = 0;
		skapi.SetControlProperty(szPanelLoot, "weaponChoice", "selected", LootIndex);
		break;

	    case "btnWeaponPrev":
		var LootIndex = parseInt(dictSzValue("weaponChoice"));
		LootIndex--;
		if (LootIndex < 0) LootIndex = Loot.WeaponFilter.length-1;
		skapi.SetControlProperty(szPanelLoot, "weaponChoice", "selected", LootIndex);
		break;

	    case "btnWeaponSetPrev":
		var LootIndex = parseInt(dictSzValue("weaponChoice"));
		if (LootIndex == LootWeaponPrev) {
		    Chat.Screen("Previous examined weapon item is same as current, aborted.");
		    break;
		} // endif

		Loot.WeaponFilter[LootIndex].Enabled 	= Loot.WeaponFilter[LootWeaponPrev].Enabled;
		Loot.WeaponFilter[LootIndex].MinDam	= Loot.WeaponFilter[LootWeaponPrev].MinDam;
		Loot.WeaponFilter[LootIndex].MinAtt	= Loot.WeaponFilter[LootWeaponPrev].MinAtt;
		Loot.WeaponFilter[LootIndex].MinDef	= Loot.WeaponFilter[LootWeaponPrev].MinDef;
		Loot.WeaponFilter[LootIndex].MaxWork	= Loot.WeaponFilter[LootWeaponPrev].MaxWork;
		Loot.WeaponFilter[LootIndex].MaxBU	= Loot.WeaponFilter[LootWeaponPrev].MaxBU;
		Loot.WeaponFilter[LootIndex].MaxValue	= Loot.WeaponFilter[LootWeaponPrev].MaxValue;
		Loot.WeaponFilter[LootIndex].MinSpells	= Loot.WeaponFilter[LootWeaponPrev].MinSpells;
 		Loot.WeaponFilter[LootIndex].MinSplLvl	= Loot.WeaponFilter[LootWeaponPrev].MinSplLvl;

		DisplayLootWeapon(LootIndex);
		if (flagVerbose) Chat.Screen("Current weapon item set same as previous examined.");
		LootWeaponLast = LootIndex;
		break;

	    case "btnWeaponSetLast":
	        if (LootWeaponLast < 0)  {
		    Chat.Screen("No Weapon items modified since macro start, can't set as last modified!");
		    break;
		} // endif

		var LootIndex = parseInt(dictSzValue("weaponChoice"));
		if (LootIndex == LootWeaponLast ) {
		    Chat.Screen("Last modified Weapon item is same as current, aborted.");
		    break;
		} // endif

		Loot.WeaponFilter[LootIndex].Enabled	= Loot.WeaponFilter[LootWeaponLast].Enabled;
		Loot.WeaponFilter[LootIndex].MinDam	= Loot.WeaponFilter[LootWeaponLast].MinDam;
		Loot.WeaponFilter[LootIndex].MinAtt	= Loot.WeaponFilter[LootWeaponLast].MinAtt;
		Loot.WeaponFilter[LootIndex].MinDef	= Loot.WeaponFilter[LootWeaponLast].MinDef;
		Loot.WeaponFilter[LootIndex].MaxWork	= Loot.WeaponFilter[LootWeaponLast].MaxWork;
		Loot.WeaponFilter[LootIndex].MaxBU	= Loot.WeaponFilter[LootWeaponLast].MaxBU;
		Loot.WeaponFilter[LootIndex].MaxValue	= Loot.WeaponFilter[LootWeaponLast].MaxValue;
		Loot.WeaponFilter[LootIndex].MinSpells	= Loot.WeaponFilter[LootWeaponLast].MinSpells;
 		Loot.WeaponFilter[LootIndex].MinSplLvl	= Loot.WeaponFilter[LootWeaponLast].MinSplLvl;

		DisplayLootWeapon(LootIndex);
		LootWeaponLast = LootIndex;
		if (flagVerbose) Chat.Screen("Current weapon set same as last modified weapon.");
		break;

	    case "btnWeaponShow":
		Loot.ShowWeapon();
		break;

	    case "btnWeaponReset":
	        var LootIndex = parseInt(dictSzValue("weaponChoice"));
		Loot.ResetWeapon();
		DisplayLootWeapon(LootIndex);
		Chat.Screen("All weapons reset to default settings!");
		break;

	    case "btnWeaponAll":
		var LootIndex = parseInt(dictSzValue("weaponChoice"));
		for (var x=0; x<Loot.WeaponFilter.length; x++) {
		    if ((x == LootIndex) || (Loot.WeaponFilter[x].Skid != Loot.WeaponFilter[LootIndex].Skid)) continue;
		    Loot.WeaponFilter[x].Enabled    = Loot.WeaponFilter[LootIndex].Enabled;
		    Loot.WeaponFilter[x].MinDam	    = Loot.WeaponFilter[LootIndex].MinDam;
		    Loot.WeaponFilter[x].MinAtt	    = Loot.WeaponFilter[LootIndex].MinAtt;
		    Loot.WeaponFilter[x].MinDef	    = Loot.WeaponFilter[LootIndex].MinDef;
		    Loot.WeaponFilter[x].MaxWork    = Loot.WeaponFilter[LootIndex].MaxWork;
		    Loot.WeaponFilter[x].MaxBU	    = Loot.WeaponFilter[LootIndex].MaxBU;
		    Loot.WeaponFilter[x].MaxValue   = Loot.WeaponFilter[LootIndex].MaxValue;
		    Loot.WeaponFilter[x].MinSpells  = Loot.WeaponFilter[LootIndex].MinSpells;
 		    Loot.WeaponFilter[x].MinSplLvl  = Loot.WeaponFilter[LootIndex].MinSplLvl;
		} // endfor
		if (flagVerbose) Chat.Screen("All weapons of same skill set like this one!");
		break;

	    // Salvage options ******************************************

	    case "salvageChoice":
		LootSalvPrev = LootSalvIndex;
		LootSalvIndex = parseInt(dictSzValue("salvageChoice"));
		DisplayLootSalvage(LootSalvIndex);
		break;

	    case "chkSalvEnab":
		var LootIndex = parseInt(dictSzValue("salvageChoice"));
		with (Loot.SalvageFilter[LootIndex]) {
		    Enabled = !Enabled;
		    skapi.SetControlProperty(szPanelLoot, "chkSalvEnab", "checked", Enabled);
		} // end with
		LootSalvLast = LootIndex;
		break;

	    case "chkExcludeVal":
		var LootIndex = parseInt(dictSzValue("salvageChoice"));
		with (Loot.SalvageFilter[LootIndex]) {
		    ExcludeVal = !ExcludeVal;
		    skapi.SetControlProperty(szPanelLoot, "chkExcludeVal", "checked", ExcludeVal);
		} // end with
		LootSalvLast = LootIndex;
		break;

	    case "choiceLoot5a":
		var LootIndex = parseInt(dictSzValue("salvageChoice"));
		var MinWork = parseInt(dictSzValue("choiceLoot5a"));
		if (MinWork == Loot.SalvageFilter[LootIndex].MinWork) break;
		Loot.SalvageFilter[LootIndex].MinWork = MinWork;
		LootSalvLast = LootIndex;
		break;

	    case "editLoot5b":
		szExp = dictSzValue("editLoot5b");
		if (isNaN(szExp) || (szExp == undefined) || (szExp == "")) {
		    Chat.Screen("Invalid number entered");
		    break;
		} // endif
		var LootIndex = parseInt(dictSzValue("salvageChoice"));
		intExp = parseInt(szExp);
		with (Loot.SalvageFilter[LootIndex]) {
		    MaxBU = intExp;
		    skapi.SetControlProperty(szPanelLoot, "text5bv", "text", MaxBU);
		} // endif
		LootSalvLast = LootIndex;
		break;

	    case "editLoot5c":
		szExp = dictSzValue("editLoot5c");
		if (isNaN(szExp) || (szExp == undefined) || (szExp == "")) {
		    Chat.Screen("Invalid number entered");
		    break;
		} // endif
		var LootIndex = parseInt(dictSzValue("salvageChoice"));
		intExp = parseInt(szExp);
		with (Loot.SalvageFilter[LootIndex]) {
		    SortPrio = intExp;
		    skapi.SetControlProperty(szPanelLoot, "text5cv", "text", SortPrio);
		} // endif
		LootSalvLast = LootIndex;
		break;

	    case "chkSal1":
		var LootIndex = parseInt(dictSzValue("salvageChoice"));
		with (Loot.SalvageFilter[LootIndex]) {
		    if (CombineMask & combineMaskVal[1]) {
			CombineMask &= ~combineMaskVal[1];
		    } else {
			CombineMask |= combineMaskVal[1];
		    } // endif
		    skapi.SetControlProperty(szPanelLoot, "chkSal1", "checked", (CombineMask & combineMaskVal[1]));
		} // end with
		Loot.SetWorkRange(LootIndex);
		LootSalvLast = LootIndex;
		break;

	    case "chkSal2":
		var LootIndex = parseInt(dictSzValue("salvageChoice"));
		with (Loot.SalvageFilter[LootIndex]) {
		    if (CombineMask & combineMaskVal[2]) {
			CombineMask &= ~combineMaskVal[2];
		    } else {
			CombineMask |= combineMaskVal[2];
		    } // endif
		    skapi.SetControlProperty(szPanelLoot, "chkSal2", "checked", (CombineMask & combineMaskVal[2]));
		} // end with
		Loot.SetWorkRange(LootIndex);
		LootSalvLast = LootIndex;
		break;

	    case "chkSal3":
		var LootIndex = parseInt(dictSzValue("salvageChoice"));
		with (Loot.SalvageFilter[LootIndex]) {
		    if (CombineMask & combineMaskVal[3]) {
			CombineMask &= ~combineMaskVal[3];
		    } else {
			CombineMask |= combineMaskVal[3];
		    } // endif
		    skapi.SetControlProperty(szPanelLoot, "chkSal3", "checked", (CombineMask & combineMaskVal[3]));
		} // end with
		Loot.SetWorkRange(LootIndex);
		LootSalvLast = LootIndex;
		break;

	    case "chkSal4":
		var LootIndex = parseInt(dictSzValue("salvageChoice"));
		with (Loot.SalvageFilter[LootIndex]) {
		    if (CombineMask & combineMaskVal[4]) {
			CombineMask &= ~combineMaskVal[4];
		    } else {
			CombineMask |= combineMaskVal[4];
		    } // endif
		    skapi.SetControlProperty(szPanelLoot, "chkSal4", "checked", (CombineMask & combineMaskVal[4]));
		} // end with
		Loot.SetWorkRange(LootIndex);
		LootSalvLast = LootIndex;
		break;

	    case "chkSal5":
		var LootIndex = parseInt(dictSzValue("salvageChoice"));
		with (Loot.SalvageFilter[LootIndex]) {
		    if (CombineMask & combineMaskVal[5]) {
			CombineMask &= ~combineMaskVal[5];
		    } else {
			CombineMask |= combineMaskVal[5];
		    } // endif
		    skapi.SetControlProperty(szPanelLoot, "chkSal5", "checked", (CombineMask & combineMaskVal[5]));
		} // end with
		Loot.SetWorkRange(LootIndex);
		LootSalvLast = LootIndex;
		break;

	    case "chkSal6":
		var LootIndex = parseInt(dictSzValue("salvageChoice"));
		with (Loot.SalvageFilter[LootIndex]) {
		    if (CombineMask & combineMaskVal[6]) {
			CombineMask &= ~combineMaskVal[6];
		    } else {
			CombineMask |= combineMaskVal[6];
		    } // endif
		    skapi.SetControlProperty(szPanelLoot, "chkSal6", "checked", (CombineMask & combineMaskVal[6]));
		} // end with
		Loot.SetWorkRange(LootIndex);
		LootSalvLast = LootIndex;
		break;

	    case "chkSal7":
		var LootIndex = parseInt(dictSzValue("salvageChoice"));
		with (Loot.SalvageFilter[LootIndex]) {
		    if (CombineMask & combineMaskVal[7]) {
			CombineMask &= ~combineMaskVal[7];
		    } else {
			CombineMask |= combineMaskVal[7];
		    } // endif
		    skapi.SetControlProperty(szPanelLoot, "chkSal7", "checked", (CombineMask & combineMaskVal[7]));
		} // end with
		Loot.SetWorkRange(LootIndex);
		LootSalvLast = LootIndex;
		break;

	    case "chkSal8":
		var LootIndex = parseInt(dictSzValue("salvageChoice"));
		with (Loot.SalvageFilter[LootIndex]) {
		    if (CombineMask & combineMaskVal[8]) {
			CombineMask &= ~combineMaskVal[8];
		    } else {
			CombineMask |= combineMaskVal[8];
		    } // endif
		    skapi.SetControlProperty(szPanelLoot, "chkSal8", "checked", (CombineMask & combineMaskVal[8]));
		} // end with
		Loot.SetWorkRange(LootIndex);
		LootSalvLast = LootIndex;
		break;

	    case "chkSal9":
		var LootIndex = parseInt(dictSzValue("salvageChoice"));
		with (Loot.SalvageFilter[LootIndex]) {
		    if (CombineMask & combineMaskVal[9]) {
			CombineMask &= ~combineMaskVal[9];
		    } else {
			CombineMask |= combineMaskVal[9];
		    } // endif
		    skapi.SetControlProperty(szPanelLoot, "chkSal9", "checked", (CombineMask & combineMaskVal[9]));
		} // end with
		Loot.SetWorkRange(LootIndex);
		LootSalvLast = LootIndex;
		break;

	    case "chkSal10":
		var LootIndex = parseInt(dictSzValue("salvageChoice"));
		with (Loot.SalvageFilter[LootIndex]) {
		    if (CombineMask & combineMaskVal[10]) {
			CombineMask &= ~combineMaskVal[10];
		    } else {
			CombineMask |= combineMaskVal[10];
		    } // endif
		    skapi.SetControlProperty(szPanelLoot, "chkSal10", "checked", (CombineMask & combineMaskVal[10]));
		} // end with
		Loot.SetWorkRange(LootIndex);
		LootSalvLast = LootIndex;
		break;

	    case "btnSalvNext":
		var LootIndex = parseInt(dictSzValue("salvageChoice"));
		LootIndex++;
		if (LootIndex == Loot.SalvageFilter.length) LootIndex = 0;
		skapi.SetControlProperty(szPanelLoot, "salvageChoice", "selected", LootIndex);
		break;

	    case "btnSalvPrev":
		var LootIndex = parseInt(dictSzValue("salvageChoice"));
		LootIndex--;
		if (LootIndex < 0) LootIndex = Loot.SalvageFilter.length-1;
		skapi.SetControlProperty(szPanelLoot, "salvageChoice", "selected", LootIndex);
		break;

	    case "btnSalvSetPrev":
		var LootIndex = parseInt(dictSzValue("salvageChoice"));
		if (LootIndex == LootSalvPrev) {
		    Chat.Screen("Previous examined salvage item is same as current, aborted.");
		    break;
		} // endif

		Loot.SalvageFilter[LootIndex].Enabled 	  = Loot.SalvageFilter[LootSalvPrev].Enabled;
		Loot.SalvageFilter[LootIndex].ExcludeVal  = Loot.SalvageFilter[LootSalvPrev].ExcludeVal;
		Loot.SalvageFilter[LootIndex].MinWork	  = Loot.SalvageFilter[LootSalvPrev].MinWork;
		Loot.SalvageFilter[LootIndex].MaxBU	  = Loot.SalvageFilter[LootSalvPrev].MaxBU;
		Loot.SalvageFilter[LootIndex].CombineMask = Loot.SalvageFilter[LootSalvPrev].CombineMask;
    		Loot.SetWorkRange(LootIndex);	// Rebuild work range from combine mask

		DisplayLootSalvage(LootIndex);
		if (flagVerbose) Chat.Screen("Current salvage item set same as previous examined.");
		LootSalvLast = LootIndex;
		break;

	    case "btnSalvSetLast":
	        if (LootSalvLast < 0)  {
		    Chat.Screen("No Salvage items modified since macro start, can't set as last modified!");
		    break;
		} // endif

		var LootIndex = parseInt(dictSzValue("salvageChoice"));
		if (LootIndex == LootSalvLast ) {
		    Chat.Screen("Last modified Salvage item is same as current, aborted.");
		    break;
		} // endif

		Loot.SalvageFilter[LootIndex].Enabled 	  = Loot.SalvageFilter[LootSalvLast].Enabled;
		Loot.SalvageFilter[LootIndex].ExcludeVal  = Loot.SalvageFilter[LootSalvLast].ExcludeVal;
		Loot.SalvageFilter[LootIndex].MinWork	  = Loot.SalvageFilter[LootSalvLast].MinWork;
		Loot.SalvageFilter[LootIndex].MaxBU	  = Loot.SalvageFilter[LootSalvLast].MaxBU;
		Loot.SalvageFilter[LootIndex].CombineMask = Loot.SalvageFilter[LootSalvLast].CombineMask;
    		Loot.SetWorkRange(LootIndex);	// Rebuild work range from combine mask

		DisplayLootSalvage(LootIndex);
		LootSalvLast = LootIndex;
		if (flagVerbose) Chat.Screen("Current salvage set same as last modified salvage.");
		break;

	    case "btnSalvShowEnab":
		Loot.ShowSalvage(true);
		break;

	    case "btnSalvReset":
	        var LootIndex = parseInt(dictSzValue("salvageChoice"));
		Loot.ResetSalvage();
		DisplayLootSalvage(LootIndex);
		Chat.Screen("All salvage reset to default settings!");
		break;

	    case "btnSalvShowAll":
		Loot.ShowSalvage(false);
		break;

	    case "btnSalvLikeThis":
		var LootIndex = parseInt(dictSzValue("salvageChoice"));
		for (var x=0; x<Loot.SalvageFilter.length; x++) {
		    if ((x == LootIndex) || (Loot.SalvageFilter[x].Type != Loot.SalvageFilter[LootIndex].Type)) continue;
		    Loot.SalvageFilter[x].Enabled     = Loot.SalvageFilter[LootIndex].Enabled;
		    Loot.SalvageFilter[x].ExcludeVal  = Loot.SalvageFilter[LootIndex].ExcludeVal;
		    Loot.SalvageFilter[x].MinWork     = Loot.SalvageFilter[LootIndex].MinWork;
		    Loot.SalvageFilter[x].MaxBU	      = Loot.SalvageFilter[LootIndex].MaxBU;
		    Loot.SalvageFilter[x].CombineMask = Loot.SalvageFilter[LootIndex].CombineMask;
    		    Loot.SetWorkRange(x);	// Rebuild work range from combine mask
		} // endfor
		if (flagVerbose) Chat.Screen("All salvage of same type set like this one!");
		break;

	    // Wand options ******************************************

	    case "wandChoice":
		LootWandPrev = LootWandIndex;
		LootWandIndex = parseInt(dictSzValue("wandChoice"));
		DisplayLootWand(LootWandIndex);
		break;

	    case "chkWandEnab":
		var LootIndex = parseInt(dictSzValue("wandChoice"));
		Chat.Screen("LootIndex [" + LootIndex + "]");
		with (Loot.WandFilter[LootIndex]) {
		    Enabled = !Enabled;
		    skapi.SetControlProperty(szPanelLoot, "chkWandEnab", "checked", Enabled);
		} // end with
		LootWandLast = LootIndex;
		break;

	    case "editLoot6a":
		szExp = dictSzValue("editLoot6a");
		if (isNaN(szExp) || (szExp == undefined) || (szExp == "")) {
		    Chat.Screen("Invalid number entered");
		    break;
		} // endif
		var LootIndex = parseInt(dictSzValue("wandChoice"));
		intExp = parseInt(szExp);
		with (Loot.WandFilter[LootIndex]) {
		    MaxValue = intExp;
		    skapi.SetControlProperty(szPanelLoot, "text6av", "text", MaxValue);
		} // endwith
		LootWandLast = LootIndex;
		break;

	    case "choiceLoot6b":
		var LootIndex = parseInt(dictSzValue("wandChoice"));
		var MinManaC = parseInt(dictSzValue("choiceLoot6b"));
		if (MinManaC == Loot.WandFilter[LootIndex].MinManaC) break;
		Loot.WandFilter[LootIndex].MinManaC = MinManaC;
		LootWandLast = LootIndex;
		break;

	    case "choiceLoot6c":
		var LootIndex = parseInt(dictSzValue("wandChoice"));
		var MinMeleeD = parseInt(dictSzValue("choiceLoot6c"));
		if (MinMeleeD == Loot.WandFilter[LootIndex].MinMeleeD) break;
		Loot.WandFilter[LootIndex].MinMeleeD = MinMeleeD;
		LootWandLast = LootIndex;
		break;

	    case "choiceLoot6d":
		var LootIndex = parseInt(dictSzValue("wandChoice"));
		var AndOrFlag = parseInt(dictSzValue("choiceLoot6d"));
		if (AndOrFlag == Loot.WandFilter[LootIndex].AndOrFlag) break;
		Loot.WandFilter[LootIndex].AndOrFlag = AndOrFlag;
		LootWandLast = LootIndex;
		break;

	    case "btnWandNext":
		var LootIndex = parseInt(dictSzValue("wandChoice"));
		LootIndex++;
		if (LootIndex == 11) LootIndex = 1;
		skapi.SetControlProperty(szPanelLoot, "wandChoice", "selected", LootIndex-1);
		break;

	    case "btnWandPrev":
		var LootIndex = parseInt(dictSzValue("wandChoice"));
		LootIndex--;
		if (LootIndex == 0) LootIndex = 10;
		skapi.SetControlProperty(szPanelLoot, "wandChoice", "selected", LootIndex-1);
		break;

	    case "btnWandShow":
		Loot.ShowWand();
		break;

	    case "btnWandReset":
	        var LootIndex = parseInt(dictSzValue("wandChoice"));
		Loot.ResetWand();
		DisplayLootWand(LootIndex);
		Chat.Screen("All wand info reset to default settings!");
		break;

	    // Jewelry Config *************************************************

	    case "choiceLoot7b":
		Loot.JewelryFilter.MinSplLvl1 = parseInt(dictSzValue("choiceLoot7b"));
		break;

	    case "choiceLoot7c":
		Loot.JewelryFilter.MinSplLvl2 = parseInt(dictSzValue("choiceLoot7c"));
		break;

	    case "choiceLoot7d":
		Loot.JewelryFilter.MinSplLvl3 = parseInt(dictSzValue("choiceLoot7d"));
		break;

	    // Clothing Config *************************************************

	    case "choiceLoot7g":
		Loot.ClothingFilter.MinSplLvl1 = parseInt(dictSzValue("choiceLoot7g"));
		break;

	    case "choiceLoot7h":
		Loot.ClothingFilter.MinSplLvl2 = parseInt(dictSzValue("choiceLoot7h"));
		break;

	    case "choiceLoot7i":
		Loot.ClothingFilter.MinSplLvl3 = parseInt(dictSzValue("choiceLoot7i"));
		break;

	    // Valuable Salvage Config *******************************************

	    case "editLoot7l":
		szExp = dictSzValue("editLoot7l");
		if (isNaN(szExp) || (szExp == undefined) || (szExp == "")) {
		    Chat.Screen("Invalid number entered");
		    break;
		} // endif
		Loot.ValSalvFilter.MinRatio = parseInt(szExp);
		skapi.SetControlProperty(szPanelLoot, "text7lv", "text", Loot.ValSalvFilter.MinRatio);
		break;

	    case "editLoot7m":
		szExp = dictSzValue("editLoot7m");
		if (isNaN(szExp) || (szExp == undefined) || (szExp == "")) {
		    Chat.Screen("Invalid number entered");
		    break;
		} // endif
		Loot.ValSalvFilter.MaxBagValue = parseInt(szExp);
		skapi.SetControlProperty(szPanelLoot, "text7mv", "text", Loot.ValSalvFilter.MaxBagValue);
		break;


	    // Scroll Config *************************************************

	    case "choiceLoot8c":
		Loot.ScrollFilter.MinLvl = parseInt(dictSzValue("choiceLoot8c"));
		break;

	    case "choiceLoot8d":
		Loot.ScrollFilter.MaxLvl = parseInt(dictSzValue("choiceLoot8d"));
		break;

	    case "chkScrollUnk":
		Loot.ScrollFilter.UnknownOnly = !Loot.ScrollFilter.UnknownOnly;
		skapi.SetControlProperty(szPanelLoot, "chkScrollUnk", "checked", Loot.ScrollFilter.UnknownOnly);
		break;
		
	    case "chkLearnUnk":
		Loot.ScrollFilter.LearnUnknown = !Loot.ScrollFilter.LearnUnknown;
		skapi.SetControlProperty(szPanelLoot, "chkLearnUnk", "checked", Loot.ScrollFilter.LearnUnknown);
		break;


	    // Item Config *************************************************

	    case "itemChoice":
		LootIndex = parseInt(dictSzValue("itemChoice"));
		DisplayLootItem(LootIndex);
		break;

	    case "chkItemEnab":
		var LootIndex = parseInt(dictSzValue("itemChoice"));
		Loot.ItemFilter[LootIndex].Enabled = !Loot.ItemFilter[LootIndex].Enabled;
		skapi.SetControlProperty(szPanelLoot, "chkItemEnab", "checked", Loot.ItemFilter[LootIndex].Enabled);
		break;

	    case "chkItemAlert":
		var LootIndex = parseInt(dictSzValue("itemChoice"));
		Loot.ItemFilter[LootIndex].Alert = !Loot.ItemFilter[LootIndex].Alert;
		skapi.SetControlProperty(szPanelLoot, "chkItemAlert", "checked", Loot.ItemFilter[LootIndex].Alert);
		break;

	    case "btnItemNext":
		var LootIndex = parseInt(dictSzValue("itemChoice"));
		LootIndex++;
		if (LootIndex == Loot.ItemFilter.length) LootIndex = 0;
		skapi.SetControlProperty(szPanelLoot, "ItemChoice", "selected", LootIndex);
		break;

	    case "btnItemPrev":
		var LootIndex = parseInt(dictSzValue("itemChoice"));
		LootIndex--;
		if (LootIndex < 0) LootIndex = Loot.ItemFilter.length-1;
		skapi.SetControlProperty(szPanelLoot, "itemChoice", "selected", LootIndex);
		break;

	    case "btnItemShow":
		if(!Loot.ShowItem(true)) Chat.Screen("No items enabled or have alert flag set!");
		break;

	    case "btnItemReset":
	        var LootIndex = parseInt(dictSzValue("itemChoice"));
		Loot.ResetItem();
		DisplayLootItem(LootIndex);
		Chat.Screen("All item info reset to default settings!");
		break;


	    // Valuable Config *************************************************

	    case "editLoot8g":
		szExp = dictSzValue("editLoot8g");
		if (isNaN(szExp) || (szExp == undefined) || (szExp == "")) {
		    Chat.Screen("Invalid number entered");
		    break;
		} // endif
		Loot.ValuableFilter.MinValue = parseInt(szExp);
		skapi.SetControlProperty(szPanelLoot, "text8gv", "text", Loot.ValuableFilter.MinValue);
		break;

	    case "editLoot8h":
		szExp = dictSzValue("editLoot8h");
		if (isNaN(szExp) || (szExp == undefined) || (szExp == "")) {
		    Chat.Screen("Invalid number entered");
		    break;
		} // endif
		Loot.ValuableFilter.MaxBU = parseInt(szExp);
		skapi.SetControlProperty(szPanelLoot, "text8hv", "text", Loot.ValuableFilter.MaxBU);
		break;

	    case "editLoot8i":
		szExp = dictSzValue("editLoot8i");
		if (isNaN(szExp) || (szExp == undefined) || (szExp == "")) {
		    Chat.Screen("Invalid number entered");
		    break;
		} // endif
		Loot.ValuableFilter.MaxTotal = parseInt(szExp);
		skapi.SetControlProperty(szPanelLoot, "text8iv", "text", Loot.ValuableFilter.MaxTotal);
		break;

	} // end switch
	if (debugEvent||debugCmds) Log.OutD("Main_OnControlEvent: End, Loot");
    	return;
    } // endif


   if (szPanel == szPanelCreature) {
	// Process Loot Panel Controls
	switch (szControl) {

	    // G(eneral) tab ******************************************

	    case "btnCreLoad":
	       	var FileNum = parseInt(dictSzValue("loadCre"));
	       	Chat.Screen("Loading creature configuration info...");
	        var Status = CreLoad(FileNum);	// Load info from file
	        if (Status) {
		    SetCreatureControls();	// Now reset decal panels
		    Chat.Screen("Loaded creature configuration info from file " + CreFileName);
		} else {
		    Chat.Screen("File " + CreFileName + " not found!");
		} // endif
	        break;

	    case "btnCreSave":
	       	var FileNum = parseInt(dictSzValue("saveCre"));
	       	Chat.Screen("Saving creature configuration info...");
		CreSave(FileNum);
		Chat.Screen("Creature configuration info saved to file " + CreFileName);
	        break;

	    case "btnCreReset":
	    	Chat.Screen("Resetting creature database...");
		Creature.ResetRace();	// Reset race database
		Creature.ResetCre();	// Reset creature database
		SetCreatureControls();	// Now update decal panels with new settings
		Chat.Screen("Creature configuration reset to defaults!");
	        break;

	    case "editMinExp":
		szMinExp = (dictSzValue("editMinExp"));
		if (isNaN(szMinExp) || (szMinExp == undefined) || (szMinExp == "")) {
		    Chat.Screen("Invalid number entered");
		} else {
		    selMinExp = parseInt(szMinExp);
		    skapi.SetControlProperty(szPanelCreature, "textExp2", "text", "Cur: " + selMinExp);
		    if (flagVerbose) Chat.Screen("Minimum creature experience for selection set to: " + selMinExp);
		    if (logDecal||debugDecal||logSelect||debugSelect)
		        Log.OutD("OnControlEvent: Minimum creature experience for selection set to: " + selMinExp);
		} // endif
		break;

   	    // R(ace) tab  *******************************************
	    case "raceList2":
		Race2Offset = parseInt(dictSzValue("raceList2"));
		Race2Index  = Creature.RaceDecal[Race2Offset];
		// Chat.Screen("raceList2 = " + Race2Index);
		DisplayRace(Race2Index);
		break;

	    case "btnRace2Next":
		Race2Offset = parseInt(dictSzValue("raceList2"));
		Race2Offset++;
		if (Race2Offset == Creature.RaceDecalCnt) Race2Offset = 0;
		skapi.SetControlProperty(szPanelCreature, "raceList2", "selected", Race2Offset);
		break;

	    case "btnRace2Prev":
		Race2Offset = parseInt(dictSzValue("raceList2"));
		Race2Offset--;
		if (Race2Offset < 0) Race2Offset = Creature.RaceDecalCnt - 1;
		skapi.SetControlProperty(szPanelCreature, "raceList2", "selected", Race2Offset);
		break;

	    case "btnResetRace2":
	        // Reset the info for this race, not the creatures that are members of the race
		Race2Offset = parseInt(dictSzValue("raceList2"));
		Race2Index  = Creature.RaceDecal[Race2Offset];
		Creature.ResetRace(Race2Index);
		DisplayRace(Race2Index);
		Chat.Screen("Race [" + Creature.RaceInfo[Race2Index].RaceName + "] reset.");
		break;

	    case "btnResetRaceAll":
	        // Reset the info for all races, but not any creatures
		Creature.ResetRace();
		Race2Offset = parseInt(dictSzValue("raceList2"));
		Race2Index  = Creature.RaceDecal[Race2Offset];
		DisplayRace(Race2Index);
		Chat.Screen("All race info reset.");
		break;
		
	    case "btnShowRace2":
		ShowRaceAll(false);
		break;

	    case "btnShowRaceDis":
		ShowRaceAll(true);
		break;

	    case "vulnDefChoice":
	        DefVulnIndex  = parseInt(dictSzValue("vulnDefChoice"));
		Race2Offset = parseInt(dictSzValue("raceList2"));
		Race2Index  = Creature.RaceDecal[Race2Offset];
		with (Creature.RaceInfo[Race2Index]) {
		    if (DefVulnIndex == DefVuln) {
			// Same value so ignore this event.  Probably generated by a display request
			break;
		    } // endif
		    // Chat.Screen("DefVulnIndex = [" + DefVulnIndex + "]");
		    DefVuln = DefVulnIndex;
		    if (flagVerbose) Chat.Screen("Race [" + RaceName + "] default vuln set to: " + damName[DefVuln]);
		} // end with
		break;

	    case "selRChoice":
	        SelIndex  = parseInt(dictSzValue("selRChoice"));
		Race2Offset = parseInt(dictSzValue("raceList2"));
		Race2Index  = Creature.RaceDecal[Race2Offset];
		with (Creature.RaceInfo[Race2Index]) {
		    if (SelIndex == SelFlag) {
			// Same value so ignore this event.  Probably generated by a display request
			break;
		    } // endif
		    // Chat.Screen("selRChoice = [" + SelIndex + "]");
		    SelFlag = SelIndex;
		    if (flagVerbose) Chat.Screen("Race [" + RaceName + "] select flag set to: " + AttText[SelFlag]);
		} // end with
		break;	
	
	    case "attRChoice":
		AttIndex  = parseInt(dictSzValue("attRChoice"));
		Race2Offset = parseInt(dictSzValue("raceList2"));
		Race2Index  = Creature.RaceDecal[Race2Offset];
		with (Creature.RaceInfo[Race2Index]) {
		    if (AttIndex == AttFlag) {
			// Same value so ignore this event.  Probably generated by a display request
			break;
		    } // endif
		    // Chat.Screen("attRChoice = [" + AttIndex + "]");
		    AttFlag = AttIndex;
		    if (flagVerbose) Chat.Screen("Race [" + RaceaName + "] attack flag set to: " + AttText[AttFlag]);
		} // end with
		break;


    	    // C(reature) tab  *******************************************

	    case "raceList3":
		Race3Offset = parseInt(dictSzValue("raceList3"));
		Race3Index  = Creature.RaceDecal[Race3Offset];
		// Chat.Screen("raceList3 = " + Race3Index);
		
		// Clear out current choice box options
		skapi.GetControlProperty(szPanelCreature, "creList", "Clear()");

		// Now reload them with creatures in new race selected in race choicebox
		with (Creature.RaceInfo[Race3Index]) {
		    if (AListCnt == 0) {
			skapi.GetControlProperty(szPanelCreature, "creList",
			 	"AddChoice(\"-- Race Empty --\", 0 )" );
			 	
		    } else {
			for (var x=0; x<AListCnt; x++) {
		    	    var CreIdx = AList[x];
			    skapi.GetControlProperty(szPanelCreature, "creList",
			        "AddChoice(\"" + Creature.Info[CreIdx].Name + "\", " + x + ")" );
			} // end for
		    } // endif
		} // end with

		skapi.SetControlProperty(szPanelCreature, "creList", "selected", 0);
		break;

	    case "creList":
	        CreOffset = parseInt(dictSzValue("creList"));
	        if (isNaN(CreOffset)) {
		    // Chat.Screen("creList: NaN");
		    break;
		} // endif
		// Chat.Screen("creList = " + CreOffset);
		
		Race3Offset = parseInt(dictSzValue("raceList3"));
		Race3Index  = Creature.RaceDecal[Race3Offset];
		if (Creature.RaceInfo[Race3Index].AListCnt == 0) {
		    BlankCreature();
		} else {
		    CreIndex = Creature.RaceInfo[Race3Index].AList[CreOffset];
	            DisplayCreature(CreIndex);
	        } // endif
	        break;

	    case "btnRace3Next":
		Race3Offset = parseInt(dictSzValue("raceList3"));
		Race3Offset++;
		if (Race3Offset == Creature.RaceDecalCnt) Race3Offset = 0;
		skapi.SetControlProperty(szPanelCreature, "raceList3", "selected", Race3Offset);
		break;

	    case "btnRace3Prev":
		Race3Offset = parseInt(dictSzValue("raceList3"));
		Race3Offset--;
		if (Race3Offset < 0) Race3Offset = Creature.RaceDecalCnt - 1;
		skapi.SetControlProperty(szPanelCreature, "raceList3", "selected", Race3Offset);
		break;

	    case "btnCreNext":
		Race3Offset = parseInt(dictSzValue("raceList3"));
		Race3Index  = Creature.RaceDecal[Race3Offset];
		if (Creature.RaceInfo[Race3Index].AListCnt == 0) break;
		with (Creature.RaceInfo[Race3Index]) {
		    CreOffset = parseInt(dictSzValue("creList"));
		    CreOffset++;
		    if (CreOffset == AListCnt) CreOffset = 0;
		    skapi.SetControlProperty(szPanelCreature, "creList", "selected", CreOffset);
		} // end with
		break;

	    case "btnCrePrev":
		Race3Offset = parseInt(dictSzValue("raceList3"));
		Race3Index  = Creature.RaceDecal[Race3Offset];
		if (Creature.RaceInfo[Race3Index].AListCnt == 0) break;
		with (Creature.RaceInfo[Race3Index]) {
		    CreOffset = parseInt(dictSzValue("creList"));
		    CreOffset--;
		    if (CreOffset < 0) CreOffset = AListCnt - 1;
		    skapi.SetControlProperty(szPanelCreature, "creList", "selected", CreOffset);
		} // end with
		break;
	
	    case "btnResetRace":
	        // Reset the info for all creatures in this race
		Race3Offset = parseInt(dictSzValue("raceList3"));
		Race3Index  = Creature.RaceDecal[Race3Offset];
		if (Creature.RaceInfo[Race3Index].AListCnt == 0) {
		    Chat.Screen("No creatures in this race.");
		    break;
		} // endif
		with (Creature.RaceInfo[Race3Index]) {
		    for (var x=0; x<AListCnt ;x++) {
		    	Index = AList[x];
			Creature.ResetCre(Index);
		    } // endfor
		
		    // Now redisplay the current creature
		    CreOffset   = parseInt(dictSzValue("creList"));
		    CreIndex    = AList[CreOffset];
		    DisplayCreature(CreIndex);
		    Chat.Screen("Creatures that are members of race [" + RaceName + "] reset.");
		} // end with
		break;	    

	    case "btnResetCre":
		Race3Offset = parseInt(dictSzValue("raceList3"));
		Race3Index  = Creature.RaceDecal[Race3Offset];
		if (Creature.RaceInfo[Race3Index].AListCnt == 0) {
		    Chat.Screen("No creatures in this race.");
		    break;
		} // endif
		CreOffset   = parseInt(dictSzValue("creList"));
		CreIndex    = Creature.RaceInfo[Race3Index].AList[CreOffset];
		Creature.ResetCre(CreIndex);
		DisplayCreature(CreIndex);
		Chat.Screen("Creature [" + Creature.Info[CreIndex].Name + "] reset.");
		break;	    

	    case "btnRaceLikeThis":
		Race3Offset = parseInt(dictSzValue("raceList3"));
		Race3Index  = Creature.RaceDecal[Race3Offset];
		if (Creature.RaceInfo[Race3Index].AListCnt == 0) {
		    Chat.Screen("No creatures in this race.");
		    break;
		} // endif
		CreOffset   = parseInt(dictSzValue("creList"));
		CreIndex    = Creature.RaceInfo[Race3Index].AList[CreOffset];
		for (var x=0; x<Creature.RaceInfo[Race3Index].AListCnt; x++) {
		    if (x==CreOffset) continue;	// Skip current creature displayed as it is the source creature
		    var Dest = Creature.RaceInfo[Race3Index].AList[x];
		    Creature.Info[Dest].Vuln1		= Creature.Info[CreIndex].Vuln1;
		    Creature.Info[Dest].Vuln2		= Creature.Info[CreIndex].Vuln2;
		    Creature.Info[Dest].Vuln3		= Creature.Info[CreIndex].Vuln3;
		    Creature.Info[Dest].SelFlag		= Creature.Info[CreIndex].SelFlag;
		    Creature.Info[Dest].AttFlag		= Creature.Info[CreIndex].AttFlag;
		    Creature.Info[Dest].YieldFlag	= Creature.Info[CreIndex].YieldFlag;
		    Creature.Info[Dest].VulnFlag	= Creature.Info[CreIndex].VulnFlag;
		    Creature.Info[Dest].WarSpell	= Creature.Info[CreIndex].WarSpell;
		    Creature.Info[Dest].NoDrainHealth   = Creature.Info[CreIndex].NoDrainHealth;
		    Creature.Info[Dest].NoDrainStamina  = Creature.Info[CreIndex].NoDrainStamina;
		    Creature.Info[Dest].NoDrainMana	= Creature.Info[CreIndex].NoDrainMana;
		    Creature.Info[Dest].NoStepDown	= Creature.Info[CreIndex].NoStepDown;
		    Creature.Info[Dest].DangerFlag	= Creature.Info[CreIndex].DangerFlag;
		} // end for
		Chat.Screen("All creatures in race set like this one.");
		break;	    

	    case "vuln1Choice":
	        Vuln1Index  = parseInt(dictSzValue("vuln1Choice"));
		Race3Offset = parseInt(dictSzValue("raceList3"));
		Race3Index  = Creature.RaceDecal[Race3Offset];
		if (Creature.RaceInfo[Race3Index].AListCnt == 0) break;

		CreOffset   = parseInt(dictSzValue("creList"));
		CreIndex    = Creature.RaceInfo[Race3Index].AList[CreOffset];
		with (Creature.Info[CreIndex]) {
		    if (Vuln1Index == Vuln1) {
			// Same value so ignore this event.  Probably generated by a display request
			break;
		    } // endif
		    // Chat.Screen("vuln1Choice = [" + Vuln1Index + "]");
		    Vuln1 = Vuln1Index;
		} // end with
		break;	

	    case "vuln2Choice":
	        Vuln2Index  = parseInt(dictSzValue("vuln2Choice"));
		Race3Offset = parseInt(dictSzValue("raceList3"));
		Race3Index  = Creature.RaceDecal[Race3Offset];
		if (Creature.RaceInfo[Race3Index].AListCnt == 0) break;

		CreOffset   = parseInt(dictSzValue("creList"));
		CreIndex    = Creature.RaceInfo[Race3Index].AList[CreOffset];
		with (Creature.Info[CreIndex]) {
		    if (Vuln2Index == Vuln2) {
			// Same value so ignore this event.  Probably generated by a display request
			break;
		    } // endif
		    // Chat.Screen("vuln2Choice = [" + Vuln2Index + "]");
		    Vuln2 = Vuln2Index;
		} // end with
		break;	

	    case "vuln3Choice":
		Vuln3Index  = parseInt(dictSzValue("vuln3Choice"));
		Race3Offset = parseInt(dictSzValue("raceList3"));
		Race3Index  = Creature.RaceDecal[Race3Offset];
		if (Creature.RaceInfo[Race3Index].AListCnt == 0) break;

		CreOffset   = parseInt(dictSzValue("creList"));
		CreIndex    = Creature.RaceInfo[Race3Index].AList[CreOffset];
		with (Creature.Info[CreIndex]) {
		    if (Vuln3Index == Vuln3) {
			// Same value so ignore this event.  Probably generated by a display request
			break;
		    } // endif
		    // Chat.Screen("vuln3Choice = [" + Vuln3Index + "]");
		    Vuln3 = Vuln3Index;
		} // end with
		break;	
	
	    case "editCre3l":
		szPrio = (dictSzValue("editCre3l"));
		if ((szPrio == undefined) || (szPrio == "") || isNaN(szPrio)) {
		    Chat.Screen("Invalid number entered");
		} else {
		    Race3Offset = parseInt(dictSzValue("raceList3"));
		    Race3Index  = Creature.RaceDecal[Race3Offset];
		    if (Creature.RaceInfo[Race3Index].AListCnt == 0) break;
		    CreOffset   = parseInt(dictSzValue("creList"));
		    CreIndex    = Creature.RaceInfo[Race3Index].AList[CreOffset];
		    with (Creature.Info[CreIndex]) {
			Priority = parseInt(szPrio);
			skapi.SetControlProperty(szPanelCreature, "text3lv", "text", Priority);
			if (flagVerbose) Chat.Screen("Creature [" + Name + "] priority set to: " + Priority);
			if (logDecal||debugDecal||logSelect||debugSelect)
			    Log.OutD("OnControlEvent: Creature [" + Name + "] priority set to: " + Priority);
		    } // end with
		} // endif
		break;

	    case "selChoice":
	        SelIndex  = parseInt(dictSzValue("selChoice"));
		Race3Offset = parseInt(dictSzValue("raceList3"));
		Race3Index  = Creature.RaceDecal[Race3Offset];
		if (Creature.RaceInfo[Race3Index].AListCnt == 0) break;
		CreOffset   = parseInt(dictSzValue("creList"));
		CreIndex    = Creature.RaceInfo[Race3Index].AList[CreOffset];
		with (Creature.Info[CreIndex]) {
		    if (SelIndex == SelFlag) {
			// Same value so ignore this event.  Probably generated by a display request
			break;
		    } // endif
		    // Chat.Screen("selChoice = [" + SelIndex + "]");
		    SelFlag = SelIndex;
		    if (flagVerbose) Chat.Screen("Creature [" + Name + "] select flag set to: " + AttText[SelFlag]);
		} // end with
		break;	
	
	    case "attChoice":
		AttIndex  = parseInt(dictSzValue("attChoice"));
		Race3Offset = parseInt(dictSzValue("raceList3"));
		Race3Index  = Creature.RaceDecal[Race3Offset];
		if (Creature.RaceInfo[Race3Index].AListCnt == 0) break;
		CreOffset   = parseInt(dictSzValue("creList"));
		CreIndex    = Creature.RaceInfo[Race3Index].AList[CreOffset];
		with (Creature.Info[CreIndex]) {
		    if (AttIndex == AttFlag) {
			// Same value so ignore this event.  Probably generated by a display request
			break;
		    } // endif
		    // Chat.Screen("attChoice = [" + AttIndex + "]");
		    AttFlag = AttIndex;
		    if (flagVerbose) Chat.Screen("Creature [" + Name + "] attack flag set to: " + AttText[AttFlag]);
		} // end with
		break;

	    case "yieldChoice":
		YieldIndex  = parseInt(dictSzValue("yieldChoice"));
		Race3Offset = parseInt(dictSzValue("raceList3"));
		Race3Index  = Creature.RaceDecal[Race3Offset];
		if (Creature.RaceInfo[Race3Index].AListCnt == 0) break;
		CreOffset   = parseInt(dictSzValue("creList"));
		CreIndex    = Creature.RaceInfo[Race3Index].AList[CreOffset];
		with (Creature.Info[CreIndex]) {
		    if (YieldIndex == YieldFlag) {
			// Same value so ignore this event.  Probably generated by a display request
			break;
		    } // endif
		    // Chat.Screen("yieldChoice = [" + YieldIndex + "]");
		    YieldFlag = YieldIndex;
		    if (flagVerbose) Chat.Screen("Creature [" + Name + "] yield flag set to: " + AttText[YieldFlag]);
		} // end with
		break;

	    case "vulnChoice":
		VulnIndex  = parseInt(dictSzValue("vulnChoice"));
		Race3Offset = parseInt(dictSzValue("raceList3"));
		Race3Index  = Creature.RaceDecal[Race3Offset];
		if (Creature.RaceInfo[Race3Index].AListCnt == 0) break;
		CreOffset   = parseInt(dictSzValue("creList"));
		CreIndex    = Creature.RaceInfo[Race3Index].AList[CreOffset];
		with (Creature.Info[CreIndex]) {
		    if (VulnIndex == VulnFlag) {
			// Same value so ignore this event.  Probably generated by a display request
			break;
		    } // endif
		    // Chat.Screen("vulnChoice = [" + VulnIndex + "]");
		    VulnFlag = VulnIndex;
		    if (flagVerbose) Chat.Screen("Creature [" + Name + "] vuln flag set to: " + AttText[VulnFlag]);
		} // end with
		break;

	    case "warChoice":
		WarIndex  = parseInt(dictSzValue("warChoice"));
		Race3Offset = parseInt(dictSzValue("raceList3"));
		Race3Index  = Creature.RaceDecal[Race3Offset];
		if (Creature.RaceInfo[Race3Index].AListCnt == 0) break;
		CreOffset   = parseInt(dictSzValue("creList"));
		CreIndex    = Creature.RaceInfo[Race3Index].AList[CreOffset];
		with (Creature.Info[CreIndex]) {
		    if (WarIndex == WarSpell) {
			// Same value so ignore this event.  Probably generated by a display request
			break;
		    } // endif
		    // Chat.Screen("warChoice = [" + WarIndex + "]");
		    WarSpell = WarIndex;
		    if (flagVerbose) Chat.Screen("Creature [" + Name + "] war spell set to: " + attSpellText[WarSpell]);
		} // end with
		break;

	    case "chkNoDrainH":
		Race3Offset = parseInt(dictSzValue("raceList3"));
		Race3Index  = Creature.RaceDecal[Race3Offset];
		if (Creature.RaceInfo[Race3Index].AListCnt == 0) break;
		CreOffset   = parseInt(dictSzValue("creList"));
		CreIndex    = Creature.RaceInfo[Race3Index].AList[CreOffset];
	    	with (Creature.Info[CreIndex]) {
		    NoDrainHealth = !NoDrainHealth;
		    skapi.SetControlProperty(szPanelCreature, "chkNoDrainH", "checked", NoDrainHealth);
		    if (flagVerbose) Chat.Screen("Creature [" + Name + "] NoDrainHealth set to: " + NoDrainHealth);
		} // end with
		break;

	    case "chkNoDrainS":
		Race3Offset = parseInt(dictSzValue("raceList3"));
		Race3Index  = Creature.RaceDecal[Race3Offset];
		if (Creature.RaceInfo[Race3Index].AListCnt == 0) break;
		CreOffset   = parseInt(dictSzValue("creList"));
		CreIndex    = Creature.RaceInfo[Race3Index].AList[CreOffset];
	    	with (Creature.Info[CreIndex]) {
		    NoDrainStamina = !NoDrainStamina;
		    skapi.SetControlProperty(szPanelCreature, "chkNoDrainS", "checked", NoDrainStamina);
		    if (flagVerbose) Chat.Screen("Creature [" + Name + "] NoDrainStamina set to: " + NoDrainStamina);
		} // end with
		break;

	    case "chkNoDrainM":
		Race3Offset = parseInt(dictSzValue("raceList3"));
		Race3Index  = Creature.RaceDecal[Race3Offset];
		if (Creature.RaceInfo[Race3Index].AListCnt == 0) break;
		CreOffset   = parseInt(dictSzValue("creList"));
		CreIndex    = Creature.RaceInfo[Race3Index].AList[CreOffset];
	    	with (Creature.Info[CreIndex]) {
		    NoDrainMana = !NoDrainMana;
		    skapi.SetControlProperty(szPanelCreature, "chkNoDrainM", "checked", NoDrainMana);
		    if (flagVerbose) Chat.Screen("Creature [" + Name + "] NoDrainMana set to: " + NoDrainMana);
		} // end with
		break;

	    case "chkNoStepDown":
		Race3Offset = parseInt(dictSzValue("raceList3"));
		Race3Index  = Creature.RaceDecal[Race3Offset];
		if (Creature.RaceInfo[Race3Index].AListCnt == 0) break;
		CreOffset   = parseInt(dictSzValue("creList"));
		CreIndex    = Creature.RaceInfo[Race3Index].AList[CreOffset];
	    	with (Creature.Info[CreIndex]) {
		    NoStepDown = !NoStepDown;
		    skapi.SetControlProperty(szPanelCreature, "chkNoStepDown", "checked", NoStepDown);
		    if (flagVerbose) Chat.Screen("Creature [" + Name + "] NoStepDown set to: " + NoStepDown);
		} // end with
		break;

	    case "chkDangerFlag":
		Race3Offset = parseInt(dictSzValue("raceList3"));
		Race3Index  = Creature.RaceDecal[Race3Offset];
		if (Creature.RaceInfo[Race3Index].AListCnt == 0) break;
		CreOffset   = parseInt(dictSzValue("creList"));
		CreIndex    = Creature.RaceInfo[Race3Index].AList[CreOffset];
	    	with (Creature.Info[CreIndex]) {
		    DangerFlag = !DangerFlag;
		    skapi.SetControlProperty(szPanelCreature, "chkDangerFlag", "checked", DangerFlag);
		    if (flagVerbose) Chat.Screen("Creature [" + Name + "] DangerFlag set to: " + DangerFlag);
		} // end with
		break;

	} // end switch
 	if (debugEvent||debugCmds) Log.OutD("Main_OnControlEvent: End, Creature");
    	return;
    } // endif

    if (debugEvent||debugCmds) Log.OutD("Main_OnControlEvent: End, No switch statement executed");
    return;
} // end function